
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/**
 * IAlertsDataSource: This interface defines the methods that needs to be
 * accessed by Portlet classes to access Exchange Service Object
 */
package com.ibm.ccd.ui.alert.framework;

import com.ibm.ccd.ui.context.WPSContext;


public interface IAlertsDataSource {
    public String TOKENIZER = ",";
    public String STATUS_COMPLETED = "COMPLETED";
    public String STATUS_INPROGRESS = "IN_PROGRESS";

    public ITransactions getTransactions(WPSContext context);

    public void addTransaction(String transactionID, WPSContext context);

    public void addTransaction(String transactionID, String transactionDesc,
        String startTime, WPSContext context);

    public void addTransaction(String transactionID, String transactionDesc,
        String startTime, String endTime, String status, WPSContext context);

    public void saveAttachmentFile(ITransaction transactionObj,
        Object fileAttach, String extension);
}
