
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.alert.framework;

import java.util.Iterator;
import java.util.Set;


/**
 * ITransactions This defines the methods for accessing Transaction Objects
 * from the hashmap of Transactions class.
 *
 */
public interface ITransactions {
    /**
     * @param transactionID
     * @return
     */
    public ITransaction getTransaction(String transactionID);

    /**
     * @param transactionID
     */
    public void addTransaction(String transactionID);

    /**
     * @param transactionID
     * @param transactionDesc
     * @param startTime
     */
    public void addTransaction(String transactionID, String transactionDesc,
        String startTime);

    /**
     * @param transactionObject
     */
    public void addTransaction(ITransaction transactionObject);

    /**
     * @return
     */
    public Iterator getTransactionsKeyIterator();

    /**
     * @return
     */
    public String[] getInCompletedTransactionIDsArray();
    /**
     * @return
     */
    public int getTransactionsSize() ;
    /**
     * @return
     */
    public Iterator getTransactionsSortedKeyIterator();
}
