/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
package com.ibm.ccd.ui.cache;

import java.util.HashMap;
import java.util.Set;

/**
 * Created on Jun 13, 2006
 * 
 * This object creates a cache and stores a key-value map for 
 * objects , which fall under a particular classification.
 */
public class SimpleCacheService {
	
	private HashMap cacheMap;
	
	protected SimpleCacheService() {
		
		//Initialize the cacheMap
		this.cacheMap = new HashMap(10);
	}
	
	/*
	 * Method to retieve a cache value
	 */
	public Object getCacheValue(String key) {
		
		if(cacheMap == null)
			cacheMap = new HashMap(10);
		
		return cacheMap.containsKey(key) ? this.cacheMap.get(key) : null;
	}
	
	/*
	 * Method to store a cache value
	 */
	public void putCacheValue(String key, Object value) {
		
		if(this.cacheMap == null)
			cacheMap = new HashMap(10);
		
		this.cacheMap.put(key,value);
	}
	
	/*
	 * To reset a simple cache service
	 */
	public void resetCache(){
		
		if(this.cacheMap != null)
			this.cacheMap = new HashMap();
	}
	
	
	public Set getCacheKeys() {
		
		return this.cacheMap.keySet();
	}
	
	public void removeKey(String key) {
		
		this.cacheMap.remove(key);
	}
}
