
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Jan 24, 2005
 */
package com.ibm.ccd.ui.context;


/**
  * This interface contains the constants for WPCUser Object
  */
public interface IWPCUser {
    /**
     * Indicates the key for retriving WPC userID from <code>User</code> object
     */
    public static final String KEY_USER_ID = "uid";

    /**
     * Indicates the key for retriving WPC password from <code>User</code> object
     */
    public static final String KEY_PASSWORD = "userPassword";

    /**
    * Indicates the key for retriving WPC company name from <code>User</code> object
    */
    public static final String KEY_COMPANY = "company";

    /**
            * Indicates the key for retriving WPC supplier GLN ID from <code>User</code> object
            */
    public static final String KEY_SUPPLIER_GLN = "userGLN";

    /**
    * Indicates the key for retriving WPC supplier GLN ID from <code>User</code> object
    */
    public static final String KEY_WPC_USERNAME = "wpcUsername";

    /**
     * The user's preferred locale
     */
    public static final String KEY_PREFERRED_LANGUAGE = "preferredLanguage";

    /**
     * The restricted locale - this will ensure that the content retrieved from WPC is displayed in this locale, irrespective of the user's preferred locale.
     */
    public static final String KEY_RESTRICTED_LANGUAGE = "restrictedLanguage";
    String KEY_WPC_CATALOGUE_NAME = "WPC_CATALOGUE_NAME";
    String KEY_WPC_CATALOGUE_NODE = "WPC_CATALOGUE_NODE"; 
    String KEY_AVAILABEL_CATALOGS = "AVAILABEL_CATALOGS";
    
    String KEY_WPC_BROWSER_LOCALE = "KEY_WPC_BROWSER_LOCALE";
	
	public static final String WPC_AXIS_SESSIONID = "WPC_AXIS_SESSIONID";
}
