
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Dec 20, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.ibm.ccd.ui.dataobjects;

import javax.xml.soap.AttachmentPart;
import javax.xml.soap.SOAPException;


/**
* Stores the Attachment related information like the Object which needs to be transfered, and the mime type for that transfer.
*/
public class Attachment {
    /**
     * The standard set of mime types
     */
    public static String CSV_MIME_TYPE = "text/csv";
    public static String XML_MIME_TYPE = "text/xml";
    public static String GENERIC_IMAGE_MIME_TYPE = "images/*";

    /**
     * Object which represents the attachement which needs to be uploaded
     */
    private Object objectForUpload;

    /**
     * mime type of the object being uploaded
     */
    private String mimeType = CSV_MIME_TYPE;

    /**
     * name of the object being uploaded
     */
    private String uploadedFileName = null;

    public Attachment() {
    }

    public Attachment(AttachmentPart attachmentPart) {
        this.mimeType = attachmentPart.getContentType();

        try {
            this.objectForUpload = attachmentPart.getContent();
        } catch (SOAPException soe) {
            soe.printStackTrace();
        }
    }

    /**
     * @return
     */
    public Object getObjectForUpload() {
        return objectForUpload;
    }

    /**
     * @param string
     */
    public void setObjectForUpload(Object object) {
        objectForUpload = object;
    }

    /**
     * @return
     */
    public String getMimeType() {
        return mimeType;
    }

    /**
     * @param string
     */
    public void setMimeType(String string) {
        mimeType = string;
    }

    /**
     * @return
     */
    public String getUploadedFileName() {
        return uploadedFileName;
    }

    /**
     * @param string
     */
    public void setUploadedFileName(String string) {
        uploadedFileName = string;
    }
}
