
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.dataobjects;


/**
 * This class is a data container to store the information of a resource;
 * a item's resource which needs to be downloaded from WPC.
 * The resources being BINARY, IMAGE, THUMBNAIL_IMAGE
 * The  catalog, category, hierarchy, and primary key are required to locate the resource
 */
public class FileDownloadResource {
    private String catalogID;
    private String categoryID;
    private String hierarchyID;
    private String itemPrimaryKey;
    private String itemAttributeTypeName;
    private String attributeName;

    public FileDownloadResource(String catalogIDparam, String categoryIDparam,
        String hierarchyIDparam, String itemPrimaryKeyparam,
        String itemAttributeTypeNameparam, String attributeNameparam) {
        catalogID = catalogIDparam;
        categoryID = categoryIDparam;
        hierarchyID = hierarchyIDparam;
        itemPrimaryKey = itemPrimaryKeyparam;
        itemAttributeTypeName = itemAttributeTypeNameparam;
        attributeName = attributeNameparam;
    }

    /**
     * @return
     */
    public String getCatalogID() {
        return catalogID;
    }

    /**
     * @return
     */
    public String getCategoryID() {
        return categoryID;
    }

    /**
     * @return
     */
    public String getHierarchyID() {
        return hierarchyID;
    }

    /**
     * @return
     */
    public String getItemAttributeTypeName() {
        return itemAttributeTypeName;
    }

    /**
     * @return
     */
    public String getItemPrimaryKey() {
        return itemPrimaryKey;
    }

    /**
     * @param string
     */
    public void setCatalogID(String string) {
        catalogID = string;
    }

    /**
     * @param string
     */
    public void setCategoryID(String string) {
        categoryID = string;
    }

    /**
     * @param string
     */
    public void setHierarchyID(String string) {
        hierarchyID = string;
    }

    /**
     * @param string
     */
    public void setItemAttributeTypeName(String string) {
        itemAttributeTypeName = string;
    }

    /**
     * @param string
     */
    public void setItemPrimaryKey(String string) {
        itemPrimaryKey = string;
    }

    /**
     * @return
     */
    public String getAttributeName() {
        return attributeName;
    }

    /**
     * @param string
     */
    public void setAttributeName(String string) {
        attributeName = string;
    }
}
