
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.dataobjects;

import java.io.Serializable;


/**
 *  Represents the details of the file upload(ed) to the WPC
 */
public class FileUploadResource implements Serializable{
    // file mime type 	
    private String type;

    // file name
    private String name;

    // uploaded file doc. dir.
    private String directory;

    // uploaded server
    private String server;

    // userID 
    private String userID;

    //password
    private String password;

    public FileUploadResource() {
    }

    public FileUploadResource(String name) {
        this.name = name;
    }

    public FileUploadResource(String type, String name, String directory,
        String server, String userID, String password) {
        this.type = type;
        this.name = name;
        this.directory = directory;
        this.server = server;
        this.userID = userID;
        this.password = password;
    }

    public String getDirectory() {
        return directory;
    }

    public String getName() {
        return name;
    }

    public String getPassword() {
        return password;
    }

    public String getServer() {
        return server;
    }

    public String getUserID() {
        return userID;
    }

    public void setDirectory(String directory) {
        this.directory = directory;
    }

    public void setName(String name) {
        this.name = name;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public void setServer(String server) {
        this.server = server;
    }

    public void setUserID(String userID) {
        this.userID = userID;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String toString() {
        return "Type : " + type + ", Name:" + name + ", Dir:" + directory +
        ", Server:" + server + " ,UserID:" + userID + ", Password:" + password;
    }
}
