
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.dataobjects;

import org.apache.jetspeed.portlet.PortletRequest;
import org.w3c.dom.Node;

import com.ibm.ccd.ui.exception.MessageMap;


/*
 * Provides the Generic interface for the WPC dataitems representation
 */
public interface IDataBean {

    /**
     *  updates the properties of the bean from the portlet request
     *  @param portletRequest - The portletrequest containing the prperties to represent.
     *  @return MessageMap - null/empy in case of no errors
     *                                            - populated with the appropriate list in case of errors
     *
     */
    public MessageMap updateProperties(PortletRequest portletRequest);

    /**
     * Encodes the object properties to XML
     */
    public String toXML();

    /**
     * Decodes the XML string and sets the element values as the bean properties
     */
    public void fromXML(String xml);

    /**
     * Decodes the XML Element and sets the element values as the bean properties
     */
    public void fromXML(Node domNode);
}
