
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.dataobjects;


/**
 *  Represents the tree node used in the catlog
 *
 */
public class Node {
    private String id;
    private String displayName;
    private String type;
    private CategoryHierarchy categoryHierarchy;

    public Node() {
    }

    public Node(String id, String displayName, String type) {
        this.id = id;
        this.displayName = displayName;
        this.type = type;
    }

    public String getDisplayName() {
        return displayName;
    }

    public String getId() {
        return id;
    }

    public String getType() {
        return type;
    }

    public void setDisplayName(String displayName) {
        this.displayName = displayName;
    }

    public void setId(String id) {
        this.id = id;
    }

    public void setType(String type) {
        this.type = type;
    }

    /**
     * @return
     */
    public CategoryHierarchy getCategoryHierarchy() {
        return categoryHierarchy;
    }

    /**
     * @param hierarchy
     */
    public void setCategoryHierarchy(CategoryHierarchy hierarchy) {
        categoryHierarchy = hierarchy;
    }

    public void printMe() {
        System.out.println(" Node Details :: ID=" + getId() + " Disp.Name=" +
            getDisplayName() + " Type=" + getType());
    }
}
