
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.dataobjects.attributes;


/*
 * Represents the NumberEnumeration as an array of real types(float/double)
 */
public class NumberEnumAttribute extends NumberAttribute {
    // numer enum.
    protected double[] enumDb;

    public NumberEnumAttribute(String name, double[] enumParam, boolean editable,
        int minimumOccurrence, int maximumOccurrence, String displayName) {
        super(name, editable, minimumOccurrence, maximumOccurrence, displayName);
        this.enumDb = enumParam;
    }

    public NumberEnumAttribute(String name, double[] enumParam, String defaultValue,
        boolean editable, int minimumOccurrence, int maximumOccurrence,
        String displayName) {
        super(name, defaultValue, editable, minimumOccurrence,
            maximumOccurrence, displayName);

        this.enumDb = enumParam;
    }

    public NumberEnumAttribute(String name, double[] enumParam, String defaultValue,
        boolean editable, int minimumLength, int maximumLength,
        int minimumOccurrence, int maximumOccurrence, String displayName) {
        super(name, defaultValue, editable, minimumLength, maximumLength,
            minimumOccurrence, maximumOccurrence, displayName);

        this.enumDb = enumParam;
    }

    public int getType() {
        return AttributeTypes.NUMBER_ENUMERATION;
    }
/*
    private void checkValue(double value) {
        if ((enum == null) || (enum.length == 0)) {
            throw new IllegalArgumentException("Enum is Empty/Not defined for " +
                getName());
        }

        for (int i = 0; i < enum.length; ++i) {
            if (value == enum[i]) {
                return;
            }
        }

        throw new IllegalArgumentException("Enum is Not defined for value " +
            value + "in " + getName());
    }
*/
    public void setValue(String value) {
        //		checkValue(value);
        super.setValue(value);
    }

    public void setValue(int occurrence, String value) {
        //		checkValue(value);
        super.setValue(occurrence, value);
    }

    public void setValues(String[] values) {
        if ((values == null) || (values.length == 0)) {
            return;
        }

        //		for(int i=0; i < values.length; ++i)
        //		{
        //			checkValue(values[i]);
        //		}
        super.setValues(values);
    }

    public double[] getEnumDb() {
        return enumDb;
    }

    public void setEnumDb(double[] enumParam) {
        this.enumDb = enumParam;
    }

    public void printMe() {
        super.printMe();

        if (enumDb != null) {
            for (int i = 0; i < enumDb.length; ++i) {
                if (i == 0) {
                    System.out.print("\t\tEnum : ");
                }

                System.out.print(enumDb[i] + " ");
            }
        }

        System.out.println(" Def.Value :" + getDefaultValue());
    }
}
