
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.dataobjects.attributes;


/*
 * Represents the Sequence attribute
 * The attribute is rendered as readonly and the values are being generated from the server
 */
public class SequenceAttribute extends StringAttribute {
    public SequenceAttribute(String name, int minimumOccurrence,
        int maximumOccurrence, String displayName) {
        super(name, false, minimumOccurrence, maximumOccurrence, displayName);
    }

    public SequenceAttribute(String name, String value, String displayName) {
        super(name, false, 1, 1, displayName);
        setValue(value);
    }

    public int getType() {
        return AttributeTypes.SEQUENCE;
    }
}
