
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.dataobjects.attributes;

import com.ibm.ccd.ui.dataobjects.FileUploadResource;


/*
 * Represents the  thumb nail Image  (Uploaded)
 * limitation : The value is represented as binary file upload and doesn't support format checking.
 */
public class ThumbnailImageAttribute extends ImageAttribute {
    public ThumbnailImageAttribute(String name, boolean editable,
        int minimumOccurrence, int maximumOccurrence, String displayName) {
        super(name, editable, minimumOccurrence, maximumOccurrence, displayName);
    }

    public ThumbnailImageAttribute(String name,
        FileUploadResource defaultValue, boolean editable,
        int minimumOccurrence, int maximumOccurrence, String displayName) {
        super(name, defaultValue, editable, minimumOccurrence,
            maximumOccurrence, displayName);
    }

    public ThumbnailImageAttribute(String name,
        FileUploadResource defaultValue, boolean editable, int minimumLength,
        int maximumLength, int minimumOccurrence, int maximumOccurrence,
        String displayName) {
        super(name, defaultValue, editable, minimumLength, maximumLength,
            minimumOccurrence, maximumOccurrence, displayName);
    }

    public int getType() {
        return AttributeTypes.THUMB_NAIL_IMAGE;
    }
}
