
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.dataobjects.attributes;

import java.net.URL;


/*
 * Represents the  Thumbnail Image URL (Uploaded/referred)
 * limitation : The value is represented as url and doesn't support formats with the xtns.
 */
public class ThumbnailImageURLAttribute extends ImageURLAttribute {
    /**
     * @param name
     * @param editable
     * @param minimumOccurrence
     * @param maximumOccurrence
     * @param displayName
     */
    public ThumbnailImageURLAttribute(String name, boolean editable,
        int minimumOccurrence, int maximumOccurrence, String displayName) {
        super(name, editable, minimumOccurrence, maximumOccurrence, displayName);

        // TODO Auto-generated constructor stub
    }

    /**
     * @param name
     * @param defaultValue
     * @param editable
     * @param minimumLength
     * @param maximumLength
     * @param minimumOccurrence
     * @param maximumOccurrence
     * @param displayName
     */
    public ThumbnailImageURLAttribute(String name, String defaultValue,
        boolean editable, int minimumLength, int maximumLength,
        int minimumOccurrence, int maximumOccurrence, String displayName) {
        super(name, defaultValue, editable, minimumLength, maximumLength,
            minimumOccurrence, maximumOccurrence, displayName);

        // TODO Auto-generated constructor stub
    }

    /**
     * @param name
     * @param defaultValue
     * @param editable
     * @param minimumOccurrence
     * @param maximumOccurrence
     * @param displayName
     */
    public ThumbnailImageURLAttribute(String name, String defaultValue,
        boolean editable, int minimumOccurrence, int maximumOccurrence,
        String displayName) {
        super(name, defaultValue, editable, minimumOccurrence,
            maximumOccurrence, displayName);

        // TODO Auto-generated constructor stub
    }

    public int getType() {
        return AttributeTypes.THUMB_NAIL_IMAGE_URL;
    }
}
