
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.dataobjects.items;

import java.text.ParseException;
import java.util.HashMap;

import org.apache.jetspeed.portlet.PortletRequest;

import com.ibm.ccd.ui.dataobjects.IDataBean;
import com.ibm.ccd.ui.dataobjects.attributes.Attribute;
import com.ibm.ccd.ui.dataobjects.workflow.CollaborationArea;
import com.ibm.ccd.ui.exception.MessageMap;


/**
 *  Represents the WPC CatalogItem(Spec).
 */
public interface ICatalogItem extends IDataBean {
    // Key for the parenet categoryID
    public static final String PARENT_CATEGORY_ID = "PARENT_ID";

    // Key for the CatalogID
    public static final String CATALOG_ID = "CATALOG_ID";

    // Key for the itemID(PrimaryKey)
    public static final String ITEM_ID = "ITEM_ID";

    public CollaborationArea getCollaborationArea();

    public String getParentCategoryID();

    public String getCatalogID();

    public String getCatalogVersion();

    public String getItemID();

    public void setCollaborationArea(CollaborationArea collabArea);

    public void setParentCategoryID(String parCtgyID);

    public void setCatalogID(String catalogID);

    public void setCatalogVersion(String ctgVersion);

    public void setItemID(String itemID);

    public Attribute[] getAttributes();

    public Attribute getAttribute(String name);

    public HashMap getAttributeMap();

    public String getCreateView();

    public String getCreateSuccessView();

    public String getCreateFailureView();

    public void setCreateView(String createJSP);

    public void setCreateSuccessView(String createSuccessJSP);

    public void setCreateFailureView(String createFailureJSP);

    public String getUpdateView();

    public String getUpdateSuccessView();

    public String getUpdateFailureView();

    public void setUpdateView(String updateJSP);

    public void setUpdateSuccessView(String updateSuccessJSP);

    public void setUpdateFailureView(String updateFailureJSP);

    public String getPrintView();

    public String getListView();

    public void setPrintView(String printJSP);

    public void setListView(String listJSP);

    public void printMe();

    public MessageMap setProperty(PortletRequest request, String attributeName)
            throws ParseException;
	public String getPrimaryKeyValue();
    
    public Attribute getPrimaryKeyAttr();
    
    public Attribute getPrimaryKeyAttr(Attribute[] attrArry);

    public HashMap getFlatAttributeMap();
    
    public HashMap getDownloadAttributeMap();

    public boolean isBworkflowItem();

    public void setBworkflowItem(boolean bworkflowItem);

    public String getAssociateWFCatalogID() ;

    public void setAssociateWFCatalogID(String associateWFCatalogID);
}
