/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

package com.ibm.ccd.ui.dataobjects.view;

import java.io.IOException;
import java.io.OutputStream;
import java.io.Serializable;
import java.util.Set;
import java.util.TreeSet;

/**
 * TabView contains tabName and Attributecollection view defintion
 * 
 * @author Senthil G Kumar
 *
 */
public class TabView implements Serializable {

	private String tabName;

	private AttributeCollectionView[] collection;

	private TreeSet entrySet = new TreeSet();
	
	public TabView() {
		
	}
	/**
	 * 
	 */
	public TabView(String tabName, AttributeCollectionView[] collection) {
		this.tabName = tabName;

		for (int i = 0; i < collection.length; i++) {
			entrySet.addAll(getKeySet(collection[i].getAttributeNames()));
		}

		String[] str = new String[entrySet.size()];
		collection[0].setAttributeNames((String[]) entrySet.toArray(str));

		AttributeCollectionView[] union_collection =
			new AttributeCollectionView[1];
		union_collection[0] = collection[0];

		this.collection = union_collection;
	}

	private Set getKeySet(String[] names) {
		TreeSet set = new TreeSet();
		//removes duplicate attribute names in the array
		for (int i = 0; i < names.length; i++)
			set.add(names[i]);
		return set;
	}

	/**
	 * @return collection
	 */
	public AttributeCollectionView[] getCollection() {
		return collection;
	}

	/**
	 * @return tabName
	 */
	public String getTabName() {
		return tabName;
	}

	/**
	 * @param views
	 */
	public void setCollection(AttributeCollectionView[] views) {
		collection = views;
	}

	/**
	 * @param tabName
	 */
	public void setTabName(String tabName) {
		this.tabName = tabName;
	}
	
	public String toString() {
		return getTabName();
	}

	public void printME() {
		System.out.println("Tab Name : " + getTabName());
		System.out.print("Collection List : ");
		for (int i = 0; i < collection.length; i++) {
			System.out.print(collection[i] + "  ");
			collection[i].printME();
			System.out.println();
		}
	}

	public void printME(OutputStream out,int tabIndex) {

		StringBuffer buffer = new StringBuffer();
		buffer.append("\n<div id=\"pane"+(tabIndex+1)+"\" class=\'<%=actTab["+tabIndex+"]%>\' >")
			.append("\n<table>");
		try {
			out.write(buffer.toString().getBytes("UTF-8"));
		} catch (IOException e) {
			e.printStackTrace();
		}
		for (int i = 0; i < collection.length; i++) {
			collection[i].printME(out);
		}
		buffer.delete(0,buffer.length());
		buffer.append("\n</table>")
		.append("\n</div>\n");

		try {
			out.write(buffer.toString().getBytes("UTF-8"));
		} catch (IOException e) {
			e.printStackTrace();
		}
		
	}

	public void printME(OutputStream out, int tabIndex, boolean flag) {
		StringBuffer buffer = new StringBuffer();
		buffer
			.append(
				"\n<div id=\"pane"
					+ (tabIndex + 1)
					+ "\" class=\'<%=actTab["
					+ tabIndex
					+ "]%>\' >")
			.append("\n<table>");
		try {
			out.write(buffer.toString().getBytes("UTF-8"));
		} catch (IOException e) {
			e.printStackTrace();
		}
		for (int i = 0; i < collection.length; i++) {
			collection[i].printME(out);
		}
		buffer.delete(0, buffer.length());
		
		buffer.append("<wpcui:categoryspecificAttribute />");		
		buffer.append("\n</table>").append("\n</div>\n");

		try {
			out.write(buffer.toString().getBytes("UTF-8"));
		} catch (IOException e) {
			e.printStackTrace();
		}

	}
}
