/*
 * Created on May 26, 2006
 */
package com.ibm.ccd.ui.dataobjects.workflow;

/**
 * holds name and item count of a category 
 */
public class CategoryInfo {
	public static final String UNASSIGNED = "UNASSIGNED";
	private String categoryPath = "???";
	private int count = 0;
	private String categoryLabelPath = "";
	
	public CategoryInfo(String name, String label, int count) {
		super();
		this.categoryPath = name;
		this.count = count;
		this.categoryLabelPath = label;
	}

	/**
	 * @return Returns the count.
	 */
	public int getCount() {
		return count;
	}
	/**
	 * @param count The count to set.
	 */
	public void setCount(int count) {
		this.count = count;
	}
	/**
	 * @return Returns the name.
	 */
	public String getName() {
	    if (categoryLabelPath != null) {
	        int lastIndex = categoryLabelPath.lastIndexOf("/");

	        if (lastIndex != -1) {
	            return categoryLabelPath.substring(lastIndex+1);
            }
	        return categoryLabelPath;
        }
		return categoryLabelPath;
	}


	public void incCount() {
		count++;
	}
    /**
     * @return Returns the categoryLabelPath.
     */
    public String getCategoryLabelPath() {
        return categoryLabelPath;
    }
    /**
     * @param categoryLabelPath The categoryLabelPath to set.
     */
    public void setCategoryLabelPath(String categoryLabelPath) {
        this.categoryLabelPath = categoryLabelPath;
    }
    /**
     * @return Returns the categoryPath.
     */
    public String getCategoryPath() {
        return categoryPath;
    }
    /**
     * @param categoryPath The categoryPath to set.
     */
    public void setCategoryPath(String categoryPath) {
        this.categoryPath = categoryPath;
    }
    /**
     * Returns category Id or last digit of category path
     * @param categoryPath The categoryPath to set.
     */
    public String getCategoryId() {
        if (categoryPath != null) {
	        int lastIndex = categoryPath.lastIndexOf("/");
	        if (lastIndex != -1) {
	            return categoryPath.substring(lastIndex+1);
            }
	        return categoryPath;
        }
		return categoryPath;

    }
}
