
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.dataobjects.workflow;

import java.util.Map;

import com.ibm.ccd.ui.context.WPSContext;
import com.ibm.ccd.ui.exception.MessageMap;
import com.ibm.ccd.ui.mediator.WPCMediatorException;


/**
 * @author administrator
 *
 * Interface for invoking the methods from Business portlet to mediator
 */
public interface IWorkflowHelper {
    /**
     * For fetching the workflow elements.
     * @param workflowObj
     * @param messageMap
     * @param context
     */
    public void process(WorkFlowTO workflowObj, MessageMap messageMap,
        WPSContext context);

    /**
     * For initiating the process on items
     * @param workflowObj
     * @param messageMap
     * @param context
     * @throws WPCMediatorException
     */
    public void processAction(WorkFlowTO workflowObj, MessageMap messageMap,
        WPSContext context) throws WPCMediatorException;

    /**
     * For getting roles for user
     * @param workflowObj
     * @param messageMap
     * @param context
     * @throws WPCMediatorException
     */
    public void getUserRoles(WorkFlowTO workflowObj, MessageMap messageMap,
        WPSContext context) throws WPCMediatorException;

    /**
     * For getting attributes
     * @param context
     * @param catalogId
     * @param messageMap
     * @return
     */
    public Map getAttributes(WPSContext context, String catalogId,
        MessageMap messageMap);
}
