
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.exception;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;


public class MessageList implements Serializable {
    protected String type;
    protected List messages;

    public MessageList(String type) {
        this.type = type;
        messages = new ArrayList();
    }

    public void add(Message message) {
        if (message != null) {
            messages.add(message);
        }
    }

    public void clear() {
        messages.clear();
    }

    public boolean empty() {
        return messages.size() == 0;
    }

    public Iterator get() {
        return messages.iterator();
    }

    public int size() {
        return messages.size();
    }
}
