
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.mediator;


/**
 *  provides the tagnames bound to the xmls for WPC soapcalls
 */
public interface ISoapMessageKeys {
    
	// soap Namespace
    public static final String REQ_LOOKUP_TABLE_SEARCH = "LOOKUP_SEARCH";
    public static final String REQ_LOOKUP_TABLE_SPEC = "LOOKUP_SKELETON";
	public static final String REQ_SEARCH_ITEMSKELETON = "SEARCH_ITEMSKELETON";
	public static final String REQ_SEARCH_RESULT_ITEMSKELETON = "SEARCH_RESULT_ITEMSKELETON";
    public static final String WPC_NS_URI = "http://ibm.com/wpc/";
    public static final String WPC_NS_URI_REF = "wpc";
    public static final String WPC_COMM_VERSION = "5.3";

    // RPC styles
    public static String OPERATION_NAMESPACE = "wpc";
    public static String RPC_OPERARION = "invoke";

    // soap commands
    public static final String REQ_GET_CATALOGS = "GET_CATALOGS";
    public static final String REQ_CATALOG_CHILDREN = "QUERY_CATALOG_CHILDREN";
    public static final String REQ_CATALOG_SPEC = "ITEMSKELETON";
    public static final String REQ_ITEM_DETAILS = "ITEMDETAIL";
	public static final String REQ_CATALOG_VIEW_LIST = "GET_CATALOG_VIEW_LIST";
	public static final String REQ_CATALOG_VIEW = "GET_CATALOG_VIEW";
    public static final String REQ_ITEM_ADD = "ADD";
    public static final String REQ_ITEM_MODIFY = "MODIFY";
    public static final String REQ_ITEM_DELETE = "DELETE";
    public static final String REQ_ITEM_CLONE = "CLONEITEM";
    public static final String REQ_ITEM_SEARCH = "SEARCH";
    public static final String REQ_QUERY_TRANSACTION = "QUERY_TRANSACTION";
    public static final String REQ_FILE_UPLOAD = "UPLOAD_FILE";
    public static final String REQ_FILE_IMPORT = "UPLOAD";
    public static final String REQ_FILE_QUERY_TRANSACTION_STATUS = "QUERY_TRANSACTION_STATUS";
    public static final String REQ_FILE_QUERY_TRANSACTION_DETAILS = "QUERY_TRANSACTION_DETAILS";
    public static final String REQ_FILE_GET_IMAGE_OBJECT = "GET_RESOURCE";
    public static final String REQ_ITEMS_FILE_DOWNLOAD = "DOWNLOAD";
    public static final String REQ_USER_ROLES = "GET_ROLES_FOR_USER";
    public static final String REQ_GET_WORKFLOWS = "GET_ALL_COLLAB_AREA";
    public static final String REQ_GET_STEPS = "GET_COLLAB_AREA_DETAILS";
    public static final String REQ_GET_ITEMS = "GET_ITEMS_IN_COLLAB_AREA_STEP";
    public static final String REQ_COLLAB_AREA_ACTION = "COLLAB_AREA_ACTION";
    public static final String REQ_RESERVE_ITEMS = "RESERVE_ITEMS";
    public static final String REQ_UNRESERVE_ITEMS = "UNRESERVE_ITEMS";
    public static final String REQ_PUSHTO_NEXTSTEP_ITEMS = "PUSHTO_NEXTSTEP_ITEMS";

    //	soap message element names	
    public static final String ENVELOPE = "envelope";
    public static final String HEADER = "wpcHeader";
    public static final String COMPANY_NAME = "companyName";
    public static final String USER_ID = "wpsUserID";
    public static final String USERID = "userID";
    public static final String USER_PREFERRED_LOCALE = "localeForDisplay";
    public static final String USER_RESTRICTED_LOCALE = "localeRestriction";
    public static final String WPCUSERNAME = "wpcUserID";
    public static final String PASSWORD = "password";
    public static final String MESSAGE_IDENTIFIER = "messageIdentifier";
    public static final String TIME_STAMP = "timestamp";
    public static final String SUPPLIER_ID = "supplierId";
    public static final String BODY = "wpcBody";
    public static final String COMMAND = "wpcCommand";
    public static final String TYPE = "type";
    public static final String MODE = "mode";
    public static final String RESPONSE = "wpcResponse";
    public static final String ENTITY_IDENTIFIER = "wpcEntityIdentifier";
    public static final String TRANSACTION_RESPONSE = "getTransactionIDResponse";
    public static final String TRANSACTION = "wpcTransaction";
    public static final String TRANSACTION_ID = "transactionID";
    public static final String NOTIFICATION = "wpcNotification";
    public static final String NOTIFICATION_INFO = "notificationInfo";
    public static final String NOTIFICATION_CODE = "notificationCode";
    public static final String NOTIFICATION_MESSAGE = "notificationMessage";
    public static final String VERSION = "version";

    // communction styles
    public static final String SYNCHRONOUS = "SYNC";
    public static final String ASYNCHRONOUS = "ASYNC";

    // result states
    public static final String PROCESSING = "PROCESSING";
    public static final String SUCCESS = "SUCCESS";
    public static final String FAILURE = "FAILURE";

    //	catalog related
    public static final String CATALOGS = "wpcCatalogs";
    public static final String CATALOG = "wpcCatalog";
    public static final String CATEGORY_HIERARCHIES = "wpcHierarchies";
    public static final String CATALOG_NAME = "wpcCatalogName";
    public static final String CATALOG_SPEC = "wpcTradeItemSpec";
    public static final String PARENT_CATEGORY = "wpcParentCategory";
    public static final String CATALOG_CHILDREN = "wpcChildren";
    public static final String CATALOG_CHILD = "wpcChild";
    public static final String CATALOG_CHILD_LENGTH = "wpcResultCount";
    public static final String CATALOG_PARENT_ID = "wpcParentID";
    public static final String CATEGORY_HIERARCHY = "wpcHierarchyName";
    public static final String CATALOG_PARENT_PATH = "wpcParentPath";
    public static final String CATALOG_CHILD_PATH = "wpcChildPath";
    public static final String CATALOG_CHILD_DISP_NAME = "wpcChildDisplayName";
    public static final String CATALOG_CHILD_TYPE = "wpcChildType";
    public static final String CATALOG_QUERY_CHILDREN = "wpcQueryCatalogChildrenResult";
	public static final String CATALOG_VIEW_NAME = "wpcCatalogViewName";
	public static final String WORKFLOWNAME = "wpcWorkflowName";
	public static final String WORKFLOW_STEP_NAME = "wpcWorkflowStepName";

    // item related
    public static final String TRADE_ITEM = "wpcTradeItem";
    public static final String TRADE_ITEM_PK = "wpcTradeItemPK";
    public static final String ATTRIBUTE_LIST = "attribute-list";
    public static final String ATTRIB_CATEGORY_SPECIFIC = "isCategorySpecific";
    public static final String ATTRIB_PRIMARY_KEY = "isPrimaryKey";
    public static final String ATTRIBUTE = "attribute";
    public static final String GROUP_ATTTRIBUTE = "groupvalue";
    public static final String SUB_ATTRIBUTE = "sub-attribute";
    public static final String ATTRIB_NAME = "name";
    public static final String ATTRIB_VALUE = "value";
    public static final String ATTRIB_VALUES = "values";
    public static final String ATTRIB_DEF_VALUE = "def_val";
    public static final String ATTRIB_TYPE = "type";
    public static final String OCCURRENCE = "occurrence";
    public static final String MIN_OCCUREENCE = "min_occurrence";
    public static final String MAX_OCCUREENCE = "max_occurrence";
    public static final String EDITABLE = "editable";
    public static final String MIN_LENGTH = "min_length";
    public static final String MAX_LENGTH = "max_length";
    public static final String DISPLAY_NAME = "displayName";
    public static final String IS_LOCALIZED = "isLocalized";
    public static final String LOCALE_NAME = "locale";
    public static final String BEGIN = "begin";
    public static final String END = "end";
    public static final String ENUM = "enum";
    public static final String DEF = "def";
    public static final String ID = "ID";
    public static final String ENTRIES = "entries";
    public static final String ENTRY = "entry";
    public static final String KEY = "key";
    public static final String VALUE = "value";
    public static final String RELATION = "relation";
    public static final String RELATION_TO = "to";
    public static final String FILE = "file";
    public static final String NAME = "name";
    public static final String DIRECTORY = "dir";
    public static final String SERVERNAME = "server-name";
	public static final String LOOKUP_TABLE_NAME = "lookupTableName";
	public static final String PERIODVALUE= "periodvalue";
	public static final String ATTRIB_PERIOD_STARTDATE = "startdate";
	public static final String ATTRIB_PERIOD_ENDDATE = "enddate";

    // search related 
    public static final String SEARCH_CATALOG_NAME = WPC_NS_URI_REF + ":" +
        "wpcCatalogName";
    public static final String SEARCH_CRITERIA_NAME = WPC_NS_URI_REF + ":" +
        "wpcSearchCriteria";
    public static final String SEARCH_RESULTS_NAME = "wpc:wpcSearchResults";
    public static final String SEARCH_ROW_COUNT_NAME = "wpc:wpcTradeEntryCount";
    public static final String SEARCH_CSV_RESULTS_NAME = "wpc:wpcCsvResults";
    public static final String SEARCH_RESULT_COUNT_NAME = "wpc:wpcResultCount";
	public static final String SEARCH_START_INDEX="wpc:wpcStartIndex";
	public static final String SEARCH_END_INDEX="wpc:wpcEndIndex";
    // transactions related 
    public static final String TRANSACTION_RESPONSE_STRING = "wpcTransactionIDs>";
    public static final String TRANSACTION_RESPONSE_RESULT_STRING = "wpcTransactionResult";

    // file upload related
    public static final String FILE_DOCSTORE_PATH_STRING = "wpcFileDocStorePath";
    public static final String DATA_CONTAINER_STRING = "wpcDataContainer";
    public static final String ATTACHMENTS_DATA_CONTAINER_STRING = "wpcAttachmentsDataContainer";
    public static final String ATTACHMENTS_FILE_NAME_STRING = "FileName";

    // file download related
    public static final String ATTRIBUTELIST = "wpcAttributeList";

    // workflow related
    public static final String WORKFLOW_ROLELIST = "wpc:wpcRoleList";
    public static final String WORKFLOW_ROLENAME = "wpcRole";
    public static final String WORKFLOW_COLL_LIST = "wpcCollabAreaList";
    public static final String WORKFLOW_COLL_AREA = "wpcCollabArea";
    public static final String WORKFLOW_NAME = "workflow";
    public static final String WORKFLOW_STEP = "step";
    public static final String WORKFLOW_STEPNAME = "stepName";
    public static final String WORKFLOW_STEP_ITEMCOUNT = "itemCount";
    public static final String WORKFLOW_STEPMAP = "stepMap";
    public static final String WORKFLOW_STEPMAP_NEXT = "NextStep";
    public static final String WORKFLOW_STEP_EXITVALUE = "exitValue";
    public static final String WORKFLOW_STEP_EXITVALUES = "exitValues";
    public static final String WORKFLOW_STEP_RESERVETOEDIT = "reserveToEdit";
    public static final String WORKFLOW_CHECKOUTENTRIES = "CheckedOutEntries";
    public static final String WORKFLOW_CHECKOUTENTRY = "checkedOutEntry";
    public static final String WORKFLOW_TRADEITEM = "wpcTradeItem";
    public static final String WORKFLOW_RESERVEDBY = "wpcReservedBy";
    public static final String WORKFLOW_USERLIST = "wpcUserList";
    public static final String WORKFLOW_USER = "wpcUser";
    public static final String WORKFLOW_STARTDATE = "startDate";
    public static final String WORKFLOW_ENDDATE = "endDate";
    public static final String WORKFLOW_COLLAB_CONTAINER = "container";    

    // workflow	
    public static final String WORKFLOW_SORTBYCOL = "sortByColumn";
    public static final String WORKFLOW_SORTBY = "sortBy";
    public static final String WORKFLOW_ASCENDING = "Ascending";
    public static final String WORKFLOW_LISTITEMS = "listItems";
    public static final String WORKFLOW_STARTINDEX = "startIndex";
    public static final String WORKFLOW_ENDINDEX = "endIndex";
    public static final String WORKFLOW_STEPPATH = "stepPath";
    public static final String WORKFLOW_COLLABAREA_ACTION = "wpcCollaborationAreaAction";
    public static final String WORKFLOW_DELWHEN_EMPTY = "Deletewhenempty";
    public static final String WORKFLOW_ACTION = "action";
    public static final String WORKFLOW_ACTION_RESERVE = "Reserve";
    public static final String WORKFLOW_ACTION_UNRESERVE = "UnReserve";
    public static final String WORKFLOW_ACTION_MOVE = "Move";
    public static final String WORKFLOW_SPECNAME = "SpecName";
    public static final String WORKFLOW_CATEGORY_PKLIST = "categorypkList";
}
