
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.mediator;

import java.util.ArrayList;


/**
 * encapuslates the WPC soap  service response and provides the
 * data XML and attachments.
 */
public class SoapResponse {
    
	// WPC Axis SessionID
	private String wpcAxisSessionID;
    
    // body xml 
    private String dataXML;

    // mime  attchments
    private ArrayList attachmentParts;

    public SoapResponse() {
    }

    public SoapResponse(String dataXML, ArrayList attachmentParts) {
        this.dataXML = dataXML;
        this.attachmentParts = attachmentParts;
    }

	public SoapResponse(String dataXML, ArrayList attachmentParts, String sessionID) {
		this.dataXML = dataXML;
		this.attachmentParts = attachmentParts;
		this.wpcAxisSessionID = sessionID;
	}

    public ArrayList getAttachmentParts() {
        return attachmentParts;
    }

    public String getDataXML() {
        return dataXML;
    }

    public void setAttachmentParts(ArrayList attachmentParts) {
        this.attachmentParts = attachmentParts;
    }

    public void setDataXML(String dataXML) {
        this.dataXML = dataXML;
    }
    
	public String getWpcAxisSessionID() {
		return wpcAxisSessionID;
	}

	public void setWpcAxisSessionID(String sessionID) {
		wpcAxisSessionID = sessionID;
	}

}
