
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.mediator;

import java.util.HashMap;
import java.util.Iterator;


/**
 * Represents the WPC Notification element and provides the support to
 * set/get the type, message , details as a hashmap
 *
 */
public class WPCNotificationBean {
    // notification code	
    private int code;

    // notification type
    private String type;

    // notification message
    private String message;

    // additional notification details , name being the element value as the element value
    private HashMap details;

    WPCNotificationBean() {
        details = new HashMap();
    }

    WPCNotificationBean(int code, String type, String message) {
        this.code = code;
        this.type = type;
        this.message = message;

        details = new HashMap();
    }

    void addDetail(String key, String detail) {
        details.put(key, detail);
    }

    public boolean hasDetails() {
        return (details.size() > 0) ? true : false;
    }

    // synonymous to code..
    public int getStatus() {
        return code;
    }

    public int getCode() {
        return code;
    }

    public HashMap getDetails() {
        return details;
    }

    public String getMessage() {
        return message;
    }

    public void setCode(int code) {
        this.code = code;
    }

    public void setDetails(HashMap details) {
        this.details = details;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getTrasactionID() {
        return (String) details.get(ISoapMessageKeys.TRANSACTION_ID);
    }

    public void printMe() {
        System.out.println("*********WPC NOTIFICATION INFO ********");
        System.out.println("TYPE : " + type);
        System.out.println("CODE : " + code);
        System.out.println("MESSAGE : " + message);

        System.out.println("DETAILS :");

        Iterator keysIterator = details.keySet().iterator();

        while (keysIterator.hasNext()) {
            String key = (String) keysIterator.next();
            System.out.println("\t" + key + " : " + details.get(key));
        }
    }
}
