
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Dec 3, 2004
 *
 */
package com.ibm.ccd.ui.portlets;

import java.util.HashMap;

import org.apache.jetspeed.portlet.PortletMessage;


/**
 *
 * GenericPortletMessage extends PortletMessage Interface which
 * can be used to send PortletMessage between portlets within Portal.
 *
 * @see java.util.HashMap
 * @see org.apache.jetspeed.portlet.PortletMessage
 */
public class GenericPortletMessage extends HashMap implements PortletMessage {
    private String message;

    /**
     * Constructs a GenericPortletMessage with message null
     *
     */
    public GenericPortletMessage() {
        message = null;
    }

    /**
     * Constructs a GenericPortletMessage with message string
     *
     * @param message portletMessage
     */
    public GenericPortletMessage(String message) {
        this.message = message;
    }

    /**
     * sets message to this PortletMessage instance
     *
     * @param message
     */
    public void setMessage(String message) {
        this.message = message;
    }

    /**
     * gets the message from this PortletMessage instance
     *
     * @return message
     */
    public String getMessage() {
        return message;
    }
}
