/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
package com.ibm.ccd.ui.portlets.admin;

import java.io.IOException;
import java.util.Enumeration;

import org.apache.jetspeed.portlet.*;
import org.apache.jetspeed.portlet.event.*;

import com.ibm.ccd.ui.cache.CacheException;
import com.ibm.ccd.ui.cache.CacheManager;
import com.ibm.ccd.ui.cache.CacheNotEnabledException;
import com.ibm.ccd.ui.exception.MessageMap;
import com.ibm.ccd.ui.portlets.BasePortlet;

public class AdminPortlet extends BasePortlet implements ActionListener {

    public static final String VIEW_JSP = "/jsps/html/admin/AdminPortletView.jsp";     // JSP file name to be rendered on the view mode

	public void init(PortletConfig portletConfig) throws UnavailableException {
		super.init(portletConfig);
	}

	public void doView(PortletRequest request, PortletResponse response) throws PortletException, IOException {
		
        // Invoke the JSP to render
		CacheManager cManager = null;
		try {
			cManager = CacheManager.getInstance();
		} catch(CacheNotEnabledException e) {
		}
		
		MessageMap mMap = getMessageMap(request);
		if(cManager != null){
			if( cManager.getCacheGroups().size() == 0){
				mMap.addInfoMessage("MESSAGE_CODE_620");
			} else {
				mMap.addInfoMessage("MESSAGE_CODE_619");
			}
		} else 
			mMap.addInfoMessage("MESSAGE_CODE_621");
			
	    getPortletConfig().getContext().include(VIEW_JSP, request, response);
	}

	public void actionPerformed(ActionEvent event) throws PortletException {

		// ActionEvent handler
		String actionString = event.getActionString();
		PortletRequest request = event.getRequest();
		// Add action string handler here
		
		Enumeration eNum = request.getParameterNames();
		
		while(eNum.hasMoreElements()) {
			
			String parameterName = (String) eNum.nextElement();
			System.out.println("param Name :: " + parameterName);
			if(parameterName.startsWith("CHKID|")){
				
				int keyIndex = parameterName.indexOf("|") + 1;
				String key = parameterName.substring(keyIndex,parameterName.length());
				System.out.println("key :: " + key);
				String groupId = key.substring(0,key.indexOf("|"));
				String cacheKey = key.substring(key.indexOf("|") + 1,key.length());
				System.out.println("Group Id :: " + groupId);
				System.out.println("Cache Key :: " + cacheKey);
				
				
				try{
					CacheManager cManager = CacheManager.getInstance();
					cManager.resetCacheValue(groupId,cacheKey);
				} catch(CacheNotEnabledException e){
					e.printStackTrace();
				}
			}
		}
	}
    
   protected void setBusinessFunction(PortletRequest portletRequest) {
        PortletSession session = portletRequest.getPortletSession();
    }
}
