
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.portlets.alert;

import java.io.IOException;

import org.apache.jetspeed.portlet.PortletException;
import org.apache.jetspeed.portlet.PortletRequest;
import org.apache.jetspeed.portlet.PortletResponse;
import org.apache.jetspeed.portlet.PortletSession;

import com.ibm.ccd.ui.portlets.BasePortlet;
import com.ibm.ccd.ui.util.IReference;


/**
 * Alert Portlet: This portlet just includes a IFrame.
 *
 */
public class AlertPortlet extends BasePortlet implements IReference {
    public static final String ALERT_JSP = "/jsps/html/alert/alert.";

    /**
     * Returns the file extension for the JSP file
     * @param request PortletRequest
     * @param response PortletResponse
     * @return JSP extension
     */
    public void doView(PortletRequest request, PortletResponse response)
        throws PortletException, IOException {
        log.debug(" doView  -> ");

        try {
            getWPSContext(request);
            getPortletConfig().getContext().include(ALERT_JSP +
                getJspExtension(request), request, response);
        } catch (Exception er) {
            er.printStackTrace();
        }
    }

    /**
     * Returns the file extension for the JSP file
     *
     * @param request PortletRequest
     * @return JSP extension
     */
    private static String getJspExtension(PortletRequest request) {
        String markupName = request.getClient().getMarkupName();

        return "jsp";
    }

    /**
     * Method
     * @param request PortletRequest
     *
     */
    protected void setBusinessFunction(PortletRequest portletRequest) {
        PortletSession session = portletRequest.getPortletSession();
    }
}
