/*
 * Licensed Materials: Property of IBM
 * "Restricted Materials of IBM"
 * 5724-I68.
 * (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

/*
 * Created on Dec 8, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.ibm.ccd.ui.portlets.catalog;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.StringTokenizer;

import org.apache.jetspeed.portlet.AccessDeniedException;
import org.apache.jetspeed.portlet.PortletConfig;
import org.apache.jetspeed.portlet.PortletException;
import org.apache.jetspeed.portlet.PortletRequest;
import org.apache.jetspeed.portlet.PortletResponse;
import org.apache.jetspeed.portlet.PortletSession;
import org.apache.jetspeed.portlet.PortletSettings;
import org.apache.jetspeed.portlet.PortletURI;
import org.apache.jetspeed.portlet.UnavailableException;
import org.apache.jetspeed.portlet.User;
import org.apache.jetspeed.portlet.event.ActionEvent;
import org.apache.jetspeed.portlet.event.ActionListener;
import org.apache.jetspeed.portlet.event.MessageEvent;
import org.apache.jetspeed.portlet.event.MessageListener;

import com.ibm.ccd.ui.cache.CacheConstants;
import com.ibm.ccd.ui.cache.CacheManager;
import com.ibm.ccd.ui.cache.CacheNotEnabledException;
import com.ibm.ccd.ui.context.IWPCUser;
import com.ibm.ccd.ui.context.WPCUser;
import com.ibm.ccd.ui.context.WPSContext;
import com.ibm.ccd.ui.dataobjects.CategoryHierarchy;
import com.ibm.ccd.ui.dataobjects.Node;
import com.ibm.ccd.ui.exception.MessageMap;
import com.ibm.ccd.ui.mediator.WPCMediator;
import com.ibm.ccd.ui.mediator.WPCMediatorException;
import com.ibm.ccd.ui.portlets.BasePortlet;
import com.ibm.ccd.ui.portlets.GenericPortletMessage;
import com.ibm.ccd.ui.util.UIUtils;

/**
 * This Portlet displays the Category hierarc
 *  
 */
public class ItemCatalogPortlet extends BasePortlet implements ICatalogAction,
        ActionListener, MessageListener {
    private static final String NODEID = "id";

    public static final int DEFAULT_CHILD_LENGTH = 300;

    public static final String CHILD_LENGTH = "ChildLen";

    public static String AVAILABLE_CATALOG_LIST = "AvbCatalog";

    private static final String VIEW_CATALOG = "/jsps/html/itemcatalog/ViewItemCatalog.jsp";

    private static final String VIEW_CATALOG_CONGIF = "/jsps/html/itemcatalog/ViewItemCatalogConfig.jsp";

    public static final String ITEMCATALOGFORM = "ItemCatalogForm";

    //  public static String ELEMENT_SELECT_CATALOGS = "selectCatalogs";
    public static String ELEMENT_SELECT_CATALOGS = "tag";

    String CONFIG_INDEX_TOKENIZER = "#";

    String CONFIG_CATALOG_TOKENIZER = "~";

    String KEY_CONFIG_CATALOGS = "CONFIG_CATALOGS";

    protected WPSContext wpsContext = null;

    /**
     * @param porletConfig
     * @see org.apache.jetspeed.portlet.Portlet#init(PortletConfig)
     */
    public void init(PortletConfig portletConfig) throws UnavailableException {
        super.init(portletConfig);
    }

    /**
     * @param request
     *            is PortletRequest
     * @param response
     *            is PortletResponse
     * @see org.apache.jetspeed.portlet.PortletAdapter#doView(PortletRequest,
     *      PortletResponse)
     */
    public void doView(PortletRequest request, PortletResponse response)
            throws PortletException, IOException {

        PortletSession session = request.getPortletSession();
        PortletURI expand = null;
        WPSContext ctx = getWPSContext(request);
        PortletURI selectedItem = null;
        if (session != null) {
            if (session.getAttribute(ITEMCATALOGFORM) == null) {
                getCatalogs(request);
            }
            getPortletConfig().getContext().getAttribute(
                    IWPCUser.KEY_AVAILABEL_CATALOGS);

            expand = response.createURI();
            expand.addAction(EXPAND_COMMAND);

            selectedItem = response.createURI();
            selectedItem.addAction(SELECT_COMMAND);

            request.setAttribute(EXPAND_COMMAND, expand);
            request.setAttribute(SELECT_COMMAND, selectedItem);
        }

		if (session.getAttribute(AVAILABLE_CATALOG_LIST)!= null) {
			
			setCatalogDisplay(request);
		}

        String jsp2Render = (String) request.getAttribute(JSP2RENDER);

        if (jsp2Render == null) {
            jsp2Render = VIEW_CATALOG;
        }

        getPortletConfig().getContext().include(jsp2Render, request, response);
    }

    private void setCatalogDisplay(PortletRequest request) {

        PortletSession session = null;
        PortletSettings portletSettings = null;
        String selectedCatalogs = null;
        StringTokenizer tokenizer = null;
        String stringToken = null;
        String catalogName = null;
        List catalogList = null;
        ItemCatalogPortlet catalogBean = null;
        CatalogList catalogListForm = null;

        //	BaseSearchElement element=null;
        String elementName = null;
        HashMap attributeMap = null;
        int index = -1;
        int count = 0;
        Integer listBoxIndex = null;
        Object value = null;

        catalogList = (ArrayList) request.getPortletSession().getAttribute(
                AVAILABLE_CATALOG_LIST);

        //catalogList = getCatalogList(request);
        portletSettings = request.getPortletSettings();

        selectedCatalogs = portletSettings.getAttribute(KEY_CONFIG_CATALOGS);

        if (selectedCatalogs != null) {
            attributeMap = new HashMap();
            tokenizer = new StringTokenizer(selectedCatalogs,
                    CONFIG_CATALOG_TOKENIZER);

            while (tokenizer.hasMoreTokens()) {
                stringToken = tokenizer.nextToken();
                index = stringToken.indexOf(CONFIG_INDEX_TOKENIZER);
                catalogName = stringToken.substring(0, index);

                listBoxIndex = Integer
                        .valueOf(stringToken.substring(index + 1));
                attributeMap.put(catalogName, listBoxIndex);
            }

            for (int i = 0; i < catalogList.size(); i++) {
                catalogListForm = (CatalogList) catalogList.get(i);
                catalogName = catalogListForm.getName();

                value = attributeMap.get(catalogName);

                if (value != null) {
                    listBoxIndex = (Integer) value;

                    catalogListForm.setSelected(true);

                    catalogListForm.setListBoxIndex(listBoxIndex.intValue());
                    count++;
                }
            }

            //recalculate list box ndex if any catalog is removed from wpc
            if (attributeMap.size() > count) {
                int j = 0;
                for (int i = 0; i < catalogList.size(); i++) {
                    catalogListForm = (CatalogList) catalogList.get(i);
                    if (catalogListForm != null) {
                        if (catalogListForm.isSelected()) {
                            catalogListForm.setListBoxIndex(j++);
                        }
                    }
                }
            }
        }

    }

    /**
     * @param request
     *            is PortletRequest
     * @param response
     *            is PortletResponse
     * @see org.apache.jetspeed.portlet.PortletAdapter#doEdit(PortletRequest,
     *      PortletResponse)
     */
    public void doEdit(PortletRequest request, PortletResponse response)
            throws PortletException, IOException {
    }

    /**
     * @param request
     *            is PortletRequest
     * @param response
     *            is PortletResponse
     * @see org.apache.jetspeed.portlet.PortletAdapter#doHelp(PortletRequest,
     *      PortletResponse)
     */
    public void doHelp(PortletRequest request, PortletResponse response)
            throws PortletException, IOException {
    }

    /**
     * @param request
     *            is PortletRequest
     * @param response
     *            is PortletResponse
     * @see org.apache.jetspeed.portlet.PortletAdapter#doConfigure(PortletRequest,
     *      PortletResponse)
     */
    public void doConfigure(PortletRequest request, PortletResponse response)
            throws PortletException, IOException {
        PortletSession session = request.getPortletSession();
        PortletSettings settings = request.getPortletSettings();

        if (settings.getAttribute(AVAILABLE_CATALOG_LIST) == null) {
        	ArrayList catalogList = null;
			if(session.getAttribute(AVAILABLE_CATALOG_LIST) == null) {
				catalogList = (ArrayList) getCatalogList(request);
				session.setAttribute(AVAILABLE_CATALOG_LIST, catalogList);	 
			}else {
				catalogList = (ArrayList) session.getAttribute(AVAILABLE_CATALOG_LIST);
			}

            setCatalogDisplay(request);
            getCatalogs(request);
        }

        getPortletConfig().getContext().include(VIEW_CATALOG_CONGIF, request,
                response);
    }

    /**
     * @param event
     * @see org.apache.jetspeed.portlet.event.ActionListener#actionPerformed(org.apache.jetspeed.portlet.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent event) throws PortletException {

        PortletRequest request = event.getRequest();
        PortletSession session = request.getPortletSession();
        PortletSettings portletSettings = null;
        portletSettings = request.getPortletSettings();
        String catalogName = null;
        StringBuffer selectedCatalogs = null;
        MessageMap map = null;

        //      /*fix for defect no WPC00021642

        //      /*fix for defect no WPC00021642

        map = getMessageMap(request);
        ItemCatalogForm itemCatalogForm = (ItemCatalogForm) session
                .getAttribute(ITEMCATALOGFORM);

        String actionString = event.getActionString();

        if (CATALOG_CONFIG.equals(actionString)) {
            String param = "ITEMCATALOG.CHILD_LENGTH";
            String key = getTextLabel(request, param);
            String childLength = request.getParameter(param);
            String paramList = ELEMENT_SELECT_CATALOGS;
            String[] selectedCatalog = request.getParameterValues(paramList);

            try {
                List ctgList = (ArrayList) session
                        .getAttribute(AVAILABLE_CATALOG_LIST);

                for (int i = 0; i < ctgList.size(); i++) {
                    CatalogList lst = (CatalogList) ctgList.get(i);
                    lst.setSelected(false);
                }
                selectedCatalogs = new StringBuffer();
                for (int i = 0; i < selectedCatalog.length; i++) {

                    catalogName = selectedCatalog[i];

                    for (int j = 0; j < ctgList.size(); j++) {
                        CatalogList lst = (CatalogList) ctgList.get(j);
                        if (lst.getName().equals(selectedCatalog[i])) {
                            //                          /*fix for defect no WPC00021642
                            //lst.setSelected(true);
                            //                          /*fix for defect no WPC00021642

                            lst.setListBoxIndex(i);
                            selectedCatalogs.append(lst.getName());
                            selectedCatalogs.append(CONFIG_INDEX_TOKENIZER);

                            selectedCatalogs.append(i);

                            selectedCatalogs.append(CONFIG_CATALOG_TOKENIZER);
                            break;
                        }
                    }
                }

                portletSettings.setAttribute(KEY_CONFIG_CATALOGS,
                        selectedCatalogs.toString());
                portletSettings.store();
                //set available catalogs at application level. used by
                // AttributeTag currently
                getPortletConfig().getContext().setAttribute(
                        IWPCUser.KEY_AVAILABEL_CATALOGS, selectedCatalog);
                //	map.addInfoMessage(MSG_CONFIG_UPDATE_SUCCESS);
            } catch (Exception e1) {
                e1.printStackTrace();

            }

            //	MessageMap map = null;
            if (childLength != null) {
                childLength = childLength.trim();
                try {
                    if (childLength.equals("") || childLength.equals("0")) {
                        itemCatalogForm.setChildLength("0");
                        session.setAttribute(CHILD_LENGTH, "0");
                        // Display message Data Updated successfully
                        map.addInfoMessage("MESSAGE_CODE_121");
                    } else {
                        long childLen = Long.parseLong(childLength);
                        if (childLen > 0) {
                            itemCatalogForm.setChildLength(childLen + "");
                            session.setAttribute(CHILD_LENGTH, childLen + "");
                            // Display message Data Updated successfully
                            map.addInfoMessage("MESSAGE_CODE_121");
                        } else {
                            // display error message for negative numbers
                            map.addErrorMessage("MESSAGE_CODE_112", key);
                        }
                    }
                } catch (NumberFormatException e) {
                    map.addErrorMessage("MESSAGE_CODE_111", key);
                }
            } else {
                map.addErrorMessage("MESSAGE_CODE_110", key);
            }

            //getCatalogs(request);
            return;
        }

        String expandNode = null;
        String selectedNode = null;

        if (request.getParameter(NODEID) != null) {
            expandNode = request.getParameter(NODEID);
            selectedNode = request.getParameter(NODEID);

        } else {
            selectedNode = itemCatalogForm.getSelItem();

        }
        System.out.println("selected Node in if loop " + selectedNode);

        String catalogId = null;
        String parentId = null;
        CategoryHierarchy hierarchy = null;
        WPCUser wpcUser = getWPSContext(request).getWpcUser();

        //hierarchy = itemCatalogForm.getSelectedNode().getCategory();
        // command to create an item
        if (CREATE.equals(actionString) && prepareAction(request, actionString)) {
            catalogId = getSelecteItemCatalogId(itemCatalogForm);
            parentId = getSelectedCategoryParentId(itemCatalogForm);

            GenericPortletMessage message = new GenericPortletMessage(
                    WORKWITHITEMPORTLET);
            message.put(CATALOG, catalogId);
            message.put(PARENTID, parentId);
            message.put(ITEMID, null);
            message.put(COMMAND, CREATE);
            message.put(CATEGORY_HIERARCHY, hierarchy);

            sendMessage(WORKWITHITEMPORTLET, message);

            return;
        }

        // command to view an item
        if (VIEW.equals(actionString) && prepareAction(request, actionString)) {

            catalogId = getSelecteItemCatalogId(itemCatalogForm);
            parentId = getSelectedItemParentId(itemCatalogForm);

            GenericPortletMessage message = new GenericPortletMessage(
                    WORKWITHITEMPORTLET);
            message.put(CATALOG, catalogId);
            message.put(PARENTID, parentId);
            message.put(ITEMID, itemCatalogForm.getSelectedNode()
                    .getDisplayName());
            message.put(COMMAND, VIEW);
            message.put(CATEGORY_HIERARCHY, hierarchy);

            sendMessage(WORKWITHITEMPORTLET, message);

            return;
        }

        // command to update an item
        if (UPDATE.equals(actionString) && prepareAction(request, actionString)) {
            catalogId = getSelecteItemCatalogId(itemCatalogForm);
            parentId = getSelectedItemParentId(itemCatalogForm);

            GenericPortletMessage message = new GenericPortletMessage(
                    WORKWITHITEMPORTLET);
            message.put(CATALOG, catalogId);
            message.put(PARENTID, parentId);
            message.put(ITEMID, itemCatalogForm.getSelectedNode()
                    .getDisplayName());
            message.put(COMMAND, UPDATE);
            message.put(CATEGORY_HIERARCHY, hierarchy);

            sendMessage(WORKWITHITEMPORTLET, message);

            return;
        }

        // command to clone an item
        if (CLONE.equals(actionString) && prepareAction(request, actionString)) {
            catalogId = getSelecteItemCatalogId(itemCatalogForm);
            parentId = getSelectedItemParentId(itemCatalogForm);

            GenericPortletMessage message = new GenericPortletMessage(
                    WORKWITHITEMPORTLET);
            message.put(CATALOG, catalogId);
            message.put(PARENTID, parentId);
            message.put(ITEMID, itemCatalogForm.getSelectedNode()
                    .getDisplayName());
            message.put(COMMAND, CLONE);
            message.put(CATEGORY_HIERARCHY, hierarchy);

            sendMessage(WORKWITHITEMPORTLET, message);

            return;
        }

        // command to delete an item
        if (DELETE.equals(actionString) && prepareAction(request, actionString)) {
            catalogId = getSelecteItemCatalogId(itemCatalogForm);
            parentId = getSelectedItemParentId(itemCatalogForm);

            GenericPortletMessage message = new GenericPortletMessage(
                    WORKWITHITEMPORTLET);
            message.put(CATALOG, catalogId);
            message.put(PARENTID, parentId);
            message.put(ITEMID, itemCatalogForm.getSelectedNode()
                    .getDisplayName());
            message.put(COMMAND, DELETE);
            message.put(CATEGORY_HIERARCHY, hierarchy);

            sendMessage(WORKWITHITEMPORTLET, message);

            return;
        }

        // command to expand - collapse the catalog tree
        if (EXPAND_COMMAND.equals(actionString)) {
            CatalogTree tree = itemCatalogForm.getTree();

            ItemNodeCatalog node = tree.searchNode(tree.getRoot(), expandNode);

            if (node != null) {
                if (node.isExpanded()) {
                    // collapse the node
                    node.setExpanded(false);
                } else {
                    // diplay the items under this catalog node
                    if (node.isLeaf()) {
                        displayExpandedNode(request, node);
                    } else if (node.getChildren() != null) {
                        node.setExpanded(true);
                    }
                }
            }

            return;
        }

        if (REFRESH.equals(actionString)) {
            session.removeAttribute(ITEMCATALOGFORM);
            getCatalogs(request);

            return;
        }

		if (SELECT_COMMAND.equals(actionString)) {
			if (selectedNode != null) {
				// Fix for Bug No WPC00031094
				CacheManager cManager = null;
			
				try {
					cManager=CacheManager.getInstance();
				} catch (CacheNotEnabledException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				User user = request.getUser();
				String catalogNameKey = CacheConstants.CATALOG_NAME;
				String catalogNodeKey = CacheConstants.CATALOG_NODE;
				String key = (String) wpcUser.getProperty(IWPCUser.KEY_USER_ID);
				itemCatalogForm.setSelItem(selectedNode);
				catalogId = getSelecteItemCatalogId(itemCatalogForm);
				if (CacheManager.isCacheEnabled()) {

					cManager.putInCache(catalogNameKey, key, catalogId);
					cManager.putInCache(catalogNodeKey, key, selectedNode);
					// Fix for Bug No WPC00031094
				} else {

					wpcUser.setProperty(
						IWPCUser.KEY_WPC_CATALOGUE_NAME,
						catalogId);

					System.out.println(
						"currentCatalogId at 523"
							+ wpcUser.getProperty(
								IWPCUser.KEY_WPC_CATALOGUE_NAME));
					wpcUser.setProperty(
						IWPCUser.KEY_WPC_CATALOGUE_NODE,
						selectedNode);

				}
			}

			if(prepareAction(request, actionString)) {
				catalogId = getSelecteItemCatalogId(itemCatalogForm);
				parentId = getSelectedItemParentId(itemCatalogForm);

				GenericPortletMessage message = new GenericPortletMessage(
						WORKWITHITEMPORTLET);
				message.put(CATALOG, catalogId);
				message.put(PARENTID, parentId);
				message.put(ITEMID, itemCatalogForm.getSelectedNode()
						.getDisplayName());
				message.put(COMMAND, VIEW);
				message.put(CATEGORY_HIERARCHY, hierarchy);

				sendMessage(WORKWITHITEMPORTLET, message);
			}
            return;
        }
    }

    /**
     * @see org.apache.jetspeed.portlet.event.MessageListener#messageReceived(org.apache.jetspeed.portlet.event.MessageEvent)
     */
    public void messageReceived(MessageEvent event) throws PortletException {

        PortletRequest request = event.getRequest();
        PortletSession session = request.getPortletSession();
        ItemCatalogForm itemCatalogForm = (ItemCatalogForm) session
                .getAttribute(ITEMCATALOGFORM);
        ItemNodeCatalog selItem = itemCatalogForm.getSelectedNode();

        GenericPortletMessage message = (GenericPortletMessage) event
                .getMessage();
        String itemID = null;

        //This portlet does not listen for any message from other portlet
        if (true)
            return;

        // return if the message is not with name ITEMCATALOGPORTLET
        if ((message.getMessage() != null)
                && !ITEMCATALOGPORTLET.equals(message.getMessage())) {
            return;
        }

        String command = (String) message.get(COMMAND);

        if (CREATE.equals(command)) {
            itemID = (String) message.get(ITEMID);

            if (selItem.getType() == CatalogTree.ITEM) {
                selItem = (ItemNodeCatalog) selItem.getParent();
            }

            ItemNodeCatalog newItem = new ItemNodeCatalog(selItem.getId() + "/"
                    + itemID, itemID, CatalogTree.ITEM, itemID);
            newItem.setCategory(selItem.getCategory());
            selItem.add(newItem);
            selItem.setExpanded(true);
            itemCatalogForm.setSelItem(newItem.getId() + "");

            return;
        }

        if (CLONE.equals(command)) {
            itemID = (String) message.get(ITEMID);

            if (selItem.getType() == CatalogTree.ITEM) {
                selItem = (ItemNodeCatalog) selItem.getParent();
            }

            ItemNodeCatalog clonedItem = new ItemNodeCatalog(selItem.getId()
                    + "/" + itemID, itemID, CatalogTree.ITEM, itemID);
            clonedItem.setCategory(selItem.getCategory());
            selItem.add(clonedItem);
            selItem.setExpanded(true);
            itemCatalogForm.setSelItem(clonedItem.getId() + "");

            return;
        }

        if (DELETE.equals(command)) {
            itemID = (String) message.get(ITEMID);

            String itemPath = itemCatalogForm.getSelectedNode().getId();

            CatalogTree tree = itemCatalogForm.getTree();
            ItemNodeCatalog delItem = tree.searchNode(tree.getRoot(), itemPath);

            if (delItem != null) {
                tree.removeChild(delItem);
            } else {
                // msg item not found in this catalog
                System.out.println("Item not found in this catalog ");
            }

            return;
        }
    }

    protected boolean prepareAction(PortletRequest request, String command) {
        PortletSession session = request.getPortletSession();
        ItemCatalogForm itemCatalogForm = (ItemCatalogForm) session
                .getAttribute(ITEMCATALOGFORM);

        MessageMap map = null;

        try {
            map = getMessageMap(request);
        } catch (Exception e) {
            e.printStackTrace();
        }

        if (CREATE.equals(command)) {
            if ((itemCatalogForm.getSelectedNode() == null)
                    || (itemCatalogForm.getSelectedNode().getType() == CatalogTree.ITEM)
                    || (itemCatalogForm.getSelectedNode().getType() == CatalogTree.HIERARCHY)
                    || (itemCatalogForm.getSelectedNode().getType() == CatalogTree.CATALOG)) {
                //ErrorMessage: Select a category to add an Item
                map.addErrorMessage("MESSAGE_CODE_103");

                return false;
            }
        }

        if (VIEW.equals(command) || CLONE.equals(command)
                || UPDATE.equals(command) || DELETE.equals(command)) {
            if ((itemCatalogForm.getSelectedNode() == null)
                    || (itemCatalogForm.getSelectedNode().getType() == CatalogTree.CATEGORY)
                    || (itemCatalogForm.getSelectedNode().getType() == CatalogTree.HIERARCHY)
                    || (itemCatalogForm.getSelectedNode().getType() == CatalogTree.CATALOG)) {
                //ErrorMessage: Item not selected or Item not found in this
                // Catalog
                map.addErrorMessage("MESSAGE_CODE_108");

                return false;
            }
        }

		if(SELECT_COMMAND.equals(command)) {
			if ((itemCatalogForm.getSelectedNode() == null)
					|| (itemCatalogForm.getSelectedNode().getType() == CatalogTree.CATEGORY)
					|| (itemCatalogForm.getSelectedNode().getType() == CatalogTree.HIERARCHY)
					|| (itemCatalogForm.getSelectedNode().getType() == CatalogTree.CATALOG)) {
						return false;
					}
				
		}
        return true;
    }

    protected List getCatalogList(PortletRequest request) {

        WPSContext context = getWPSContext(request);
        PortletSession session = request.getPortletSession();
        WPCMediator mediator = WPCMediator.getInstance();
        CategoryHierarchy[] hierarchy = null;

        try {
            hierarchy = mediator.getCatalogs(context);
        } catch (WPCMediatorException e) {
            e.printStackTrace();
            handleException(e, request);

            return null;
        }

        ArrayList ctgList = new ArrayList();

        for (int i = 0; i < hierarchy.length; i++) {
            CatalogList cat = new CatalogList(hierarchy[i].getCatalogName(),
                    hierarchy[i].getCatalogName());
            cat.setListBoxIndex(i);
            ctgList.add(cat);
        }

        return ctgList;
    }

    protected void getCatalogs(PortletRequest request) {

        WPSContext context = null;
        PortletSession session = request.getPortletSession();
        PortletSettings settings = request.getPortletSettings();
        ItemCatalogForm itemCatalogForm = new ItemCatalogForm();
        session.setAttribute(ITEMCATALOGFORM, itemCatalogForm);
        String selectedCatalogs = null;
        StringTokenizer tokenizer = null;
        String stringToken = null;
        String catalogName = null;
        ArrayList catalogList = new ArrayList();
        HashMap attributeMap = null;
        int index = -1;
        Integer listBoxIndex = null;
        String[] selectedCatalog = null;
        int sVariable = 0;
        // fix for defect no WPC00021642

        WPCUser wpcUser = getWPSContext(request).getWpcUser();
        String currentCatalogId = null;
        currentCatalogId = UIUtils.getCatalogName(wpcUser);
        String currentCatalogNode = UIUtils.getCatalogNode(wpcUser);

        String [] finalArray=null;
        String baseStr = "";
  	    String finalString="";
  		String firstNode = "";
        int arrayElements =0;
        //     fix for defect no WPC00021642
        //selectedCatalogs = new StringBuffer();

        CatalogTree tree = itemCatalogForm.getTree();

        if (session.getAttribute(CHILD_LENGTH) == null) {
            itemCatalogForm.setChildLength(Long.toString(DEFAULT_CHILD_LENGTH));
            session.setAttribute(CHILD_LENGTH, Long
                    .toString(DEFAULT_CHILD_LENGTH));
        } else {
            itemCatalogForm.setChildLength((String) session
                    .getAttribute(CHILD_LENGTH));
        }

        context = getWPSContext(request);

        WPCMediator mediator = WPCMediator.getInstance();
        CategoryHierarchy[] hierarchy = null;
        try {
            hierarchy = mediator.getCatalogs(context);
        } catch (WPCMediatorException e) {
            e.printStackTrace();
            handleException(e, request);
            return;
        }

		if(session.getAttribute(AVAILABLE_CATALOG_LIST) == null) {
			ArrayList ctgList = new ArrayList();
			for (int i = 0; i < hierarchy.length; i++) {
				CatalogList cat = new CatalogList(hierarchy[i].getCatalogName(),
						hierarchy[i].getCatalogName());
				cat.setListBoxIndex(i);
				ctgList.add(cat);
				}
			session.setAttribute(AVAILABLE_CATALOG_LIST, ctgList);
		}
        
        boolean flag = false;
        boolean item_flag = false;

        selectedCatalogs = settings.getAttribute(KEY_CONFIG_CATALOGS);
        /*
         * if() condition included to display catalogs selected in the
         * configuration
         */
        if (selectedCatalogs != null && selectedCatalogs.trim().length() > 0) {
            String defaultCatalog = WPCMediator.getInstance()
                    .getDefaultCatalog();
            tokenizer = new StringTokenizer(selectedCatalogs,
                    CONFIG_CATALOG_TOKENIZER);
            attributeMap = new HashMap();

            while (tokenizer.hasMoreTokens()) {
                int m = 0;
                stringToken = tokenizer.nextToken();
                index = stringToken.indexOf(CONFIG_INDEX_TOKENIZER);
                catalogName = stringToken.substring(0, index);

                listBoxIndex = Integer
                        .valueOf(stringToken.substring(index + 1));
                attributeMap.put(catalogName, listBoxIndex);
                int l = listBoxIndex.intValue();

                catalogList.add(catalogName);
                for (int i = 0; i < hierarchy.length; i++) {
                    //	hierarchy[i].printMe();

                    ItemNodeCatalog catalog1 = new ItemNodeCatalog("/0/"
                            + hierarchy[i].getCatalogName() + "/", hierarchy[i]
                            .getCatalogName(), CatalogTree.CATALOG,
                            hierarchy[i].getCatalogName());
                    /*
                     * if (!flag) { itemCatalogForm.setSelItem("/0/" +
                     * hierarchy[i].getCatalogName() + "/"); flag = true; }
                     */
                    catalog1.setExpanded(true);
                    String hierarchyName[] = hierarchy[i].getHierarchy();
                    String hierarchyType[] = hierarchy[i].getHierarchyType();

                    for (int j = 0; j < hierarchyName.length; j++) {
                        ItemNodeCatalog hierarchyNode = new ItemNodeCatalog(
                                "/0/" + hierarchy[i].getCatalogName() + "/"
                                        + hierarchyName[j], hierarchyName[j],
                                CatalogTree.HIERARCHY, hierarchyName[j]);
                        hierarchyNode.setExpanded(false);

                        CategoryHierarchy hier = new CategoryHierarchy(
                                hierarchy[i].getCatalogName(),
                                hierarchyName[j], hierarchyType[j], "/0/"
                                        + hierarchy[i].getCatalogName() + "/"
                                        + hierarchyName[j] + "");
                        hierarchyNode.setCategory(hier);
                        catalog1.add(hierarchyNode);

                        //                               fix for defect no WPC00021642

                        if (catalogName.equals(catalog1.getDisplayName())) {

                            
                            flag = true;
                            
                            tree.addChild(tree.getRoot(), catalog1);
                            
                        } else {

                            if (catalogName.equals(catalog1.getDisplayName())
                                    && (defaultCatalog.equals(catalog1
                                            .getDisplayName()))) {
                               
                                flag = true;

                               

                                tree.addChild(tree.getRoot(), catalog1);
                                System.out.println("here at 830");
                                System.out.println("currentCatalogId at 836"
                                        + currentCatalogId);
                               
                            }
                        }
                        if (catalogName.equals(catalog1.getDisplayName())
                                && catalogName.equals(currentCatalogId)) {
                            
                            CatalogTree tree1 = itemCatalogForm.getTree();
                            ItemNodeCatalog node1 = tree1.searchNode(tree1
                                    .getRoot(), catalog1);
                        
			   					try {				   					
                            	// Fix for Bug:WPC00024574 modified the line no 841 . added ii!=1 in the if loop 
                            	
                            	int ii = 1;
                                if(currentCatalogNode!=null){
                                	
                             	   String[] tempArray = currentCatalogNode.split("/");
                             	  arrayElements = tempArray.length-4;
                             	         System.out.println("arry elements ="+arrayElements);
                             	         if(arrayElements>=1){
                             	         
                             	        // fix for WPC00023923,WPC00023892
                             	          while ((ii*ii + ii) != (arrayElements*2) && ii<arrayElements) ii++;
                             	                
                             	         if (ii == arrayElements && ii!=1){
                             	                  ii = 1;
                             	                  arrayElements--;
                             	          while ((ii*ii + ii) != (arrayElements*2)) ii++;
                             	                  item_flag = true;
                             	                }
                             	               // fix for WPC00023923,WPC00023892
                             	          System.out.println("i value is "+ii);
                             	          
                             	          for (int indx = 0; indx < tempArray.length; indx++) {

                             	           if (indx < 3) {
                             	            baseStr += tempArray[indx] + "/";
                             	               System.out.println("baseStr line 24" + baseStr);

                             	           }
                             	           if(indx ==3){
                             	            baseStr+=tempArray[indx];
                             	            firstNode+= baseStr;
                             	            System.out.println("node1="+firstNode);
                             	            
                             	           }
                             	           }
                             	          
                             				int c = 4;
                             				finalArray = new String[ii + 2];
                             				System.out.println("node 1" + firstNode);
                             				baseStr += "/";
                             				finalArray[0] = firstNode;
                             				for (int index1 = 1; index1 <= ii; index1++) {
                             					String tempStr = "";

                             					for (int k = 0; k < index1; k++) {
                             						//tempStr = tempStr + tempArray[c++((j+1)*(j+2)/2) + k]+"/";
                             						tempStr = tempStr + tempArray[c++] + "/";

                             					}

                             					baseStr = baseStr + tempStr;
                             					System.out.println("baseStr is " + baseStr);
                             					int start = 0;
                             					int end = baseStr.lastIndexOf("/");
                             					finalString = baseStr.substring(start, end);
                             					finalArray[index1] = finalString;
                             					//   System.out.println("finalString is "+finalString);
                             					System.out.println("finalArrya is " + index1 + " "
                             							+ finalArray[index1]);

                             				}
                             				 // fix for WPC00023923,WPC00023892
                             				if (item_flag) {
                             					finalString = baseStr + tempArray[c];
                             					finalArray[ii+1]=baseStr + tempArray[c];
												System.out.println("finalArray in item flag is " + finalArray[ii+1]);	
												System.out.println("finalString in item flag is " + finalString);
                             				}
                             				 // fix for WPC00023923,WPC00023892      
                                	                
                             	         }
                             	         }
                               
                               
                                                            //                            System.out.println("temp value is  "+ finalArray.length);
                                if (finalArray != null) {
                                    for (int startNode = 0; startNode < arrayElements+1; startNode++) {

                                        System.out.println("temp value is temp["+startNode+"]"
                                                + finalArray[startNode]);
                                        ItemNodeCatalog node = tree1.searchNode(
                                                tree1.getRoot(), finalArray[startNode]);
																			
                                        System.out.println("node arrayElements = " + arrayElements);
                                
                                        if (node != null) {
                                            if (node.isExpanded()) {
                                                // collapse the node
                                                node.setExpanded(false);
                                                System.out.println("inside the isExpanded");

                                            } else {
                                                // diplay the items under this
                                                // catalog node
                                                if (node.isLeaf() && node.getType()!=3) { // checking for category fix for WPC00031094
                                                    System.out
                                                            .println("inside is leaf "
                                                                    + node);
                                                    displayExpandedNode(request,node);
												    node.setSelected(true);
													if (node.isLeaf() && node.getType()==3) { // checking for item fix for WPC00031094
														System.out.println("inside is leaf and type"+ node);
														node.setSelected(true);    
												} else if (node.getChildren() != null ) {
                                                	System.out.println("insde the getChilder");
                                                    node.setExpanded(true);
                                                    node.setSelected(true);
												}
                                                }
                                               
                                            }
                                            
                                    	}
                                   
                                   }
                                   
                                }
                            } catch (RuntimeException e2) {
                                // TODO Auto-generated catch block
                                System.out.println("at line 926");
                                e2.printStackTrace();
                            }
                            flag = true;
                            tree.addChild(tree.getRoot(), catalog1);
                        //    catalog1.setSelected(true);
                            System.out.println("here at 851");
                            System.out.println("currentCatalogId at 853"
                                    + currentCatalogId);
                            /*
                             * wpcUser.setProperty(
                             * IWPCUser.KEY_WPC_CATALOGUE_NAME, catalogName);
                             */

                        }

                        //fix for defect no WPC00021642
                    }
                    // add the cut code here

                }

            }
            //fixed defect no : 00015
            selectedCatalog = new String[catalogList.size()];
            catalogList.toArray(selectedCatalog);
            getPortletConfig().getContext().setAttribute(
                    IWPCUser.KEY_AVAILABEL_CATALOGS, selectedCatalog);

        }

        /*
         * if() condition included to display default catalog if there are no
         * catalogs defined/selected in the configuration
         */
        if (selectedCatalogs == null || selectedCatalogs.trim().length() == 0) {

            String defaultCatalog = WPCMediator.getInstance()
                    .getDefaultCatalog();
            flag = true;
            for (int i = 0; i < hierarchy.length; i++) {
                //	hierarchy[i].printMe();
                System.out.println("i = " + i);
                ItemNodeCatalog catalog1 = new ItemNodeCatalog("/0/"
                        + hierarchy[i].getCatalogName() + "/", hierarchy[i]
                        .getCatalogName(), CatalogTree.CATALOG, hierarchy[i]
                        .getCatalogName());
                if (!flag) {
                    System.out.println("inside the flag");
                    itemCatalogForm.setSelItem("/0/"
                            + hierarchy[i].getCatalogName() + "/");
                    flag = true;
                }
                itemCatalogForm.setSelItem("/0/"
                        + hierarchy[i].getCatalogName() + "/");
                catalog1.setExpanded(true);

                catalog1.setSelected(true);
                String hierarchyName[] = hierarchy[i].getHierarchy();
                String hierarchyType[] = hierarchy[i].getHierarchyType();

                for (int j = 0; j < hierarchyName.length; j++) {
                    ItemNodeCatalog hierarchyNode = new ItemNodeCatalog("/0/"
                            + hierarchy[i].getCatalogName() + "/"
                            + hierarchyName[j], hierarchyName[j],
                            CatalogTree.HIERARCHY, hierarchyName[j]);
                    hierarchyNode.setExpanded(false);

                    CategoryHierarchy hier = new CategoryHierarchy(hierarchy[i]
                            .getCatalogName(), hierarchyName[j],
                            hierarchyType[j], "/0/"
                                    + hierarchy[i].getCatalogName() + "/"
                                    + hierarchyName[j] + "");
                    hierarchyNode.setCategory(hier);
                    catalog1.add(hierarchyNode);

                    //	System.out.println("Default Catalog"+defaultCatalog);
                    if (defaultCatalog.equals(catalog1.getDisplayName())) {
                        wpcUser.setProperty(IWPCUser.KEY_WPC_CATALOGUE_NAME,
                                catalog1.getDisplayName());
                        
                        
                        tree.addChild(tree.getRoot(), catalog1);
                        
                        
                        

                    }
                }
            }
        }

        //System.out.println("inside the ICP clg=" + clg);
        session.setAttribute(ITEMCATALOGFORM, itemCatalogForm);

    }

    /**
     * receives the children of this node and displays under this node
     * 
     * @param request
     * @param node
     */
    protected void displayExpandedNode(PortletRequest request,
            ItemNodeCatalog node) {
        
        Node[] children = null;
        WPSContext context = null;
        context = getWPSContext(request);

        WPCMediator mediator = WPCMediator.getInstance();

        PortletSession session = request.getPortletSession();
        ItemCatalogForm itemCatalogForm = (ItemCatalogForm) session
                .getAttribute(ITEMCATALOGFORM);
        
        String childLength = itemCatalogForm.getChildLength();
 

        int childCount = 0;

        try {
            //			String path = node.getWpcID();
            String path = node.getPathFromLevel("///", 3);

            if ((path != null) && (path.length() >= 3)) {
                path = path.substring(3);
            }

            if (node.getLevel() <= 2) {
                path = "/";
            }

            CategoryHierarchy parentHier = node.getCategory();
            String catalogName = parentHier.getCatalogName();
            String[] hierName = parentHier.getHierarchy();
            String[] hierType = parentHier.getHierarchyType();

            children = mediator.getCatalogChildren(path, catalogName,
                    hierName[0], hierType[0], childLength, context);

            for (int i = 0; i < children.length; i++) {
                //	System.out.println("Children " + children[i].getDisplayName()
                // + " " + children[i].getId() + " " + children[i].getType());
                ++childCount;
            }
        } catch (WPCMediatorException me) {
            handleException(me, request);

            return;
        }

        if (children != null) {
            for (int i = 0; i < children.length; i++) {
                if (children[i] != null) {
                    String idToken = children[i].getId();
                    String type = children[i].getType();

                    if (ITEM.equalsIgnoreCase(type)) {
                        type = String.valueOf(CatalogTree.ITEM);
                      } else {
                        type = String.valueOf(CatalogTree.CATEGORY);
					}

                    ItemNodeCatalog newItem = new ItemNodeCatalog(node.getId()
                            + "/" + idToken, idToken, Integer.parseInt(type),
                            children[i].getDisplayName());

                    node.add(newItem);

                    if (UNASSIGNED.equalsIgnoreCase(children[i].getType())) {
                        newItem.setCategory(new CategoryHierarchy(node
                                .getCategory().getCatalogName(), node
                                .getCategory().getHierarchy()[0], UNASSIGNED,
                                ""));
                    } else {
                        newItem.setCategory(node.getCategory());
                    }
                }
            }
        }

        int childLen = Integer.parseInt(itemCatalogForm.getChildLength());

        MessageMap map = null;

        try {
            map = getMessageMap(request);
        } catch (Exception e1) {
            e1.printStackTrace();
        }

        node.setExpanded(true);

        if (childCount == childLen) {
            //display Info Message : Extend the maxmimum limit of
            // ({0})category/items displayed.
            map.addInfoMessage("MESSAGE_CODE_138", childLen + "");
        } else if (childCount == 0) {
            //display Info Message : No Content for {0}
            map.addInfoMessage("MESSAGE_CODE_139", node.getDisplayName());
            node.setExpanded(true);
        }
    }

    protected String getSelecteItemCatalogId(ItemCatalogForm catalogForm) {
        ItemNodeCatalog selNode = null;

        if (catalogForm != null) {
            selNode = catalogForm.getSelectedNode();

            if (selNode != null) {
                if (selNode.getType() == CatalogTree.CATALOG) {
                    return selNode.getDisplayName();
                } else if (selNode.getCategory() != null) {
                    return selNode.getCategory().getCatalogName();
                }
            }
        }

        return null;
    }

    protected String getSelectedCategoryParentId(ItemCatalogForm catalogForm) {
        ItemNodeCatalog selNode = null;

        if (catalogForm != null) {
            selNode = catalogForm.getSelectedNode();

            //			String path = selNode.getWpcID();
            String path = selNode.getPathFromLevel("///", 3);

            if ((path != null) && (path.length() >= 3)) {
                path = path.substring(3);
            }

            if (path.length() < 1) {
                path = "/";
            }

            return path;
        }

        return null;
    }

    protected String getSelectedItemParentId(ItemCatalogForm catalogForm) {
        ItemNodeCatalog selNode = null;

        if (catalogForm != null) {
            selNode = catalogForm.getSelectedNode();

            //String path = selNode.getParent().getWpcID();
            String path = selNode.getParent().getPathFromLevel("///", 3);

            if ((path != null) && (path.length() >= 3)) {
                path = path.substring(3);
            }

            if (path.length() < 1) {
                path = "/";
            }

            return path;
        }

        return null;
    }

    protected String getItemID(String path) {
        if (path != null) {
            if (path.lastIndexOf('/') != -1) {
                return path.substring(path.lastIndexOf('/') + 1);
            }
        }

        return null;
    }

    /**
     * @param portlet
     *            name
     * @param GenericPorltletMessage
     * @throws AccessDeniedException
     */
    public void sendMessage(String portlet, GenericPortletMessage message) {
        try {
            getPortletConfig().getContext().send(null, message);
        } catch (AccessDeniedException e) {
            e.printStackTrace();
        }
    }

    /**
     * @param request
     *            PortletRequest
     */
    protected void setBusinessFunction(PortletRequest portletRequest) {
        PortletSession session = portletRequest.getPortletSession();
    }
}
