
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.portlets.catalog.util;

import java.io.IOException;
import java.util.HashMap;
import java.util.List;
import java.util.StringTokenizer;

import javax.servlet.http.HttpSession;

import org.apache.jetspeed.portlet.PortletConfig;
import org.apache.jetspeed.portlet.PortletException;
import org.apache.jetspeed.portlet.PortletRequest;
import org.apache.jetspeed.portlet.PortletResponse;
import org.apache.jetspeed.portlet.PortletSession;
import org.apache.jetspeed.portlet.PortletSettings;
import org.apache.jetspeed.portlet.PortletURI;
import org.apache.jetspeed.portlet.UnavailableException;
import org.apache.jetspeed.portlet.event.ActionEvent;

import com.ibm.ccd.ui.context.WPSContext;
import com.ibm.ccd.ui.dataobjects.CategoryHierarchy;
import com.ibm.ccd.ui.dataobjects.Node;
import com.ibm.ccd.ui.exception.MessageMap;
import com.ibm.ccd.ui.mediator.WPCMediator;
import com.ibm.ccd.ui.mediator.WPCMediatorException;
import com.ibm.ccd.ui.portlets.catalog.CatalogTree;
import com.ibm.ccd.ui.portlets.catalog.ICatalogAction;
import com.ibm.ccd.ui.portlets.catalog.ItemCatalogForm;
import com.ibm.ccd.ui.portlets.catalog.ItemCatalogPortlet;
import com.ibm.ccd.ui.portlets.catalog.ItemNodeCatalog;



/**
 *
 * A sample portlet based on PortletAdapter
 *
 */
public class ItemCatalogUtilPortlet extends ItemCatalogPortlet
    implements ICatalogAction {
    private static final String NODEID = "id";
    private static final String ATTR_NAME = "ATTR_NAME";
    String MSG_APPLICATION_EXCEPTION = "MESSAGE_CODE_140";

    public void init(PortletConfig portletConfig) throws UnavailableException,NullPointerException {
        super.init(portletConfig);
    }

    public void doView(PortletRequest request, PortletResponse response)
        throws PortletException, IOException {
        String CATALOG_NAME = request.getParameter("CATALOG_NAME");

        String ATTR_NAME = null;
        PortletSession session = request.getPortletSession();
        PortletURI expand = null;
        PortletURI selectedItem = null;
        MessageMap messageMap = null;
        messageMap = getMessageMap(request);
        System.out.println("catalog in util is "+CATALOG_NAME);

        if (session != null) {
            /*
             * if (session.getAttribute(ITEMCATALOGFORM) == null) {
             *
             * getCatalogs(request); }
             */
            /*if (CATALOG_NAME != null) {
                session.setAttribute(ITEMCATALOGFORM, null);
                getCatalogs(request);
            }*/
            if(CATALOG_NAME==null){
                messageMap.addInfoMessage(MSG_APPLICATION_EXCEPTION);
                System.out.println("catalog inside util is "+CATALOG_NAME);
                
            }
            else{
                session.setAttribute(ITEMCATALOGFORM, null);
                getCatalogs(request);
            }

            expand = response.createURI();
            expand.addAction(EXPAND_COMMAND);

            selectedItem = response.createURI();
            selectedItem.addAction(SELECT_COMMAND);

            request.setAttribute(EXPAND_COMMAND, expand);
            request.setAttribute(SELECT_COMMAND, selectedItem);
        }

        String jsp2Render = (String) request.getAttribute(JSP2RENDER);

        if (jsp2Render == null) {
            jsp2Render = ICatalogUtil.PATH_CATALOG_UTIL_VIEW_JSP;
        }

        getPortletConfig().getContext().include(jsp2Render, request, response);
    }

    protected void getCatalogs(PortletRequest request) {
        //String CATALOG_NAME = "WPSCatalog";
        WPSContext context = null;
        PortletSession session = request.getPortletSession(false);
        HttpSession hSession = request.getSession();
        PortletSettings settings = request.getPortletSettings();
        ItemCatalogForm itemCatalogUtilForm = new ItemCatalogForm();
        String selectedCatalogs = null;
        StringTokenizer tokenizer = null;
        String stringToken = null;
        String catalogName = null;
        List catalogList = null;
        HashMap attributeMap = null;
        int index = -1;
        Integer listBoxIndex = null;
        MessageMap messageMap = null;
        messageMap = getMessageMap(request);
        String catalog = request.getParameter("CATALOG_NAME");
        String attribute = request.getParameter("ATTR_NAME");
        
        String strWFFilter = (String)request.getParameter("CAT_FILTER");
        
        boolean isWFFilter = strWFFilter != null && (strWFFilter.equalsIgnoreCase("YES") || strWFFilter.equalsIgnoreCase("TRUE")) ? true :false;
        itemCatalogUtilForm.setWFFilter(isWFFilter);
        
        CatalogTree tree = itemCatalogUtilForm.getTree();

        if (session.getAttribute(CHILD_LENGTH) == null) {
            itemCatalogUtilForm.setChildLength(Long.toString(
                    DEFAULT_CHILD_LENGTH));
            session.setAttribute(CHILD_LENGTH,
                Long.toString(DEFAULT_CHILD_LENGTH));
        } else {
            itemCatalogUtilForm.setChildLength((String) session.getAttribute(
                    CHILD_LENGTH));
        }

        context = getWPSContext(request);

        WPCMediator mediator = WPCMediator.getInstance();
        CategoryHierarchy[] hierarchy = null;

        try {
            hierarchy = mediator.getCatalogs(context);
        } catch (WPCMediatorException e) {
            e.printStackTrace();
            handleException(e, request);

            return;
        }

        boolean flag = false;

        
            for (int i = 0; i < hierarchy.length; i++) {
                hierarchy[i].printMe();

                ItemNodeCatalog catalog1 = new ItemNodeCatalog("/0/" +
                        hierarchy[i].getCatalogName() + "/",
                        hierarchy[i].getCatalogName(), CatalogTree.CATALOG,
                        hierarchy[i].getCatalogName());

                if (!flag) {
                    itemCatalogUtilForm.setSelItem("/0/" +
                        hierarchy[i].getCatalogName() + "/");
                    flag = true;
                }

                catalog1.setExpanded(true);

                String[] hierarchyName = hierarchy[i].getHierarchy();
                String[] hierarchyType = hierarchy[i].getHierarchyType();

                for (int j = 0; j < hierarchyName.length; j++) {
                    ItemNodeCatalog hierarchyNode = new ItemNodeCatalog("/0/" +
                            hierarchy[i].getCatalogName() + "/" + hierarchyName[j],
                            hierarchyName[j], CatalogTree.HIERARCHY,
                            hierarchyName[j]);
                    hierarchyNode.setExpanded(false);

                    CategoryHierarchy hier = new CategoryHierarchy(hierarchy[i].getCatalogName(),
                            hierarchyName[j], hierarchyType[j],
                            "/0/" + hierarchy[i].getCatalogName() + "/" +
                            hierarchyName[j] + "");
                    hierarchyNode.setCategory(hier);
                    catalog1.add(hierarchyNode);
                }

                if (catalog.equals(catalog1.getDisplayName())) {
                    tree.addChild(tree.getRoot(), catalog1);
                }

                session.setAttribute(ITEMCATALOGFORM, itemCatalogUtilForm);
            }
        
        session.setAttribute(ItemCatalogUtilPortlet.ATTR_NAME, attribute);
    }
 
        

    public void actionPerformed(ActionEvent event) throws PortletException {
        PortletRequest request = event.getRequest();
        PortletSession session = request.getPortletSession();
        PortletSettings portletSettings = null;
        portletSettings = request.getPortletSettings();

        HttpSession hSession = request.getSession();
        String catalogName = null;
        StringBuffer selectedCatalogs = null;

        ItemCatalogForm itemCatalogUtilForm = (ItemCatalogForm) session.getAttribute(ITEMCATALOGFORM);

        String actionString = event.getActionString();

        String expandNode = null;
        String selectedNode = null;

        if (request.getParameter(NODEID) != null) {
            expandNode = request.getParameter(NODEID);
            selectedNode = request.getParameter(NODEID);
        } else {
            selectedNode = itemCatalogUtilForm.getSelItem();
        }

        String catalogId = null;
        String parentId = null;
        CategoryHierarchy hierarchy = null;

        //hierarchy = itemCatalogUtilForm.getSelectedNode().getCategory();
        // command to expand - collapse the catalog tree
        if (EXPAND_COMMAND.equals(actionString)) {
            CatalogTree tree = itemCatalogUtilForm.getTree();

            ItemNodeCatalog node = tree.searchNode(tree.getRoot(), expandNode);

            if (node != null) {
                if (node.isExpanded()) {
                    // collapse the node
                    node.setExpanded(false);
                } else {
                    // diplay the items under this catalog node
                    if (node.isLeaf()) {
                        displayExpandedNode(request, node);
                    } else if (node.getChildren() != null) {
                        node.setExpanded(true);
                    }
                }
            }

            return;
        }

        if (REFRESH.equals(actionString)) {
            session.removeAttribute(ITEMCATALOGFORM);
            getCatalogs(request);

            return;
        }

        if (SELECT_COMMAND.equals(actionString)) {
            if (selectedNode != null) {
                itemCatalogUtilForm.setSelItem(selectedNode);
            }

            return;
        }
    }

    protected void displayExpandedNode(PortletRequest request,
        ItemNodeCatalog node) {
        Node[] children = null;
        WPSContext context = null;
        context = getWPSContext(request);

        WPCMediator mediator = WPCMediator.getInstance();

        PortletSession session = request.getPortletSession();
        ItemCatalogForm itemCatalogUtilForm = (ItemCatalogForm) session.getAttribute(ITEMCATALOGFORM);
        String childLength = itemCatalogUtilForm.getChildLength();
        int childCount = 0;

        try {
            //			String path = node.getWpcID();
            String path = node.getPathFromLevel("///", 3);

            if ((path != null) && (path.length() >= 3)) {
                path = path.substring(3);
            }

            if (node.getLevel() <= 2) {
                path = "/";
            }

            CategoryHierarchy parentHier = node.getCategory();
            String catalogName = parentHier.getCatalogName();
            String[] hierName = parentHier.getHierarchy();
            String[] hierType = parentHier.getHierarchyType();

            children = mediator.getCatalogChildren(path, catalogName,
                    hierName[0], hierType[0], childLength, context);

            for (int i = 0; i < children.length; i++) {
                System.out.println("Children " + children[i].getDisplayName() +
                    " " + children[i].getId() + " " + children[i].getType());
                ++childCount;
            }
        } catch (WPCMediatorException me) {
            handleException(me, request);

            return;
        }

        if (children != null) {
            for (int i = 0; i < children.length; i++) {
                if (children[i] != null) {
                    String idToken = children[i].getId();
                    String type = children[i].getType();
                    if (ITEM.equalsIgnoreCase(type)) {
                        type = String.valueOf(CatalogTree.ITEM);
                    } else {
                        type = String.valueOf(CatalogTree.CATEGORY);
                    }

                    ItemNodeCatalog newItem = new ItemNodeCatalog(node.getId() +
                            "/" + idToken, idToken, Integer.parseInt(type),
                            children[i].getDisplayName());

                    node.add(newItem);

                    if (UNASSIGNED.equalsIgnoreCase(children[i].getType())) {
                        newItem.setCategory(new CategoryHierarchy(
                                node.getCategory().getCatalogName(),
                                node.getCategory().getHierarchy()[0],
                                UNASSIGNED, ""));
                    } else {
                        newItem.setCategory(node.getCategory());
                    }
                }
            }
        }

        int childLen = Integer.parseInt(itemCatalogUtilForm.getChildLength());

        MessageMap map = null;

        try {
            map = getMessageMap(request);
        } catch (Exception e1) {
            e1.printStackTrace();
        }

        node.setExpanded(true);

        if (childCount == childLen) {
            //display Info Message : Extend the maxmimum limit of
            // ({0})category/items displayed.
            map.addInfoMessage("MESSAGE_CODE_138", childLen + "");
        } else if (childCount == 0) {
            //display Info Message : No Content for {0}
            map.addInfoMessage("MESSAGE_CODE_139", node.getDisplayName());
            node.setExpanded(true);
        }
    }

    protected String getSelecteItemCatalogId(ItemCatalogForm catalogForm) {
        ItemNodeCatalog selNode = null;

        if (catalogForm != null) {
            selNode = catalogForm.getSelectedNode();

            if ((selNode != null) &&
                    (selNode.getType() == CatalogTree.CATALOG)) {
                return selNode.getDisplayName();
            } else if (selNode.getCategory() != null) {
                return selNode.getCategory().getCatalogName();
            }
        }

        return null;
    }

    protected String getSelectedCategoryParentId(ItemCatalogForm catalogForm) {
        ItemNodeCatalog selNode = null;

        if (catalogForm != null) {
            selNode = catalogForm.getSelectedNode();

            //			String path = selNode.getWpcID();
            String path = selNode.getPathFromLevel("///", 3);

            if ((path != null) && (path.length() >= 3)) {
                path = path.substring(3);
            }

            if (path.length() < 1) {
                path = "/";
            }

            return path;
        }

        return null;
    }

    protected String getSelectedItemParentId(ItemCatalogForm catalogForm) {
        ItemNodeCatalog selNode = null;

        if (catalogForm != null) {
            selNode = catalogForm.getSelectedNode();

            //String path = selNode.getParent().getWpcID();
            String path = selNode.getParent().getPathFromLevel("///", 3);

            if ((path != null) && (path.length() >= 3)) {
                path = path.substring(3);
            }

            if (path.length() < 1) {
                path = "/";
            }

            return path;
        }

        return null;
    }

    protected String getItemID(String path) {
        if (path != null) {
            if (path.lastIndexOf('/') != -1) {
                return path.substring(path.lastIndexOf('/') + 1);
            }
        }

        return null;
    }
}
