
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on May 23, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.ibm.ccd.ui.portlets.download;

import java.util.HashMap;
import java.util.Iterator;

import com.ibm.ccd.ui.dataobjects.CategoryHierarchy;
import com.ibm.ccd.ui.dataobjects.attributes.Attribute;
import com.ibm.ccd.ui.dataobjects.items.ICatalogItem;
import com.ibm.ccd.ui.mediator.ISoapMessageKeys;
import com.ibm.ccd.ui.mediator.XMLHelper;


/**
 * @author administrator
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class DownloadItemGenerator {
    public static String prepareDownloadItemRequestXML(
        CategoryHierarchy hierarchy, ICatalogItem catalogItem,
        String[] headerInfor, String[] itemPrimaryKey) {
        String catalogName = catalogItem.getCatalogID();
        boolean isHierarchyPresent = false;

        if (hierarchy != null) {
            isHierarchyPresent = true;
        }

        StringBuffer requestXML = new StringBuffer();

        requestXML.append(XMLHelper.WPC_NS_REF_BEG)
                  .append(ISoapMessageKeys.CATALOG_NAME).append(">")
                  .append(catalogName).append(XMLHelper.WPC_NS_REF_END)
                  .append(ISoapMessageKeys.CATALOG_NAME).append(">");

        if (isHierarchyPresent) {
            requestXML.append(XMLHelper.WPC_NS_REF_BEG)
                      .append(ISoapMessageKeys.CATEGORY_HIERARCHY + " ")
                      .append(ISoapMessageKeys.NAME + "=")
                      .append("\"" + hierarchy.getHierarchy()[0] + "\" ")
                      .append(ISoapMessageKeys.TYPE + "=")
                      .append("\"" + hierarchy.getHierarchyType()[0] + "\" ")
                      .append("/>");

            //.append(XMLHelper.WPC_NS_REF_BEG)
            //.append(ISoapMessageKeys.PARENT_CATEGORY)
            //.append(">")
            //.append(hierarchy.getParentPath())
            //.append(XMLHelper.WPC_NS_REF_END)
            //.append(ISoapMessageKeys.PARENT_CATEGORY)
            //.append(">");
        }

        if (itemPrimaryKey != null) {
            int itemSize = itemPrimaryKey.length;

            for (int i = 0; i < itemSize; i++) {
                requestXML.append(XMLHelper.WPC_NS_REF_BEG)
                          .append(ISoapMessageKeys.TRADE_ITEM + " ")
                          .append(ISoapMessageKeys.ID + "=\"")
                          .append(itemPrimaryKey[i] + "\"").append("/>");
            }
        }

        requestXML.append(prepareGeneratorHeader(catalogItem, headerInfor));

        return requestXML.toString();
    }

    private static String prepareGeneratorHeader(ICatalogItem catalogItem,
        String[] headerInfor) {
        StringBuffer requestXML = new StringBuffer();

        HashMap attribMap = catalogItem.getFlatAttributeMap();

        int itemSize = 0; //catalogItem.getAttributes().length;

        Iterator iter = attribMap.keySet().iterator();

        while (iter.hasNext()) {
            Attribute attrib = (Attribute) attribMap.get(iter.next());

            if (!attrib.isCategorySpecificAttribute()) {
                itemSize++;
            }
        }

        //boolean genAllHeader = ((itemSize == headerInfor.length) ? true : false);
		boolean genAllHeader = false;
		
        requestXML.append(XMLHelper.WPC_NS_REF_BEG).append(ISoapMessageKeys.ATTRIBUTELIST +
            " ");

        if (!genAllHeader) {
            requestXML.append(">").append(generateItemHeader(headerInfor))
                      .append(XMLHelper.WPC_NS_REF_END)
                      .append(ISoapMessageKeys.ATTRIBUTELIST).append(">");
        } else {
            requestXML.append("/>");
        }

        return requestXML.toString();
    }

    private static String generateItemHeader(String[] headerInfor) {
        StringBuffer requestXML = new StringBuffer();

        int itemSize = headerInfor.length;

        for (int i = 0; i < itemSize; i++) {
            requestXML.append(XMLHelper.WPC_NS_REF_BEG)
                      .append(ISoapMessageKeys.ATTRIBUTE + " ")
                      .append(ISoapMessageKeys.NAME + "=\"")
                      .append(headerInfor[i]).append("\"").append("/>");
        }

        return requestXML.toString();
    }
}
