
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on May 12, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.ibm.ccd.ui.portlets.download;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

import org.apache.jetspeed.portlet.PortletException;
import org.apache.jetspeed.portlet.PortletRequest;
import org.apache.jetspeed.portlet.PortletResponse;
import org.apache.jetspeed.portlet.PortletSession;
import org.apache.jetspeed.portlet.event.ActionEvent;
import org.apache.jetspeed.portlet.event.ActionListener;

import com.ibm.ccd.ui.dataobjects.CategoryHierarchy;
import com.ibm.ccd.ui.dataobjects.items.ICatalogItem;
import com.ibm.ccd.ui.exception.MessageMap;
import com.ibm.ccd.ui.mediator.WPCMediator;
import com.ibm.ccd.ui.mediator.WPCMediatorException;
import com.ibm.ccd.ui.portlets.BasePortlet;
import com.ibm.ccd.ui.portlets.alert.ITransactionDisplay;
import com.ibm.ccd.ui.util.IReference;


/**
 * @author administrator
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class DownloadPortlet extends BasePortlet implements ActionListener,
    IDownloadAction {
    private static final String MSG_ZERO_SELECTED = "MsgZeroSelected";
    private static final String MSG_ITEM_DOWNLOADING = "ItemDownloading";
    public static final String ITEMID_COMMA_SEPARATED = "ItemIds";
    private static final String DOWNLOADPORTLET_VIEW = "/jsps/html/download/DownloadPortletView.jsp";

    /**
     * @see org.apache.jetspeed.portlet.PortletAdapter#doView(org.apache.jetspeed.portlet.PortletRequest, org.apache.jetspeed.portlet.PortletResponse)
     */
    public void doView(PortletRequest request, PortletResponse response)
        throws PortletException, IOException {
        PortletSession session = request.getPortletSession();
        setBusinessFunction(request);

        String command = request.getParameter(COMMAND);

        if (DOWNLOAD_FROM_SINGLE.equals(command)) {
            displayDownloadView(request);
        } else if (DOWNLOAD_FROM_SEARCH.equals(command)) {
            displayDownloadView(request);
        } else if (DOWNLOAD_FROM_MASS.equals(command)) {
            displayDownloadView(request);
        }

        String jsp2Render = null;

        if (session.getAttribute(JSP2RENDER) != null) {
            jsp2Render = (String) session.getAttribute(JSP2RENDER);
        }

        if (jsp2Render == null) {
            jsp2Render = MESSAGEPAGE;
            setMessageHeader(request, null);
        } else {
            jsp2Render = DOWNLOADPORTLET_VIEW;

            if (session.getAttribute(COMMAND) != null) {
                command = (String) session.getAttribute(COMMAND);
            }

            setMessageHeader(request, command);
        }

        getPortletConfig().getContext().include(jsp2Render, request, response);
    }

    /**
     * @see org.apache.jetspeed.portlet.event.ActionListener#actionPerformed(org.apache.jetspeed.portlet.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent event) throws PortletException {
        PortletRequest request = event.getRequest();
        PortletSession session = request.getPortletSession();

        String actionString = event.getActionString();

        System.out.println("action Perfomred download " + actionString);

        if ((actionString != null) && GENERATE_EXCEL.equals(actionString)) {
            String[] selListValues = request.getParameterValues("tag");

            if ((selListValues == null) || (selListValues.length == 0)) {
                setMessageHeader(request, MSG_ZERO_SELECTED);

                return;
            }

            DownloadPortletBean dpbean = (DownloadPortletBean) session.getAttribute(DOWNLOAD_PORTLET_BEAN);
            dpbean.setSelectedHeader(selListValues);

            CategoryHierarchy categoryHier = null;

            if (session.getAttribute(HIER_NAME) != null) {
                String catalogId = (String) session.getAttribute(CATALOG);
                String parentId = (String) session.getAttribute(PARENTID);
                String hierName = (String) session.getAttribute(HIER_NAME);
                String hierType = (String) session.getAttribute(HIER_TYPE);

                categoryHier = new CategoryHierarchy(catalogId, hierName,
                        hierType, parentId);
            }

            System.out.println(DownloadItemGenerator.prepareDownloadItemRequestXML(
                    categoryHier, dpbean.getCatalogItem(), selListValues,
                    dpbean.getItemSelectedPrimaryKey()));

            try {
                WPCMediator.getInstance().downloadItemDetails(categoryHier,
                    dpbean.getCatalogItem(), selListValues,
                    dpbean.getItemSelectedPrimaryKey(), getWPSContext(request));
            } catch (WPCMediatorException e) {
                String alertMessage = getTextMessages(request,
                        "MESSAGE_CODE_408");

                request.setAttribute(ITransactionDisplay.TRANSACTION_DESCRIPTION_KEY,
                    alertMessage);
                handleException(e, request);
                setMessageHeader(request, MSG_ITEM_DOWNLOADING);
                session.setAttribute(JSP2RENDER, null);
            } finally {
                session.setAttribute(JSP2RENDER, null);
            }
        } else if ((actionString != null) &&
                GENERATE_CANCEL.equals(actionString)) {
            session.setAttribute(JSP2RENDER, null);
        }
    }

    /**
     *
     * @param request
     * @throws PortletException
     */
    public void displayDownloadView(PortletRequest request)
        throws PortletException {
        PortletSession session = request.getPortletSession();
        session.setAttribute(COMMAND, request.getParameter(COMMAND));
        session.setAttribute(JSP2RENDER, DOWNLOADPORTLET_VIEW);

        String catalogID = request.getParameter(CATALOG);
        String parentID = (request.getParameter(PARENTID) != null)
            ? request.getParameter(PARENTID) : "";
        String hierName = (request.getParameter(HIER_NAME) != null)
            ? request.getParameter(HIER_NAME) : "";
        String hierType = (request.getParameter(HIER_TYPE) != null)
            ? request.getParameter(HIER_TYPE) : "";

        if (parentID.equals("")) {
            parentID = "/";
        }

        String itemIDval = request.getParameter(ITEMID);
        String[] itemids = tokenizeItemID(itemIDval);

        session.setAttribute(CATALOG, catalogID);
        session.setAttribute(PARENTID, parentID);
        session.setAttribute(HIER_NAME, hierName);
        session.setAttribute(HIER_TYPE, hierType);
        session.setAttribute(ITEMID, itemids);
        session.setAttribute(ITEMID_COMMA_SEPARATED, itemIDval);

        ICatalogItem item = null;
        WPCMediator mediator = null;

        try {
            mediator = WPCMediator.getInstance();
            item = mediator.getCatalogItem(parentID, catalogID,
                    getWPSContext(request));
        } catch (WPCMediatorException e) {
            e.printStackTrace();
        }

        DownloadPortletBean dpBean = new DownloadPortletBean(item, itemids);

        session.setAttribute(DOWNLOAD_PORTLET_BEAN, dpBean);
    }

    /**
     * @see com.ibm.ccd.ui.portlets.BasePortlet#setBusinessFunction(org.apache.jetspeed.portlet.PortletRequest)
     */
    protected void setBusinessFunction(PortletRequest portletRequest) {
        PortletSession session = portletRequest.getPortletSession();

        session.setAttribute(IReference.SESSION_BUS_FUNCT, "DOWNLOAD");
        session.setAttribute(IReference.SESSION_ACTION, "VIEW");
    }

    /**
     *
     * @param request
     * @param command
     */
    protected void setMessageHeader(PortletRequest request, String command) {
        MessageMap map = null;

		if (request.getAttribute(IReference.MESSAGE_KEY) != null) {
					map = (MessageMap) request.getAttribute(IReference.MESSAGE_KEY);
		} else {
	        try {
	            map = getMessageMap(request);
	        } catch (Exception e) {
	            e.printStackTrace();
	
	            return;
	        }
		}

        if (command != null) {
            if (command.equals(DOWNLOAD_FROM_SINGLE)) {
                //MESSAGE_CODE_403=Item viewed from Work withItem/Single Edit				
                map.addInfoMessage("MESSAGE_CODE_403");
            } else if (command.equals(DOWNLOAD_FROM_SEARCH)) {
                //MESSAGE_CODE_404=Item viewed from Search result
                map.addInfoMessage("MESSAGE_CODE_404");
            } else if (command.equals(DOWNLOAD_FROM_MASS)) {
                //MESSAGE_CODE_405=Item viewed from Mass edit 
                map.addInfoMessage("MESSAGE_CODE_405");
            } else if (command.equals(MSG_ZERO_SELECTED)) {
                //MESSAGE_CODE_402=Select atleast one attribute name as download header.
                map.addErrorMessage("MESSAGE_CODE_402");
            } else if (command.equals(MSG_ITEM_DOWNLOADING)) {
                //map.addErrorMessage("MESSAGE_CODE_402");
                //map.addInfoMessage("MESSAGE_CODE_407",
                  //  (String) request.getAttribute(ITEMID_COMMA_SEPARATED));
            }
        } else {
            //MESSAGE_CODE_401 : To download Item(s), select the items from search result / Mass upload screen, and click download. Alternately, click download button from workwithItem Portlet.
            map.addInfoMessage("MESSAGE_CODE_401");
        }
    }

    /**
     *
     * @param input
     * @return
     */
    private String[] tokenizeItemID(String input) {
        StringTokenizer tokenizer = new StringTokenizer(input, ",");

        List lst = null;

        if (tokenizer.hasMoreTokens()) {
            lst = new ArrayList();
        } else {
            return null;
        }

        while (tokenizer.hasMoreTokens()) {
            lst.add(tokenizer.nextToken());
        }

        String[] out = new String[lst.size()];

        return (String[]) lst.toArray(out);
    }
}
