
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on May 17, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.ibm.ccd.ui.portlets.download;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

import com.ibm.ccd.ui.dataobjects.CategoryHierarchy;
import com.ibm.ccd.ui.dataobjects.attributes.Attribute;
import com.ibm.ccd.ui.dataobjects.items.ICatalogItem;


/**
 * @author administrator
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class DownloadPortletBean {
    private CategoryHierarchy hierarchy;
    private ICatalogItem catalogItem;
    private String[] itemSelectedPrimaryKey;
    private ArrayList downloadPortletHeader;

    public DownloadPortletBean(ICatalogItem catalogItem,
        String[] itemSelectedPrimaryKey) {
        this(null, catalogItem, itemSelectedPrimaryKey);
    }

    public DownloadPortletBean(CategoryHierarchy hierarchy,
        ICatalogItem catalogItem, String[] itemSelectedPrimaryKey) {
        this.hierarchy = hierarchy;
        this.catalogItem = catalogItem;
        this.itemSelectedPrimaryKey = itemSelectedPrimaryKey;

        setDownloadPorletHeader();
    }

    /**
     *
     * @param primaryKeys
     */
    public void setItemSelectedPrimaryKey(String[] primaryKeys) {
        itemSelectedPrimaryKey = primaryKeys;
    }

    /**
     * @return
     */
    public String[] getItemSelectedPrimaryKey() {
        return itemSelectedPrimaryKey;
    }

    protected void setDownloadPorletHeader() {
        if (catalogItem != null) {
            Map attribMap = catalogItem.getDownloadAttributeMap();

            Attribute primaryAttrib = catalogItem.getPrimaryKeyAttr(catalogItem.getAttributes());
            String primaryAttribName = primaryAttrib.getName();

            Set attribNames = attribMap.keySet();

            Iterator iter = attribNames.iterator();

            String name = null;
            String displayName = null;

            downloadPortletHeader = new ArrayList();

            while (iter.hasNext()) {
                name = (String) iter.next();
				
				Attribute attrib = (Attribute)attribMap.get(name);

				String dname = attrib.getDisplayLabelName();
				
                int name_slash_index = dname.lastIndexOf('/');

                if (name_slash_index != -1) {
						displayName = dname.substring(name_slash_index + 1);
                } else {
                    displayName = dname;
                }
                
                if(attrib.isLocalized()) {
                	displayName = attrib.getDisplayLabelName();
                }

                if (name.equals(primaryAttribName)) {
                    downloadPortletHeader.add(new DownloadHeaderInfo(name,
                            displayName, true));
                } else {
                    downloadPortletHeader.add(new DownloadHeaderInfo(name,
                            displayName));
                }
            }
        }
    }

    public void setSelectedHeader(String[] selectedNameList) {
        if (selectedNameList != null) {
            /**
             * deSelect all the selected name from the list
             */
            deSelectHeader();

            for (int i = 0; i < selectedNameList.length; i++) {
                setSelectedHeader(selectedNameList[i]);
            }
        }
    }

    private void setSelectedHeader(String selectedName) {
        Iterator iter = downloadPortletHeader.iterator();
        DownloadHeaderInfo headerInfo = null;

        while (iter.hasNext()) {
            headerInfo = (DownloadHeaderInfo) iter.next();

            if (headerInfo.getName().equals(selectedName)) {
                headerInfo.setSelected(true);
            }
        }
    }

    private void deSelectHeader() {
        Iterator iter = downloadPortletHeader.iterator();
        DownloadHeaderInfo headerInfo = null;

        while (iter.hasNext()) {
            headerInfo = (DownloadHeaderInfo) iter.next();
            headerInfo.setSelected(false);
        }
    }

    /**
     * @return
     */
    public ICatalogItem getCatalogItem() {
        return catalogItem;
    }

    /**
     * @return
     */
    public ArrayList getDownloadPortletHeader() {
        return downloadPortletHeader;
    }

    /**
     * @return
     */
    public CategoryHierarchy getHierarchy() {
        return hierarchy;
    }

    /**
     * @param hierarchy
     */
    public void setHierarchy(CategoryHierarchy hierarchy) {
        this.hierarchy = hierarchy;
    }
}
