
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Nov 26, 2004
 */
package com.ibm.ccd.ui.portlets.fileupload;


/**
 * This interface contains the all the constants used by FileUoload from Portlet
 */
public interface IFileUpload {
    /**
     *Indicates the name of form action in doView
     */
    String FORM_ACTION_FILE_UPLOAD = "FORM_ACTION_FILE_UPLOAD"; //$NON-NLS-1$

    /**
     * Indicates the name of form action for configuration page.
     */
    String FORM_ACTION_CONFIG = "FORM_ACTION_EDIT"; //$NON-NLS-1$

    /**
     * Indicates the key for storing view bean name used for data transfer
     */
    String FILE_UPLOAD_BEAN = "FILE_UPLOAD_BEAN"; //$NON-NLS-1$

    /**
     *Indicates the key for property protocol used for file transfer
     */
    String PROPERTY_PROTOCOL = "PROTOCOL"; //$NON-NLS-1$

    /**
     *Indicates the key for property user
     */
    String PROPERTY_FTP_USER = "FTP_USER"; //$NON-NLS-1$

    /**
     *Indicates the key for property password of FTP server
     */
    String PROPERTY_FTP_PASSWORD = "FTP_PASSWORD"; //$NON-NLS-1$

    /**
     *Indicates the key for property ftp host server IP
     */
    String PROPERTY_FTP_HOST = "FTP_HOST"; //$NON-NLS-1$

    /**
     * Indiactes the key for property port of FTP server
     */
    String PROPERTY_FTP_PORT = "FTP_PORT"; //$NON-NLS-1$

    /**
     * Indicates the key for proprty destination folder for FTP file transfer.
     */
    String PROPERTY_FTP_FOLDER = "FTP_FOLDER"; //$NON-NLS-1$

    /**
     *Indicates the constant if user selects to upload file to FTP server
     */
    String PROTOCOL_FTP = "FTP"; //$NON-NLS-1$

    /**
     * Indicates the constant if user selects to upload file vai SOAP message
     */
    String PROTOCOL_SOAP = "SOAP"; //$NON-NLS-1$

    /**
     *Indicates the default user for FTP server
     */
    String DEFAULT_FTP_USER = "anonymous"; //$NON-NLS-1$

    /**
     *Indicates the password for default user for FTP server
     */
    String DEFAULT_FTP_PASSWPORD = ""; //$NON-NLS-1$

    /**
    * Indicates the default port for FTP server
    */
    String DEFAULT_FTP_PPORT = "21"; //$NON-NLS-1$

    /**
     * This constant is placeholder for seperating FTP host address and port
     */
    String SEPERATOR_SPACE = " "; //$NON-NLS-1$

    /**
     * Indicates the key for file name
     */
    String PROPERTY_FILE_NAME = "FILE_NAME"; //$NON-NLS-1$

    /**
     * Indicates the proprty URL of proxy server.
     */
    String PROPERTY_PROXY_URL = "PROXY_URL"; //$NON-NLS-1$

    /**
     * Indicates the proprty port of proxy server.
     */
    String PROPERTY_PROXY_PORT = "PROXY_PORT"; //$NON-NLS-1$

    /**
     * Indicates the property user name for proxy server authentication
     */
    String PROPERTY_PROXY_USER = "PROXY_USER"; //$NON-NLS-1$

    /**
     * Indicates the property password for proxy server authentication
     */
    String PROPERTY_PROXY_PASSWORD = "PROXY_PASSWORD"; //$NON-NLS-1$

    /**
     *Indicates the key for proxy ftp host
     */
    String PROPERTY_PROXY_FTP_HOST = "deployment.proxy.ftp.host"; //$NON-NLS-1$

    /**
     *Indicates the key for proxy ftp port
     */
    String PROPERTY_PROXY_FTP_PORT = "deployment.proxy.ftp.port"; //$NON-NLS-1$

    /**
     * Indicates the path of file upload view.jsp page.
     */
    String PATH_FILE_UPLOAD_VIEW_JSP = "/jsps/html/fileupload/FileUploadPortletView.jsp"; //$NON-NLS-1$

    /**
     * Indicates the path of file upload view jsp page.
     */
    String PATH_FILE_UPLOAD_CONFIG_JSP = "/jsps/html/fileupload/FileUploadPortletConfig.jsp"; //$NON-NLS-1$

    /**
     * Indicates the path of file upload view jsp page.
     */
    String PATH_FILE_UPLOAD_HELP_JSP = "/jsps/html/fileupload/FileUploadPortletHelp.jsp"; //$NON-NLS-1$

    /**
     * Indicates the business function <i>file upload</i>
     */
    String BUSINESS_FUNCTION_FILE_UPLOAD = "FILE_UPLOAD"; //$NON-NLS-1$

    /**
     * Indicates the bsuiness action <i>config</i>
     */
    String BUSINESS_ACTION_CONFIG = "CONFIG"; //$NON-NLS-1$

    /**
     * Indicates the bsuiness action <i>config</i>
     */
    String BUSINESS_ACTION_VIEW = "VIEW"; //$NON-NLS-1$

    /**
     * settings saved
     */
    String MSG_FILE_UPLOAD_CONFIG_SAVED = "MESSAGE_CODE_201"; //$NON-NLS-1$

    /**
     * key for general mesage to point user on view page
     */
    String MSG_VIEW_LINK = "MESSAGE_CODE_202"; //$NON-NLS-1$

    /**
     * key for general mesage to point user on help page
     */
    String MSG_HELP_LINK = "MESSAGE_CODE_203"; //$NON-NLS-1$

    /**
     * key for  the message that field is mandatory
     */
    String MSG_FILED_MANDATORY = "MESSAGE_CODE_110"; //$NON-NLS-1$

    /**
     * key for the message that FTp host is invalid
     */
    String MSG_INVALID_FTP_HOST = "MESSAGE_CODE_205"; //$NON-NLS-1$

    /**
     * key for message invalid FTP user
     */
    String MSG_INVALID_FTP_USER = "MESSAGE_CODE_206"; //$NON-NLS-1$

    /**
     * key for message invalid FTP filder
     */
    String MSG_INVALID_FTP_FOLDER = "MESSAGE_CODE_207"; //$NON-NLS-1$

    /**
     * key for retriving success message from resource bundle
     */
    String MSG_FILE_UPLOAD_SUCCESS = "MESSAGE_CODE_208"; //$NON-NLS-1$

    /**
     * key for message upload failed
     */
    String MSG_FILE_UPLOAD_FAILED = "MESSAGE_CODE_209"; //$NON-NLS-1$

    /**
     * key for information message on view page
     */
    String MSG_VIEW_INFO_MESSAGE = "MESSAGE_CODE_210"; //$NON-NLS-1$

    /**
     * key for message to select fiie
     */
    String MSG_SELECT_FILE = "MESSAGE_CODE_211"; //$NON-NLS-1$

    /**
     * key for message file not found
     */
    String MSG_FILE_NOT_FOUND = "MESSAGE_CODE_212"; //$NON-NLS-1$

    /**
     * key for message file not found
     */
    String MSG_TRANSACTION_DESCRIPTION = "MESSAGE_CODE_213"; //$NON-NLS-1$

    /**
     * contains the constant for adding sngle quote
     */
    String QUOTES = "\'";
}
