
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Nov 26, 2004
 */
package com.ibm.ccd.ui.portlets.fileupload;

import java.io.File;


/**
 *A class to hold information about an uploaded file
 */
public class UploadedFile {
    /**
     *  contains the fle names
     */
    private String filename;

    /**
     * contians type
     */
    private String type;

    /**
     * constructor
     * @param filename
     * @param type
     */
    UploadedFile(String pFilename, String pType) {
        this.filename = pFilename;
        this.type = pType;
    }

    /**
     * returns the content type of file
     * @return String
     */
    public String getContentType() {
        return type;
    }

    /**
     * returns the file name
     * @return String
     */
    public String getFilesystemName() {
        return filename;
    }

    /**
     * reurns the file
     * @return File
     */
    public File getFile() {
        if (filename == null) {
            return null;
        } else {
            return new File(File.separator + filename);
        }
    }
}
