package com.ibm.ccd.ui.portlets.helper;

import java.util.Enumeration;
import java.util.Properties;

import javax.servlet.http.HttpSession;

import org.apache.jetspeed.portlet.PortletConfig;
import org.apache.jetspeed.portlet.PortletContext;
import org.apache.jetspeed.portlet.PortletRequest;
import org.apache.jetspeed.portlet.User;


import com.ibm.ccd.ui.cache.CacheConstants;
import com.ibm.ccd.ui.cache.CacheManager;
import com.ibm.ccd.ui.cache.CacheNotEnabledException;
import com.ibm.ccd.ui.context.IWPCUser;
import com.ibm.ccd.ui.context.WPCUser;
import com.ibm.ccd.ui.context.WPSContext;
import com.ibm.ccd.ui.mediator.ConfigManager;
import com.ibm.ccd.ui.mediator.WPCMediator;
import com.ibm.ccd.ui.services.user.UserBean;
import com.ibm.ccd.ui.services.user.UserManager;

/**
 * @author Administrator
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class PortletHelper {
	
	private PortletContext portletContext = null;
	private PortletConfig portletConfig = null;
	
	public PortletHelper(){
	}
	
	public PortletHelper(PortletConfig config){
		
		this.portletConfig = config;
		this.portletContext = config.getContext();
	}
	
	public WPSContext getWPSContext(PortletRequest request) {
		
		WPSContext context = null;
		CacheManager cManager = null;

		User user = request.getUser();

		long lastLogin = user.getLastLoginTime();
		try{
			cManager = CacheManager.getInstance();
		} catch (CacheNotEnabledException e){
			e.printStackTrace();
		}
		
		String userKey = CacheConstants.USER_CONTEXT;
		String key = (String) user.getAttribute(IWPCUser.KEY_USER_ID);
		key = key + "_" + lastLogin;
		System.out.println("initial key value is " + key);
		PortletContext portletCtx = getPortletContext();

		//if ((CacheManager.isCacheEnabled() && cManager.isCached(userKey, key)) || portletCtx.getAttribute(key) != null) {
		context = CacheManager.isCacheEnabled() ? (WPSContext) cManager.getFromCache(userKey, key):(WPSContext) portletCtx.getAttribute(key); 
		if (context == null) {

			context = createContext(request);
			if(CacheManager.isCacheEnabled())
				cManager.putInCache(userKey, key, context);
			else 				
				portletCtx.setAttribute(key,context);
			
		}
		return context;
	}

	/**
	 * @param request
	 * @return
	 */
	public WPSContext createContext(PortletRequest request) {

		HttpSession httpSession = null;
		User portalUser = null;
		WPCUser wpcUser = null;
		WPSContext context = null;
		Enumeration userAttributes = null;
		WPCMediator mediator = null;
		String catalogId = null;
		String catalogNode = null;
		//retrive data from User object
		portalUser = request.getUser();

		String strUserID = (String) portalUser.getAttribute("uid");
		Properties ldapProp = ConfigManager.getInstance().getLdapProp();

		if (ConfigManager.getInstance().isLdapEnabled()) {
			UserManager userManager = UserManager.getInstance();
			UserBean userBean = new UserBean();
			userBean.setUserName(strUserID);
			//   Retrieve User's details from the LDAP
			UserBean userDetails = null;
			userDetails = userManager.validateLoginUser(userBean);

			wpcUser = new WPCUser();
			wpcUser.setProperty(IWPCUser.KEY_USER_ID,userDetails.getUserName());
			wpcUser.setProperty(IWPCUser.KEY_PASSWORD,userDetails.getPassword());
			wpcUser.setProperty(IWPCUser.KEY_COMPANY,userDetails.getCompany());
			wpcUser.setProperty(IWPCUser.KEY_SUPPLIER_GLN,userDetails.getSupplierGLN());
			wpcUser.setProperty(IWPCUser.KEY_WPC_USERNAME,userDetails.getWpcUserName());
			wpcUser.setProperty(IWPCUser.KEY_PREFERRED_LANGUAGE,userDetails.getPreferredLanguage());
			wpcUser.setProperty(IWPCUser.KEY_RESTRICTED_LANGUAGE,userDetails.getRestrictedLanguage());

		} else {
			wpcUser = new WPCUser();
			wpcUser.setProperty(IWPCUser.KEY_USER_ID,ldapProp.get(IWPCUser.KEY_USER_ID));
			wpcUser.setProperty(IWPCUser.KEY_PASSWORD,ldapProp.get(IWPCUser.KEY_PASSWORD));
			wpcUser.setProperty(IWPCUser.KEY_COMPANY,ldapProp.get(IWPCUser.KEY_COMPANY));
			wpcUser.setProperty(IWPCUser.KEY_SUPPLIER_GLN,ldapProp.get(IWPCUser.KEY_SUPPLIER_GLN));
			wpcUser.setProperty(IWPCUser.KEY_WPC_USERNAME,ldapProp.get(IWPCUser.KEY_WPC_USERNAME));
			wpcUser.setProperty(IWPCUser.KEY_PREFERRED_LANGUAGE,ldapProp.get(IWPCUser.KEY_PREFERRED_LANGUAGE));
			wpcUser.setProperty(IWPCUser.KEY_RESTRICTED_LANGUAGE,ldapProp.get(IWPCUser.KEY_RESTRICTED_LANGUAGE));
		} 

		//// BEGIN REMOVE
		//wpcUser = new WPCUser();
		//wpcUser.setProperty(IWPCUser.KEY_USER_ID, "admin");
		//wpcUser.setProperty(IWPCUser.KEY_WPC_USERNAME, "Admin");
		//wpcUser.setProperty(IWPCUser.KEY_SUPPLIER_GLN, "C4");
		//wpcUser.setProperty(IWPCUser.KEY_PREFERRED_LANGUAGE, "fr_FR");
		//wpcUser.setProperty(IWPCUser.KEY_RESTRICTED_LANGUAGE, "fr_FR");	
		//// END REMOVE
		mediator = WPCMediator.getInstance();
		catalogId = mediator.getDefaultCatalog();
		/*
		 * Set the catalog for a user. If there was a catalog already set for a user, then re-use it. 
		 * This is required because the context object is created for every call.
		 */
		PortletContext portletContext = getPortletContext();
		WPSContext wpsContext =	((WPSContext) portletContext.getAttribute(strUserID));
		if (wpsContext != null) {
			
			String currentCatalogID = (String) wpsContext.getWpcUser().getProperty(IWPCUser.KEY_WPC_CATALOGUE_NAME);
			catalogId =	(currentCatalogID != null)? currentCatalogID : mediator.getDefaultCatalog();
			String currentCatalogNode =	(String) wpsContext.getWpcUser().getProperty(IWPCUser.KEY_WPC_CATALOGUE_NODE);
			if (currentCatalogNode != null) 
				catalogNode = currentCatalogNode;
		}

		wpcUser.setProperty(IWPCUser.KEY_WPC_CATALOGUE_NAME, catalogId);
		wpcUser.setProperty(IWPCUser.KEY_WPC_CATALOGUE_NODE, catalogNode);

		//set the user in context
		context = new WPSContext();
		context.setWpcUser(wpcUser);
		return context;
	}
	
	
	/**
	 * @return Returns the portletConfig.
	 */
	public PortletConfig getPortletConfig() {
		return portletConfig;
	}
	/**
	 * @param portletConfig The portletConfig to set.
	 */
	public void setPortletConfig(PortletConfig portletConfig) {
		this.portletConfig = portletConfig;
	}
	/**
	 * @return Returns the portletContext.
	 */
	public PortletContext getPortletContext() {
		return portletContext;
	}
	/**
	 * @param portletContext The portletContext to set.
	 */
	public void setPortletContext(PortletContext portletContext) {
		this.portletContext = portletContext;
	}
}
