
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Jul 29, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.ibm.ccd.ui.portlets.items;

import java.net.MalformedURLException;
import java.net.URL;

import org.apache.jetspeed.portlet.PortletRequest;
import org.apache.jetspeed.portlet.PortletSession;

import com.ibm.ccd.ui.dataobjects.FileUploadResource;
import com.ibm.ccd.ui.dataobjects.NVPair;
import com.ibm.ccd.ui.dataobjects.attributes.Attribute;
import com.ibm.ccd.ui.dataobjects.attributes.AttributeTypes;
import com.ibm.ccd.ui.dataobjects.attributes.BinaryAttribute;
import com.ibm.ccd.ui.dataobjects.attributes.CurrencyAttribute;
import com.ibm.ccd.ui.dataobjects.attributes.DateAttribute;
import com.ibm.ccd.ui.dataobjects.attributes.FlagAttribute;
import com.ibm.ccd.ui.dataobjects.attributes.GroupAttribute;
import com.ibm.ccd.ui.dataobjects.attributes.ImageAttribute;
import com.ibm.ccd.ui.dataobjects.attributes.ImageURLAttribute;
import com.ibm.ccd.ui.dataobjects.attributes.IntegerAttribute;
import com.ibm.ccd.ui.dataobjects.attributes.LookupTableAttribute;
import com.ibm.ccd.ui.dataobjects.attributes.NumberAttribute;
import com.ibm.ccd.ui.dataobjects.attributes.NumberEnumAttribute;
import com.ibm.ccd.ui.dataobjects.attributes.PasswordAttribute;
import com.ibm.ccd.ui.dataobjects.attributes.PeriodAttribute;
import com.ibm.ccd.ui.dataobjects.attributes.RelationshipAttribute;
import com.ibm.ccd.ui.dataobjects.attributes.SequenceAttribute;
import com.ibm.ccd.ui.dataobjects.attributes.StringAttribute;
import com.ibm.ccd.ui.dataobjects.attributes.StringEnumAttribute;
import com.ibm.ccd.ui.dataobjects.attributes.ThumbnailImageAttribute;
import com.ibm.ccd.ui.dataobjects.attributes.ThumbnailImageURLAttribute;
import com.ibm.ccd.ui.dataobjects.attributes.TimeZoneAttribute;
import com.ibm.ccd.ui.dataobjects.attributes.URLAttribute;
import com.ibm.ccd.ui.dataobjects.items.CatalogItem;
import com.ibm.ccd.ui.portlets.catalog.ICatalogAction;
import com.ibm.ccd.ui.tags.element.IHTMLRenderer;


/**
 * @author administrator
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class WorkwithItemHandler implements ICatalogAction {
	public void invokeAttributeAdd(PortletRequest request) {
		PortletSession session = request.getPortletSession();

		String attribParam = request.getParameter(IHTMLRenderer.ATTRIB_PARAM);

		int lastIndex_V = attribParam.lastIndexOf("_V");

		if (lastIndex_V != -1) {
			attribParam = attribParam.substring(1, lastIndex_V);
		} else {
			attribParam = attribParam.substring(1);
		}

		CatalogItem citem = (CatalogItem) session.getAttribute(ITEM);

		Attribute attribute = null;
		try {
			attribute = citem.getAttributeFromGroupPath(attribParam);
		} catch (Exception e1) {
			e1.printStackTrace();
			return;
		}
		
		switch (attribute.getType()) {
		case AttributeTypes.URL: {
			URLAttribute urlAttrib = (URLAttribute) attribute;

				if (urlAttrib.getDefaultValue() != null) {
					urlAttrib.setValue(urlAttrib.getDefaultValue());
				} else {
					urlAttrib.setValue(null);
				}

			break;
		}

		case AttributeTypes.STRING: {
			StringAttribute stringAttrib = (StringAttribute) attribute;
			stringAttrib.setValue("");

			break;
		}

		case AttributeTypes.FLAG: {
			FlagAttribute flagAttrib = (FlagAttribute) attribute;
			String flagDefaultValue = flagAttrib.getDefaultValue(); 
			flagAttrib.setValue((flagDefaultValue != null)?flagDefaultValue : "");

			break;
		}

		case AttributeTypes.GROUP: {
			GroupAttribute groupAttrib = (GroupAttribute) attribute;
			groupAttrib.setValue(groupAttrib.cloneValue());

			break;
		}

		case AttributeTypes.INTEGER: {
			IntegerAttribute integerAttribute = (IntegerAttribute) attribute;
			integerAttribute.setValue(integerAttribute.getDefaultValue());

			break;
		}

		case AttributeTypes.NUMBER: {
			NumberAttribute numberAttribute = (NumberAttribute) attribute;
			numberAttribute.setValue(numberAttribute.getDefaultValue());

			break;
		}

		case AttributeTypes.DATE: {
			DateAttribute dateAttribute = (DateAttribute) attribute;
			dateAttribute.setValue("");

			break;
		}

		case AttributeTypes.TIMEZONE: {
			TimeZoneAttribute timezoneAttribute = (TimeZoneAttribute) attribute;
			timezoneAttribute.setValue("");

			break;
		}

		case AttributeTypes.CURRENCY: {
			CurrencyAttribute currencyAttribute = (CurrencyAttribute) attribute;
			currencyAttribute.setValue("");

			break;
		}

		case AttributeTypes.PASSWORD: {
			PasswordAttribute passwordAttribute = (PasswordAttribute) attribute;
			passwordAttribute.setValue("");

			break;
		}

		case AttributeTypes.PERIOD: 	{
			PeriodAttribute periodAttribute = (PeriodAttribute) attribute;
			periodAttribute.setValue("","");
			break;
		}

		case AttributeTypes.SEQUENCE: {
			SequenceAttribute sequenceAttribute = (SequenceAttribute) attribute;
			sequenceAttribute.setValue("");

			break;
		}

		case AttributeTypes.BINARY: {
			BinaryAttribute binaryAttribute = (BinaryAttribute) attribute;
			binaryAttribute.setValue(new FileUploadResource());

			break;
		}

		case AttributeTypes.IMAGE: {
			ImageAttribute imageAttribute = (ImageAttribute) attribute;
			imageAttribute.setValue(new FileUploadResource());

			break;
		}

		case AttributeTypes.THUMB_NAIL_IMAGE: {
			ThumbnailImageAttribute thumbnailImageAttribute = (ThumbnailImageAttribute) attribute;
			thumbnailImageAttribute.setValue(new FileUploadResource());

			break;
		}

		case AttributeTypes.IMAGE_URL: {
			ImageURLAttribute imageURLAttribute = (ImageURLAttribute) attribute;
			if(imageURLAttribute.getDefaultValue() != null){
				imageURLAttribute.setValue(imageURLAttribute.getDefaultValue());
			} else { 
				imageURLAttribute.setValue(null);
			}	

			break;
		}

		case AttributeTypes.THUMB_NAIL_IMAGE_URL: {
			ThumbnailImageURLAttribute thumbnailImageURLAttribute = (ThumbnailImageURLAttribute) attribute;
			if(thumbnailImageURLAttribute.getDefaultValue() != null) {
				thumbnailImageURLAttribute.setValue(thumbnailImageURLAttribute.getDefaultValue());
			} else {
				thumbnailImageURLAttribute.setValue(null);
			}
	
			break;
		}

		case AttributeTypes.STRING_ENUMERATION: {
			StringEnumAttribute StringEnumerationAttribute = (StringEnumAttribute) attribute;
			StringEnumerationAttribute.setValue("");

			break;
		}

		case AttributeTypes.NUMBER_ENUMERATION: {
			NumberEnumAttribute numberEnumAttribute = (NumberEnumAttribute) attribute;
			numberEnumAttribute.setValue(numberEnumAttribute.getDefaultValue());

			break;
		}

		case AttributeTypes.RELATIONSHIP: {
			RelationshipAttribute relationshipAttribute = (RelationshipAttribute) attribute;
			relationshipAttribute.setValue(new NVPair());
		}

		case AttributeTypes.LOOKUP_TABLE: {
			LookupTableAttribute lookupTableAttribute = (LookupTableAttribute) attribute;
			lookupTableAttribute.setValue(lookupTableAttribute.getDefaultValue());
		}
		}
	}

	public void invokeAttributeRemove(PortletRequest request) {
		PortletSession session = request.getPortletSession();

		String attribParam = request.getParameter(IHTMLRenderer.ATTRIB_PARAM);

		int lastIndex_V = attribParam.lastIndexOf("_V");

		if (lastIndex_V != -1) {
			attribParam = attribParam.substring(1, lastIndex_V);
		} else {
			attribParam = attribParam.substring(1);
		}

		CatalogItem citem = (CatalogItem) session.getAttribute(ITEM);
		String attribIndex = CatalogItem.getAttributeOcc(attribParam);
//		  Attribute attribute = (Attribute) citem.getAttributeFromPath(attribParam);

		Attribute attribute = null;
		
		try {
			attribute = citem.getAttributeFromGroupPath(attribParam);
		} catch (Exception e1) {
			e1.printStackTrace();
			return;
		}
		switch (attribute.getType()) {
		case AttributeTypes.URL: {
			URLAttribute urlAttrib = (URLAttribute) attribute;
			urlAttrib.removeValue(Integer.parseInt(attribIndex));

			break;
		}

		case AttributeTypes.STRING: {
			StringAttribute stringAttrib = (StringAttribute) attribute;
			stringAttrib.removeValue(Integer.parseInt(attribIndex));

			break;
		}

		case AttributeTypes.FLAG: {
			FlagAttribute flagAttrib = (FlagAttribute) attribute;
			flagAttrib.removeValue(Integer.parseInt(attribIndex));

			break;
		}

		case AttributeTypes.GROUP: {
			GroupAttribute groupAttrib = (GroupAttribute) attribute;
			groupAttrib.removeValue(Integer.parseInt(attribIndex));

			break;
		}

		case AttributeTypes.INTEGER: {
			IntegerAttribute integerAttribute = (IntegerAttribute) attribute;
			integerAttribute.removeValue(Integer.parseInt(attribIndex));

			break;
		}

		case AttributeTypes.NUMBER: {
			NumberAttribute numberAttribute = (NumberAttribute) attribute;
			numberAttribute.removeValue(Integer.parseInt(attribIndex));

			break;
		}

		case AttributeTypes.DATE: {
			DateAttribute dateAttribute = (DateAttribute) attribute;
			dateAttribute.removeValue(Integer.parseInt(attribIndex));

			break;
		}

		case AttributeTypes.TIMEZONE: {
			TimeZoneAttribute timeZoneAttribute = (TimeZoneAttribute) attribute;
			timeZoneAttribute.removeValue(Integer.parseInt(attribIndex));

			break;
		}

		case AttributeTypes.CURRENCY: {
			CurrencyAttribute currencyAttribute = (CurrencyAttribute) attribute;
			currencyAttribute.removeValue(Integer.parseInt(attribIndex));

			break;
		}

		case AttributeTypes.PASSWORD: {
			PasswordAttribute passwordAttribute = (PasswordAttribute) attribute;
			passwordAttribute.removeValue(Integer.parseInt(attribIndex));

			break;
		}

		case AttributeTypes.PERIOD: {
			PeriodAttribute periodAttribute = (PeriodAttribute) attribute;
			periodAttribute.removeValue(Integer.parseInt(attribIndex));

			break;
		}

		case AttributeTypes.SEQUENCE: {
			SequenceAttribute sequenceAttribute = (SequenceAttribute) attribute;
			sequenceAttribute.removeValue(Integer.parseInt(attribIndex));

			break;
		}

		case AttributeTypes.RELATIONSHIP: {
			RelationshipAttribute relationshipAttribute = (RelationshipAttribute) attribute;
			relationshipAttribute.removeValue(Integer.parseInt(attribIndex));

			break;
		}

		case AttributeTypes.LOOKUP_TABLE: {
			LookupTableAttribute lookupTableAttribute = (LookupTableAttribute) attribute;
			lookupTableAttribute.removeValue(Integer.parseInt(attribIndex));

			break;
		}

		case AttributeTypes.BINARY: {
			BinaryAttribute binaryAttribute = (BinaryAttribute) attribute;
			binaryAttribute.removeValue(Integer.parseInt(attribIndex));

			break;
		}

		case AttributeTypes.IMAGE: {
			ImageAttribute imageAttribute = (ImageAttribute) attribute;
			imageAttribute.removeValue(Integer.parseInt(attribIndex));

			break;
		}

		case AttributeTypes.THUMB_NAIL_IMAGE: {
			ThumbnailImageAttribute thumbNailImageAttribute = (ThumbnailImageAttribute) attribute;
			thumbNailImageAttribute.removeValue(Integer.parseInt(attribIndex));

			break;
		}

		case AttributeTypes.IMAGE_URL: {
			URLAttribute urlAttribute = (URLAttribute) attribute;
			urlAttribute.removeValue(Integer.parseInt(attribIndex));

			break;
		}

		case AttributeTypes.THUMB_NAIL_IMAGE_URL: {
			ThumbnailImageURLAttribute thumbnailImageURLAttribute = (ThumbnailImageURLAttribute) attribute;
			thumbnailImageURLAttribute.removeValue(Integer.parseInt(attribIndex));

			break;
		}

		case AttributeTypes.STRING_ENUMERATION: {
			StringEnumAttribute stringEnumAttribute = (StringEnumAttribute) attribute;
			stringEnumAttribute.removeValue(Integer.parseInt(attribIndex));

			break;
		}

		case AttributeTypes.NUMBER_ENUMERATION: {
			NumberEnumAttribute numberEnumAttribute = (NumberEnumAttribute) attribute;
			numberEnumAttribute.removeValue(Integer.parseInt(attribIndex));

			break;
		}
		}
	}
}
