
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Aug 19, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.ibm.ccd.ui.portlets.lookuptablesearch.core;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;

import com.ibm.ccd.ui.context.IWPCUser;
import com.ibm.ccd.ui.context.WPCUser;
import com.ibm.ccd.ui.dataobjects.attributes.Attribute;
import com.ibm.ccd.ui.dataobjects.items.ICatalogItem;
import com.ibm.ccd.ui.exception.UIException;
import com.ibm.ccd.ui.mediator.WPCMediator;
import com.ibm.ccd.ui.mediator.WPCMediatorException;
import com.ibm.ccd.ui.portlets.search.core.SearchBean;


/**
 * @author administrator
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class LookupTableSearchBean extends SearchBean {
    public LookupTableSearchBean() {
        super();
    }

    /**
     * @deprecated Not required since SearchBean.getSearchAttributes() 
     * uses generic service SERACH_ITEMSKELETION for catalog and lookup tables
     * @return Attribute[]
     * @throws UIException
     * @throws WPCMediatorException
     */
    public Attribute[] getAttributesList()
        throws UIException, WPCMediatorException {
        ArrayList attributesList = null;
        Attribute[] attributes = null;
        WPCUser user = null;
        int size = 0;
        String lookupId = null;
        user = getWpsContext().getWpcUser();

		lookupId=(String) user.getProperty(IWPCUser.KEY_WPC_CATALOGUE_NAME);
        WPCMediator mediator = WPCMediator.getInstance();
        attributes = mediator.getLookupTableAttributes(lookupId, getWpsContext());

        return attributes;
    }
    
    /**
     * Override the SearchBean implementation to retrieve the lookup table name from user object
     * instead of cache
     */
    public Attribute[] getSearchAttributes()
    throws UIException, WPCMediatorException {
    ArrayList attributesList = null;
    ICatalogItem catalogItem = null;
    Attribute[] attributes = null;
	Attribute[] flatAttributes = null;
	HashMap flatAttributeMap=null;
    WPCUser user = null;
    String lookupId = null;
	Collection attrCollection = null;
	Iterator attrItr = null;
	int size = 0;
    user = getWpsContext().getWpcUser();
    lookupId=(String) user.getProperty(IWPCUser.KEY_WPC_CATALOGUE_NAME);
    
    WPCMediator mediator = WPCMediator.getInstance();
	attributes=mediator.getSearchAttributes(lookupId,getWpsContext());
	flatAttributeMap=prepareFlatAttributeMap(attributes);
	attrCollection = flatAttributeMap.values();
	size = attrCollection.size();
	attrItr = attrCollection.iterator();
	flatAttributes = new Attribute[size];
	
	for (int i = 0; i < size; i++) {
		flatAttributes[i] = (Attribute) attrItr.next();
	}
	
    return flatAttributes;
}
    
    public Attribute[] getSearchResultAttributes()
	   throws UIException, WPCMediatorException {
	   ArrayList attributesList = null;
	   ICatalogItem catalogItem = null;
	   Attribute[] attributes = null;
	   Attribute[] flatAttributes = null;
	   HashMap flatAttributeMap=null;
	   WPCUser user = null;
	   String lookupId = null;
	   Collection attrCollection = null;
		Iterator attrItr = null;
		int size = 0;
		
	   user = getWpsContext().getWpcUser();
	   lookupId=(String) user.getProperty(IWPCUser.KEY_WPC_CATALOGUE_NAME);
	   
	   WPCMediator mediator = WPCMediator.getInstance();
	   attributes=mediator.getSearchResultAttributes(lookupId,getWpsContext());
	   flatAttributeMap=prepareFlatAttributeMap(attributes);
		attrCollection = flatAttributeMap.values();
		size = attrCollection.size();
		attrItr = attrCollection.iterator();
		flatAttributes = new Attribute[size];
		
	   	for (int i = 0; i < size; i++) {
		   flatAttributes[i] = (Attribute) attrItr.next();
		 }
		 
	   return flatAttributes;
}
}
