
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Jan 5, 2005
 */
package com.ibm.ccd.ui.portlets.massupdate;


/**
 * This interface holds constants for <code>MassUpdatePortlet</code>
 */
public interface IMassUpdate {
    /**
     * Indicates the path for view jsp of MassUpdate Portlet
     */
    String VIEW_JSP_PATH = "/jsps/html/massUpdate/MassUpdatePortletView.jsp";

    /**
     * Indicates the path for edit jsp of MassUpdate Portlet
     */
    String EDIT_JSP_PATH = "/jsps/html/massUpdate/MassUpdatePortletEdit.jsp";

    /**
     * Indicates the path for edit jsp of MassUpdate Portlet
     */
    String CONFIG_JSP_PATH = "/jsps/html/massUpdate/MassUpdatePortletConfig.jsp";

    /**
     * Indicates the path for help jsp of MassUpdate Portlet
     */
    String HELP_JSP_PATH = "/jsps/html/massUpdate/MassUpdatePortletHelp.jsp";

    /**
     * indicates the key for storing <code>MassUpdateBean<code>
     */
    String KEY_MASS_UDATE_BEAN = "MASS_UDATE_BEAN";

    /**
     * Indicates the form action URI for view mode
     */
    String VIEW_FORM_ACTION_URI = "VIEW_FORM";

    /**
     * Indicates the form action URI for view mode
     */
    String VIEW_FORM_SAVE_ACTION_URI = "SAVE_FORM";

    /**
     * Indicates the form action URI for view mode
     */
    String VIEW_FORM_DELETE_ACTION_URI = "DELETE_FORM";

    /**
     * Indicates the form action URI for edit mode
     */
    String EDIT_FORM_ACTION_UPDATE = "EDIT_UPDATE";

    /**
     * Indicates the form action URI for edit mode
     */
    String CONFIG_FORM_ACTION_UPDATE = "CONFIG_UPDATE";

    /**
     * Indicates the business function <i>file upload</i>
     */
    String BUSINESS_FUNCTION_MASS_UPDATE = "MASS_UPDATE"; //$NON-NLS-1$

    /**
     * Indicates the bsuiness action <i>config</i>
     */
    String BUSINESS_ACTION_CONFIG = "CONFIG"; //$NON-NLS-1$

    /**
     * Indicates the bsuiness action <i>config</i>
     */
    String BUSINESS_ACTION_VIEW = "VIEW"; //$NON-NLS-1$

    /**
     * Indicates the bsuiness action <i>config</i>
     */
    String BUSINESS_ACTION_EDIT = "EDIT"; //$NON-NLS-1$

    /**
     *  indicates the key for <code>PortletSetting</code> parameter MAX_ATTRIBUTES
     */
    String KEY_MAX_ATTRIBUTES = "MAX_ATTRIBUTES";

    /**
     * ndicates the key for storing maxx allowed rows for mass update
     */
    String KEY_MAX_ROWS = "MAX_ROWS";

    /**
     *  Indicates the message code
     */
    String MSG_INVALID_NUMBER_VALUE = "MESSAGE_CODE_111";

    /**
     * Indicates message code for data updation success
     */
    String MSG_UPDATE_SUCCESS = "MESSAGE_CODE_121";

    /**
     * Indicates the message key for max number of attributes
     */
    String MSG_MAX_ATTRIBUTES_AND_ROWS = "MESSAGE_CODE_351";

    /**
     * indicates the message code for edit mode message
     */
    String MSG_MAX_ALLOWED_ATTRIBUTES = "MESSAGE_CODE_352";

    /**
     *  indicates the key while extracting items ids from the GenericPortletMessage
     */
    String KEY_ITEMSLIST = "ITEM_LIST";

    /**
     *  indicates the key while extracting items ids from the GenericPortletMessage
     */
    String KEY_MSG_ITEMIDS = "ITEM_IDS";

    /**
     *  indicates ICatalogItem that setProperties is invoked from Bulk Edit or Mass edit
     */
    String KEY_MASS_EDIT = "MASS_EDIT";

    /**
     *  indicates VIEW MODE for mass update screen.
     */
    String VIEW = "VIEW";

    /**
     *  indicates UPDATE MODE for mass update screen.
     */
    String UPDATE = "UPDATE";

    /**
     *  indicates DELETE MODE for mass update screen.
     */
    String DELETE = "DELETE";

    /**
     *  indicates cancel for Mass Update screen.
     */
    String CANCEL = "CANCEL";

    /**
     *  indicates request parameter for Mass Update screen.
     */
    String REQ_PARAM_KEY_CAT_WORKFLOW = "COLLABID";
}
