
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Jan 6, 2005
 */
package com.ibm.ccd.ui.portlets.massupdate;

import java.io.Serializable;

import com.ibm.ccd.ui.dataobjects.attributes.Attribute;
import com.ibm.ccd.ui.tags.ISelectListTag;


/**
 * Thsi class is a wrapper over <code>Attributre</code> class.
 */
public class ItemAttribute implements Serializable,ISelectListTag {
    /**
     * Indicates whether the Attribute is displayable or not
     */
    private boolean isDisplayable;

    /**
     * Indicates whether the Attribute is additable or not
     */
    private boolean isEditable;

    /**
     * contains the name of <code>Attribute</code>
     */
    private String name = null;

    /**
     * contains the <code>Attribute</code> Object
     */
    private Attribute attribute = null;

    private int listBoxIndex = 0;
    private boolean selected = false;
    /**
     * Constructor
     */
    public ItemAttribute() {
        super();
    }

    /**
     * returns the boolean
     * @return String
     */
    public boolean getIsDisplayable() {
        return isDisplayable;
    }

    /**
     * Sets the field isDisplayable
     * @param string
     */
    public void setIsDisplayable(boolean isDisplayable) {
        this.isDisplayable = isDisplayable;
    }

    /**
     * returns the <code>Attribute</code> object
     * @return Attribute
     */
    public Attribute getAttribute() {
        return attribute;
    }

    /**
     * sets the <code>Attribute</code> object
     * @param attribute
     */
    public void setAttribute(Attribute attribute) {
        this.attribute = attribute;
    }

    /**
     * @return
     */
    public String getName() {
        return name;
    }

    /**
     * @param string
     */
    public void setName(String string) {
        name = string;
    }

    /**
     * @return
     */
    public boolean isEditable() {
        return isEditable;
    }
    /**
     * @param b
     */
    public void setEditable(boolean b) {
        isEditable = b;
    }
    
    public String getDisplayName() {
        return attribute.getDisplayLabelName();
    }
    public int getListBoxIndex() {
        return listBoxIndex;
    }
    public boolean isSelected() {
        return selected;
    }
    
    /**
     * @param selected The selected to set.
     */
    public void setSelected(boolean selected) {
        this.selected = selected;
    }
    /**
     * @param listBoxIndex The listBoxIndex to set.
     */
    public void setListBoxIndex(int listBoxIndex) {
        this.listBoxIndex = listBoxIndex;
    }
}
