
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Jan 5, 2005
 */
package com.ibm.ccd.ui.portlets.massupdate;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import com.ibm.ccd.ui.dataobjects.attributes.Attribute;
import com.ibm.ccd.ui.dataobjects.items.ICatalogItem;
import com.ibm.ccd.ui.portlets.catalog.ICatalogAction;


/**
 * Data Bean for MassUpdatePortlet
 */
public class MassUpdateBean implements Serializable {
    /**
     * contains form Action URI for edit mode
     */
    private String formActionURI = null;

    /**
     * contains form Action URI for edit mode
     */
    private String formSaveUpdateURI = null;

    /**
     * contains form Action URI for edit mode
     */
    private String formDeleteURI = null;

    /**
     * contains item list that needs to be shown to user.
     */
    private Map itemMap = null;

    /**
     * contains the list of ItemAttributes
     */
    private ArrayList itemAttributeList = null;

    private ICatalogItem catalogItemSkeleton = null;
    /**
     * contains the list of ItemAttributes
     */
    private List itemAttributeListForHeader = null;

    /**
     * contains the max no of attributes for update
     */
    private String maxAttributes = null;

    /**
     * contains the max no of rows allowed for mass update
     * set by potal administrator
     */
    private String maxRows = null;

    /**
     * contains the current mode of Mass Edit screen.It may be View/edit/Delete.
     * Its is purely specific to mass edit screen and different from Portlet modes.
     * set by potal administrator
     */
    private String mode = null;

    /**
     * contains the primary key attribute Name
     */
    private Attribute primaryKeyAttribute = null;

    /**
     * contains the primary key attribute Name
     */
    private String primaryCatalogName = null;

    /**
     * contains the primary key attribute Name
     */
    private String collabName = null;
    /**
     * contains the Workflow name.If bean is populated with Items from search
     * itemsSetforWorkflow will be null.If bean is populated with Items from Workflow
     * itemsSetforWorkflow contains workflowName.
     */
    private String itemsSetforWorkflow = null;
    private Map portletRequestAttributes = null; 
    /**
     * Constructor
     */
    public MassUpdateBean() {
        super();

        // TODO Auto-generated constructor stub
    }

    /**
     * @return
     */
    public String getFormActionURI() {
        return formActionURI;
    }

    /**
     * @param string
     */
    public void setFormActionURI(String string) {
        formActionURI = string;
    }

    /**
     * @return
     */
    public ArrayList getItemAttributeList() {
        return itemAttributeList;
    }

    /**
     * @param list
     */
    public void setItemAttributeList(ArrayList list) {
        itemAttributeList = list;
    }

    /**
     * @return
     */
    public Map getItemMap() {
        return itemMap;
    }

    /**
     * @param list
     */
    public void setItemMap(Map map) {
        itemMap = map;
    }

    /**
     * @return
     */
    public List getItemAttributeListForHeader() {
        return itemAttributeListForHeader;
    }

    /**
     * @param list
     */
    public void setItemAttributeListForHeader(List list) {
        itemAttributeListForHeader = list;
    }

    /**
     * @return
     */
    public String getMaxAttributes() {
        return maxAttributes;
    }

    /**
     * @return
     */
    public String getMaxRows() {
        return maxRows;
    }

    /**
     * @param string
     */
    public void setMaxAttributes(String string) {
        maxAttributes = string;
    }

    /**
     * @param string
     */
    public void setMaxRows(String string) {
        maxRows = string;
    }

    /**
     * @return
     */
    public String getFormSaveUpdateURI() {
        return formSaveUpdateURI;
    }

    /**
     * @param string
     */
    public void setFormSaveUpdateURI(String string) {
        formSaveUpdateURI = string;
    }

    /**
     * @return
     */
    public String getFormDeleteURI() {
        return formDeleteURI;
    }

    /**
     * @param string
     */
    public void setFormDeleteURI(String string) {
        formDeleteURI = string;
    }

    /**
     * @return
     */
    public String getMode() {
        return mode;
    }

    /**
     * @param string
     */
    public void setMode(String string) {
        mode = string;
    }

    /**
     * @return
     */
    public String getPrimaryKeyName() {
        return primaryKeyAttribute.getName();
    }
    /**
     * @return
     */
    public String getPrimaryKeyLable() {
        return primaryKeyAttribute.getDisplayLabelName();
    }
    /**
     * @param string
     */
    public void setPrimaryKeyAttribute(Attribute attributePk) {
        primaryKeyAttribute = attributePk;
    }

    /**
     * @return
     */
    public String getPrimaryCatalogName() {
        return primaryCatalogName;
    }

    /**
     * @param string
     */
    public void setPrimaryCatalogName(String string) {
        primaryCatalogName = string;
    }

    /**
     * @return
     */
    public String getCollabName() {
        return collabName;
    }

    /**
     * @param string
     */
    public void setCollabName(String string) {
        collabName = string;
    }
    /**
     * @return Returns the itemsSetforWorkflow.
     */
    public String getItemsSetforWorkflow() {
        return itemsSetforWorkflow;
    }
    /**
     * @param itemsSetforWorkflow The itemsSetforWorkflow to set.
     */
    public void setItemsSetforWorkflow(String itemsSetforWorkflow) {
        this.itemsSetforWorkflow = itemsSetforWorkflow;
    }
    /**
     * @return Returns the portletRequestAttributes.
     */
    public Map getPortletRequestAttributes() {
        return portletRequestAttributes;
    }
    /**
     * @param portletRequestAttributes The portletRequestAttributes to set.
     */
    public void setPortletRequestAttributes(Map portletRequestAttributes) {
        this.portletRequestAttributes = portletRequestAttributes;
    }
/**
 * @return Returns the catalogItemSkeleton.
 */
public ICatalogItem getCatalogItemSkeleton() {
    return catalogItemSkeleton;
}
/**
 * @param catalogItemSkeleton The catalogItemSkeleton to set.
 */
public void setCatalogItemSkeleton(ICatalogItem catalogItemSkeleton) {
    this.catalogItemSkeleton = catalogItemSkeleton;
}
}
