
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Jul 31, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.ibm.ccd.ui.portlets.search;

import java.io.IOException;

import org.apache.jetspeed.portlet.Portlet;
import org.apache.jetspeed.portlet.PortletException;
import org.apache.jetspeed.portlet.PortletRequest;
import org.apache.jetspeed.portlet.PortletResponse;

import com.ibm.ccd.ui.portlets.search.core.BaseSearchPortlet;
import com.ibm.ccd.ui.portlets.search.core.IBaseSearch;
import com.ibm.ccd.ui.portlets.search.core.cmd.ISearchCommand;
import com.ibm.ccd.ui.portlets.search.core.cmd.QuickSearchCmd;


public class SearchPortlet extends BaseSearchPortlet {
    protected void render(PortletRequest request, PortletResponse response,
        Portlet.Mode mode) throws PortletException, IOException {
        String jspName = null;

        if (Portlet.Mode.VIEW.equals(mode)) {
            jspName = ISearch.PATH_SEARCH_VIEW_JSP;
        }

        if (Portlet.Mode.EDIT.equals(mode)) {
            jspName = ISearch.PATH_SEARCH_EDIT_JSP;
        }

        if (Portlet.Mode.CONFIGURE.equals(mode)) {
            jspName = ISearch.PATH_SEARCH_CONFIG_JSP;
        }

        if (Portlet.Mode.HELP.equals(mode)) {
            jspName = ISearch.PATH_SEARCH_HELP_JSP;
        }

        includeJSP(jspName, request, response);
    }

    protected ISearchCommand getAction(String actionString) {
        ISearchCommand command = null;

        if (IBaseSearch.FORM_ACTION_QUICK_SEARCH.equals(actionString)) {
            command = new QuickSearchCmd();
        } else {
            command = super.getAction(actionString);
        }

        return command;
    }
}
