
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Jan 13, 2005
 */
package com.ibm.ccd.ui.portlets.search.core;

import java.util.ArrayList;

import com.ibm.ccd.ui.exception.UIException;


/**
  * This interface defines methods for saving the search XML.
  * implementations for dtatbase or file must implement this interface
  */
public interface ISaveSearch {
    /**Saves the search data to dtat syore
     * @param <code>Hashtable</code>. keys of <code>Hashtable</code> are unique identifiers for the
     * searchXML in values
     */
    public void saveSearch(ArrayList searchData) throws UIException;

    /**
     * Thsi methid loads all previous saved search xmls
     * @return <code>Hashtable</code> with search xml for unique keys
     */
    public ArrayList loadSearch() throws UIException;

    /**
     * gets unique user id used for saving and retriving data.
     * @return String
     */
    public String getUserId();

    /**
     * sets unique user id used for saving and retriving data.
     * @param userId
     */
    public void setUserId(String userId);

    /**
     * @return the folder path
     */
    public String getFolder();

    /**
     * Set the folder name which stores all files
     */
    public void setFolder(String path);
}
