
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Dec 15, 2004
 */
package com.ibm.ccd.ui.portlets.search.core;

import java.io.Serializable;


/**
 * Class used for passing config data to jsp
 */
public class SearchConfigBean implements ISearchDataStore, Serializable {
    /**
     *  Contains the form action URI
     */
    private String formActionURI = null;

    /**
     * contains the max no of columns displauable for search criteria and search result
     */
    private String mxCols = null;

    /**
     * Indicates the scroll size for search result
     */
    private String scrollSize = IBaseSearch.DEFAULT_TRAVERSAL_SIZE;

    /**
     * Indicates the max size of history
     */
    private String maxHistory;

    /**
     * max no of results returned from WPC
     */
    private String maxTraversalSize;

    /**
     * @return
     */
    public String getFormActionURI() {
        return formActionURI;
    }

    /**
     * @return
     */
    public String getMxCols() {
        return mxCols;
    }

    /**
     * @return
     */
    public String getScrollSize() {
        return scrollSize;
    }

    /**
     * @param string
     */
    public void setFormActionURI(String string) {
        formActionURI = string;
    }

    /**
     * @param string
     */
    public void setMxCols(String string) {
        mxCols = string;
    }

    /**
     * @param string
     */
    public void setScrollSize(String string) {
        scrollSize = string;
    }

    /**
     * @return
     */
    public String getMaxHistory() {
        return maxHistory;
    }

    /**
     * @param string
     */
    public void setMaxHistory(String string) {
        maxHistory = string;
    }

    /**
     * @return
     */
    public String getMaxTraversalSize() {
        return maxTraversalSize;
    }

    /**
     * @param string
     */
    public void setMaxTraversalSize(String string) {
        maxTraversalSize = string;
    }
}
