
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Dec 7, 2004
 */
package com.ibm.ccd.ui.portlets.search.core;

import java.io.Serializable;
import java.util.ArrayList;


/**
 * This class holds dta for rendering SearchCriteriaConfig jsp
 */
public class SearchCriteriaBean implements Serializable {
    /**
     * Contains the cuirrent catalog id
     */
    private String catalogId = null;

    /**
     * Contains the message for previous search tab
     */
    String previousSearchMsg = null;

    /**
     * Indicates the form action URI
     */
    private String formActionURI = null;

    /**
     * contains the list of <code>Attribute</code> Objects
     */
    ArrayList attributeList = null;

    /**
     *  Contains the list of <code>ResultMetaData</code> Objects used for user prefrence of search result
     */
    ArrayList metaDataList = null;

    /**
     *  Indicates the traversal size
     */
    private String traversalSize = null;

    /**
     * Contains the past n saved searchs. <code>SearchInputBean</code> is stored as
     * value in <code>HashTable</code>
     */
    ArrayList previousSeach = null;

    /**
     * @return
     */
    public String getFormActionURI() {
        return formActionURI;
    }

    /**
     * @param string
     */
    public void setFormActionURI(String string) {
        formActionURI = string;
    }

    /**
     * @return
     */
    public ArrayList getAttributeList() {
        return attributeList;
    }

    /**
     * @param list
     */
    public void setAttributeList(ArrayList list) {
        attributeList = list;
    }

    /**
     * @return
     */
    public ArrayList getMetaDataList() {
        return metaDataList;
    }

    /**
     * @param list
     */
    public void setMetaDataList(ArrayList list) {
        metaDataList = list;
    }

    /**
     * @return
     */
    public String getTraversalSize() {
        return traversalSize;
    }

    /**
     * @param string
     */
    public void setTraversalSize(String string) {
        traversalSize = string;
    }

    /**
     * @return
     */
    public ArrayList getPreviousSeach() {
        return previousSeach;
    }

    /**
     * @param hashtable
     */
    public void setPreviousSeach(ArrayList values) {
        previousSeach = values;
    }

    /**
     * @return
     */
    public String getPreviousSearchMsg() {
        return previousSearchMsg;
    }

    /**
     * @param string
     */
    public void setPreviousSearchMsg(String string) {
        previousSearchMsg = string;
    }

    /**
     * @return
     */
    public String getCatalogId() {
        return catalogId;
    }

    /**
     * @param string
     */
    public void setCatalogId(String string) {
        catalogId = string;
    }
}
