
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Jul 26, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.ibm.ccd.ui.portlets.search.core;

import java.io.File;
import java.text.ParseException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Locale;
import java.util.Set;

import org.apache.jetspeed.portlet.PortletContext;
import org.apache.jetspeed.portlet.PortletRequest;

import com.ibm.ccd.ui.dataobjects.attributes.AttributeTypes;
import com.ibm.ccd.ui.exception.MessageMap;
import com.ibm.ccd.ui.exception.UIException;
import com.ibm.ccd.ui.taglib.dataobjects.BaseSearchElement;
import com.ibm.ccd.ui.util.IReference;
import com.ibm.ccd.ui.util.UIUtils;


/**
 * @author administrator
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class SearchUtil {
    public SearchUtil() {
        super();
    }

    /**
             * getMessageMap:Method returns MessageMap after setting it in Request object
             * @param portletRequest PortletRequest
             */
    public static MessageMap getMessageMap(PortletRequest portletRequest) {
        MessageMap mmap = null;
        mmap = (MessageMap) portletRequest.getAttribute(IReference.MESSAGE_KEY);

        if (mmap == null) {
            mmap = new MessageMap();
            portletRequest.setAttribute(IReference.MESSAGE_KEY, mmap);
        }

        return mmap;
    }

    public static String getOperatorDisplayName(BaseSearchElement element) {
        String displayName = null;
        String operator = null;
        HashMap operatorMap = null;
        String key = null;
        String value = null;
        Set keySet = null;
        Iterator iterator = null;
        operator = element.getDefaultOperator();
        operatorMap = element.getOperatorsMap();
        keySet = operatorMap.keySet();
        iterator = keySet.iterator();

        while (iterator.hasNext()) {
            key = (String) iterator.next();
            value = (String) operatorMap.get(key);

            if (value.equals(operator)) {
                displayName = key;

                break;
            }
        }

        return displayName;
    }

    /**
     * @param string
     * @return
     */
    public static Object getClass(String className) throws UIException {
        Class cl = null;
        Object object = null;

        try {
            cl = Class.forName(className);
            object = cl.newInstance();
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
            throw new UIException(e);
        } catch (InstantiationException e) {
            e.printStackTrace();
            throw new UIException(e);
        } catch (IllegalAccessException e) {
            e.printStackTrace();
            throw new UIException(e);
        }

        return object;
    }

    public static String getHistoryFolder(PortletContext portletContext,
        String portletName, String catalogId) throws UIException {
        String folder;
        folder = portletContext.getRealPath(IBaseSearch.RELATIVE_FOLDER_PATH) +
            File.separator + IBaseSearch.HISTORY_FOLDER_NAME + "_" +
            portletName + "_" + catalogId;

        File attachdbDir = new File(folder);

        if (!attachdbDir.exists()) {
            if (!attachdbDir.mkdir()) {
                throw new UIException("COULD NOT CREATE FOLDER");
            }
        }

        return folder;
    }

    /**
                     * @param value
                     * @return
                     */
    public static String getFormattedValue(String value, int wpcAttributeType,
        Locale locale) {
        String formattedValue = value;

        if (AttributeTypes.NUMBER == wpcAttributeType) {
            try {
                formattedValue = UIUtils.parseNumber(value, locale);
            } catch (ParseException e) {
                e.printStackTrace();
            }
        }

        return formattedValue;
    }
}
