
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Jul 25, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.ibm.ccd.ui.portlets.search.core.cmd;

import org.apache.jetspeed.portlet.PortletContext;
import org.apache.jetspeed.portlet.PortletRequest;
import org.apache.jetspeed.portlet.PortletResponse;
import org.apache.jetspeed.portlet.PortletSession;

import com.ibm.ccd.ui.context.WPSContext;
import com.ibm.ccd.ui.exception.MessageMap;
import com.ibm.ccd.ui.exception.UIException;
import com.ibm.ccd.ui.mediator.WPCMediatorException;
import com.ibm.ccd.ui.portlets.search.core.IBaseSearch;
import com.ibm.ccd.ui.portlets.search.core.SearchBean;
import com.ibm.ccd.ui.portlets.search.core.SearchCriteriaBean;
import com.ibm.ccd.ui.portlets.search.core.SearchHelper;
import com.ibm.ccd.ui.portlets.search.core.SearchInputBean;
import com.ibm.ccd.ui.portlets.search.core.SearchUtil;
import com.ibm.ccd.ui.util.ValidationUtil;


/**
 * @author administrator
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class PerformSearchCmd implements ISearchCommand {
    protected PortletContext portletContext = null;
    protected WPSContext wpsContext = null;
    protected String portletName = null;
    protected SearchHelper searchHelper = null;

    public PerformSearchCmd() {
        super();
    }

    public void execute(PortletRequest request, PortletResponse response)
        throws UIException, WPCMediatorException {
        PortletSession portletSession = null;
        SearchCriteriaBean searchCriteriaBean = null;
        SearchInputBean searchInputBean = null;
        SearchBean searchBean = null;
		MessageMap messageMap = null;
		int count=0;
		messageMap = SearchUtil.getMessageMap(request);
        portletSession = request.getPortletSession();
        searchCriteriaBean = (SearchCriteriaBean) portletSession.getAttribute(IBaseSearch.KEY_SEARCH_CRITERIA_BEAN);
        //clear the searchResult bean from sesion
		portletSession.setAttribute(IBaseSearch.KEY_SEARCH_RESULTS_BEAN,null);
		
        //prepare search helper
        searchHelper = new SearchHelper();
        searchBean = new SearchBean();
        searchHelper.setSearchBean(searchBean);
        searchHelper.setPortletContext(getPortletContext());
        searchHelper.setRequest(request);
        searchHelper.setWpsContext(getWpsContext());
        searchHelper.setPortletName(portletName);
        searchHelper.setSearchCriteriaBean(searchCriteriaBean);
        searchHelper.setRequestValues();
		count=searchHelper.filterSearchCriteria();
		
		if (count == 0) {
			messageMap.addInfoMessage(IBaseSearch.MSG_NO_SEARCH_CRITERIA);
			request.setAttribute("stabNo", "1");
			return;
		}
        searchInputBean = searchHelper.getSearchInput();
        search(searchInputBean);

        //Saves the search criteria in userData object
        searchHelper.saveSearch(searchInputBean);
		
		if(!ValidationUtil.isNullOrEmpty(searchCriteriaBean.getPreviousSeach())){
			int searchKey=searchCriteriaBean.getPreviousSeach().size()-1;
			portletSession.setAttribute(IBaseSearch.KEY_SEARCH_ID,searchKey + "");
		}else{
			portletSession.setAttribute(IBaseSearch.KEY_SEARCH_ID,"0");
		}
    }

    protected void search(SearchInputBean searchInputBean)
        throws UIException, WPCMediatorException {
        searchHelper.performSearch(searchInputBean);
    }

    public WPSContext getWpsContext() {
        return wpsContext;
    }

    public void setWpsContext(WPSContext wpsContext) {
        this.wpsContext = wpsContext;
    }

    public PortletContext getPortletContext() {
        return portletContext;
    }

    public void setPortletContext(PortletContext portletContext) {
        this.portletContext = portletContext;
    }

    /**
     * @return
     */
    public String getPortletName() {
        return portletName;
    }

    /**
     * @param string
     */
    public void setPortletName(String string) {
        portletName = string;
    }
}
