
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Jul 25, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.ibm.ccd.ui.portlets.search.core.cmd;

import org.apache.jetspeed.portlet.PortletContext;
import org.apache.jetspeed.portlet.PortletRequest;
import org.apache.jetspeed.portlet.PortletResponse;
import org.apache.jetspeed.portlet.PortletSession;
import org.apache.jetspeed.portlet.PortletSettings;
import org.apache.jetspeed.portlet.PortletURI;

import com.ibm.ccd.ui.context.WPSContext;
import com.ibm.ccd.ui.exception.UIException;
import com.ibm.ccd.ui.mediator.WPCMediatorException;
import com.ibm.ccd.ui.portlets.search.core.IBaseSearch;
import com.ibm.ccd.ui.portlets.search.core.SearchConfigBean;


/**
 * @author administrator
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class PopulateConfigDataStoreCmd implements ISearchCommand {
    PortletContext portletContext = null;
    WPSContext wpsContext = null;
    private String portletName = null;

    public PopulateConfigDataStoreCmd() {
        super();
    }

    public void execute(PortletRequest request, PortletResponse response)
        throws UIException, WPCMediatorException {
        PortletSettings portletSettings = null;
        PortletSession portletSession = null;
        SearchConfigBean configBean = null;
        PortletURI formActionURI = null;
        String maxlCols = null;
        String maxHistory = null;
        String maxTraversalSize = null;

        portletSettings = request.getPortletSettings();
        maxlCols = portletSettings.getAttribute(IBaseSearch.MAX_SEARCH_COLS);
        maxHistory = portletSettings.getAttribute(IBaseSearch.MAX_SEARCH_HISTORY);
		maxTraversalSize = portletSettings.getAttribute(IBaseSearch.MAX_TRAVERSAL_SIZE);

        configBean = new SearchConfigBean();
        configBean.setMxCols(maxlCols);
        configBean.setMaxHistory(maxHistory);
        configBean.setMaxTraversalSize(maxTraversalSize);

        formActionURI = response.createURI();
        formActionURI.addAction(IBaseSearch.FORM_ACTION_CONFIG);
        configBean.setFormActionURI(formActionURI.toString());
        request.setAttribute(IBaseSearch.KEY_SEARCH_CONFIG_BEAN, configBean);
    }

    public WPSContext getWpsContext() {
        return wpsContext;
    }

    public void setWpsContext(WPSContext wpsContext) {
        this.wpsContext = wpsContext;
    }

    public PortletContext getPortletContext() {
        return portletContext;
    }

    public void setPortletContext(PortletContext portletContext) {
        this.portletContext = portletContext;
    }

    public void setPortletName(String portletName) {
        this.portletName = portletName;
    }

    public String getPortletName() {
        return portletName;
    }
}
