
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Jul 25, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.ibm.ccd.ui.portlets.search.core.cmd;

import java.util.ArrayList;

import org.apache.jetspeed.portlet.PortletContext;
import org.apache.jetspeed.portlet.PortletData;
import org.apache.jetspeed.portlet.PortletRequest;
import org.apache.jetspeed.portlet.PortletResponse;
import org.apache.jetspeed.portlet.PortletSession;
import org.apache.jetspeed.portlet.PortletSettings;
import org.apache.jetspeed.portlet.PortletURI;

import com.ibm.ccd.ui.context.WPSContext;
import com.ibm.ccd.ui.exception.MessageMap;
import com.ibm.ccd.ui.exception.UIException;
import com.ibm.ccd.ui.mediator.WPCMediatorException;
import com.ibm.ccd.ui.portlets.search.core.IBaseSearch;
import com.ibm.ccd.ui.portlets.search.core.SearchCriteriaBean;
import com.ibm.ccd.ui.portlets.search.core.SearchHelper;
import com.ibm.ccd.ui.portlets.search.core.SearchUtil;
import com.ibm.ccd.ui.util.ValidationUtil;


/**
 * @author administrator
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class PopulateEditDataStoreCmd implements ISearchCommand {
    PortletContext portletContext = null;
    WPSContext wpsContext = null;
    private String portletName = null;

    public PopulateEditDataStoreCmd() {
        super();
    }

    public void execute(PortletRequest request, PortletResponse response)
        throws UIException, WPCMediatorException {
        PortletData portletData = null;
        PortletSession portletSession = null;
        PortletSettings portletSettings = null;
        PortletURI formActionURI = null;
        ArrayList attributeList = null;
        SearchCriteriaBean searchCriteriaBean = null;
        String traversalSize = null;
        String maxCols = null;
        MessageMap messageMap = null;

        //add info mesages
        portletSettings = request.getPortletSettings();
        maxCols = portletSettings.getAttribute(IBaseSearch.MAX_SEARCH_COLS);
        messageMap = SearchUtil.getMessageMap(request);
        messageMap.addInfoMessage(IBaseSearch.MSG_EDIT_INFO, maxCols);

        //check if SearchCriteriaBean is present
        portletSession = request.getPortletSession();
        searchCriteriaBean = (SearchCriteriaBean) portletSession.getAttribute(IBaseSearch.KEY_SEARCH_CRITERIA_BEAN);

        if (searchCriteriaBean == null) {
            searchCriteriaBean = new SearchCriteriaBean();

            //parses xml and sets the attributes list in portletSession object
            setSearchCriteria(request, searchCriteriaBean);
        }

        //set traversl size
        portletData = request.getData();
        traversalSize = (String) portletData.getAttribute(IBaseSearch.KEY_TRAVERSAL_SIZE);

        if (ValidationUtil.isNullOrEmpty(traversalSize)) {
            traversalSize = IBaseSearch.DEFAULT_TRAVERSAL_SIZE;
        }

        searchCriteriaBean.setTraversalSize(traversalSize);

        formActionURI = response.createURI();
        formActionURI.addAction(IBaseSearch.FORM_ACTION_EDIT_SEARCH_CRITERIA);
        searchCriteriaBean.setFormActionURI(formActionURI.toString());
    }

    public WPSContext getWpsContext() {
        return wpsContext;
    }

    public void setWpsContext(WPSContext wpsContext) {
        this.wpsContext = wpsContext;
    }

    public PortletContext getPortletContext() {
        return portletContext;
    }

    public void setPortletContext(PortletContext portletContext) {
        this.portletContext = portletContext;
    }

    /**
     * @param request
     * @param searchCriteriaBean
     */
    private void setSearchCriteria(PortletRequest request,
        SearchCriteriaBean searchCriteriaBean)
        throws UIException, WPCMediatorException {
        MessageMap messageMap = null;
        SearchHelper helper = null;

        try {
            helper = new SearchHelper();
            helper.setPortletContext(getPortletContext());
            helper.setWpsContext(getWpsContext());
            helper.setRequest(request);
            helper.setSearchCriteriaBean(searchCriteriaBean);
            helper.populateSearchCriteria();
        } catch (UIException exception) {
            exception.printStackTrace();
            messageMap = SearchUtil.getMessageMap(request);
            messageMap.addInfoMessage(IBaseSearch.MSG_SYSTEM_EXCEPTION);
        }
    }

    public void setPortletName(String portletName) {
        this.portletName = portletName;
    }

    public String getPortletName() {
        return portletName;
    }
}
