
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Jul 25, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.ibm.ccd.ui.portlets.search.core.cmd;

import java.util.ArrayList;

import org.apache.jetspeed.portlet.PortletContext;
import org.apache.jetspeed.portlet.PortletRequest;
import org.apache.jetspeed.portlet.PortletResponse;
import org.apache.jetspeed.portlet.PortletSession;
import org.apache.jetspeed.portlet.PortletURI;

import com.ibm.ccd.ui.context.WPSContext;
import com.ibm.ccd.ui.exception.MessageMap;
import com.ibm.ccd.ui.exception.UIException;
import com.ibm.ccd.ui.mediator.WPCMediatorException;
import com.ibm.ccd.ui.portlets.search.core.IBaseSearch;
import com.ibm.ccd.ui.portlets.search.core.ICollectionViewBean;
import com.ibm.ccd.ui.portlets.search.core.SearchBean;
import com.ibm.ccd.ui.portlets.search.core.SearchCriteriaBean;
import com.ibm.ccd.ui.portlets.search.core.SearchHelper;
import com.ibm.ccd.ui.portlets.search.core.SearchResultBean;
import com.ibm.ccd.ui.portlets.search.core.SearchUtil;
import com.ibm.ccd.ui.util.UIUtils;


/**
 * @author administrator
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class PopulateViewDataStoreCmd implements ISearchCommand {
    protected PortletContext portletContext = null;
    protected WPSContext wpsContext = null;
    protected String portletName = null;
	protected SearchHelper helper = null;

    public PopulateViewDataStoreCmd() {
        super();
    }

    public void execute(PortletRequest request, PortletResponse response)
        throws UIException, WPCMediatorException {
        setSearchCriteria(request, response);

        setSearchResult(request, response);
    }

    protected void setSearchCriteria(PortletRequest request,
        PortletResponse response) throws UIException, WPCMediatorException {
        MessageMap messageMap = null;
        PortletURI formActionURI = null;
        PortletSession portletSession = null;
        String catalogID = null;
        SearchCriteriaBean searchCriteriaBean = null;
        SearchBean searchBean = null;
        String currentCatalogId=null;
		String actionName=null;
        portletSession = request.getPortletSession();
        searchCriteriaBean = (SearchCriteriaBean) portletSession.getAttribute(IBaseSearch.KEY_SEARCH_CRITERIA_BEAN);
        
        // Checkif the SearchCriteriaBean is cached for diffrent catalog than current catalog. 
		currentCatalogId=UIUtils.getCatalogName(wpsContext.getWpcUser());
		if(searchCriteriaBean!=null){
			catalogID=searchCriteriaBean.getCatalogId();	
			if(!catalogID.equals(currentCatalogId)){
				searchCriteriaBean = null;
				portletSession.setAttribute(IBaseSearch.KEY_SEARCH_RESULTS_BEAN,null);
			}
		}
		
        if (searchCriteriaBean == null ) {
            catalogID = currentCatalogId;
            searchCriteriaBean = new SearchCriteriaBean();
            searchCriteriaBean.setCatalogId(catalogID);

            try {
                searchBean = createSearchBean();
                helper = new SearchHelper();
                helper.setSearchBean(searchBean);
                helper.setPortletContext(getPortletContext());
                helper.setWpsContext(getWpsContext());
                helper.setRequest(request);
                helper.setSearchCriteriaBean(searchCriteriaBean);
                helper.setPortletName(getPortletName());
                helper.populateSearchCriteria();
				modifyAttributeDisplay();
            } catch (UIException exception) {
                exception.printStackTrace();
                messageMap = SearchUtil.getMessageMap(request);
                messageMap.addInfoMessage(IBaseSearch.MSG_SYSTEM_EXCEPTION);
                throw exception;
            }
        }
		
		actionName=request.getParameter(IBaseSearch.KEY_ACTION);
		if(IBaseSearch.FORM_ACTION_QUICK_SEARCH.equals(actionName)){
			executeQuickSearch(request,response);
		}
        formActionURI = response.createURI();
        formActionURI.addAction(IBaseSearch.FORM_ACTION_PERFORM_SEARCH);
        searchCriteriaBean.setFormActionURI(formActionURI.toString());
    }

    
	
	private void executeQuickSearch(PortletRequest request,
	PortletResponse response) throws UIException, WPCMediatorException {
		QuickSearchCmd quickSearchCmd=new QuickSearchCmd();
		quickSearchCmd.setPortletContext(portletContext);
		quickSearchCmd.setPortletName(portletName);
		quickSearchCmd.setWpsContext(wpsContext);
		quickSearchCmd.execute(request,response);
	}

	/**
     * @return
     */
    protected SearchBean createSearchBean() {
        SearchBean searchBean = new SearchBean();

        return searchBean;
    }

    protected void setSearchResult(PortletRequest request,
        PortletResponse response) throws UIException, WPCMediatorException {
        PortletURI formActionURI = null;
        PortletURI nextLinkURI = null;
        PortletURI lastLinkURI = null;
        PortletURI firstLinkURI = null;
        PortletURI previousLinkURI = null;
        PortletURI workWithItemURI = null;
        PortletSession portletSession = null;
        SearchResultBean searchResultBean = null;
        SearchCriteriaBean searchCriteriaBean=null;
        int index=0;

        portletSession = request.getPortletSession();
		searchCriteriaBean=(SearchCriteriaBean) portletSession.getAttribute(IBaseSearch.KEY_SEARCH_CRITERIA_BEAN);
        searchResultBean = (SearchResultBean) portletSession.getAttribute(IBaseSearch.KEY_SEARCH_RESULTS_BEAN);

        if (searchResultBean != null) {
        	//index of previous search
        	index=Integer.parseInt((String)portletSession.getAttribute(IBaseSearch.KEY_SEARCH_ID));
        	
            formActionURI = response.createURI();
            formActionURI.addAction(IBaseSearch.SEARCH_RESULT_FORM_ACTION_VIEW);
            searchResultBean.setFormActionURI(formActionURI.toString());

            nextLinkURI = response.createURI();
            nextLinkURI.addAction(ICollectionViewBean.GET_NEXT_RESULTS);
			nextLinkURI.addParameter(IBaseSearch.KEY_SEARCH_ID,index + "");
            searchResultBean.setNextActionURI(nextLinkURI.toString());

            lastLinkURI = response.createURI();
            lastLinkURI.addAction(ICollectionViewBean.GET_LAST_RESULTS);
			lastLinkURI.addParameter(IBaseSearch.KEY_SEARCH_ID,index + "");
            searchResultBean.setLastActionURI(lastLinkURI.toString());

            firstLinkURI = response.createURI();
            firstLinkURI.addAction(ICollectionViewBean.GET_FIRST_RESULTS);
			firstLinkURI.addParameter(IBaseSearch.KEY_SEARCH_ID,index + "");
            searchResultBean.setFirstActionURI(firstLinkURI.toString());

            previousLinkURI = response.createURI();
            previousLinkURI.addAction(ICollectionViewBean.GET_PREVIOUS_RESULTS);
			previousLinkURI.addParameter(IBaseSearch.KEY_SEARCH_ID,index + "");
            searchResultBean.setPreviousLinkURI(previousLinkURI.toString());

            workWithItemURI = response.createURI();
            workWithItemURI.addAction(IBaseSearch.FORM_ACTION_WORK_WITH_ITEM);
            searchResultBean.setWorkWithItemURI(workWithItemURI.toString());
        }
    }
    
    /**
     * By default only primary key of item will be displayed in search
     * criteria and search results.
     * If this behaviour needs to be altered then overide this methos in child class
     *Parent class will have blank implementation
     */
    protected void modifyAttributeDisplay(){
		 helper.displayUserSetAttributes();		
    }

    public WPSContext getWpsContext() {
        return wpsContext;
    }

    public void setWpsContext(WPSContext wpsContext) {
        this.wpsContext = wpsContext;
    }

    public PortletContext getPortletContext() {
        return portletContext;
    }

    public void setPortletContext(PortletContext portletContext) {
        this.portletContext = portletContext;
    }

    /**
     * @return
     */
    public String getPortletName() {
        return portletName;
    }

    /**
     * @param string
     */
    public void setPortletName(String string) {
        portletName = string;
    }
}
