
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Jul 26, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.ibm.ccd.ui.portlets.search.core.cmd;

import java.util.ArrayList;

import org.apache.jetspeed.portlet.PortletContext;
import org.apache.jetspeed.portlet.PortletRequest;
import org.apache.jetspeed.portlet.PortletResponse;
import org.apache.jetspeed.portlet.PortletSession;

import com.ibm.ccd.ui.context.WPSContext;
import com.ibm.ccd.ui.exception.UIException;
import com.ibm.ccd.ui.mediator.WPCMediatorException;
import com.ibm.ccd.ui.portlets.search.core.IBaseSearch;
import com.ibm.ccd.ui.portlets.search.core.SearchBean;
import com.ibm.ccd.ui.portlets.search.core.SearchCriteriaBean;
import com.ibm.ccd.ui.portlets.search.core.SearchHelper;
import com.ibm.ccd.ui.portlets.search.core.SearchInputBean;
import com.ibm.ccd.ui.taglib.dataobjects.ResultMetaData;


public class SearchFromHistoryCmd implements ISearchCommand {
    private PortletContext portletContext = null;
    private WPSContext wpsContext = null;
    private String portletName = null;
	protected SearchHelper searchHelper = null;

    public SearchFromHistoryCmd() {
        super();
    }

    public void execute(PortletRequest request, PortletResponse response)
        throws UIException, WPCMediatorException {
        PortletSession portletSession = null;
        ArrayList previousSearch = null;
        String prevSearchID = null;
        SearchCriteriaBean searchCriteriaBean = null;
        SearchInputBean searchInputBean = null;
        SearchBean searchBean = null;
        String index=null;
		

        portletSession = request.getPortletSession();
        searchCriteriaBean = (SearchCriteriaBean) portletSession.getAttribute(IBaseSearch.KEY_SEARCH_CRITERIA_BEAN);
		prevSearchID = request.getParameter(IBaseSearch.KEY_SEARCH_ID);
		
		//clear the cache if diffrent search history is executed
		index=(String)portletSession.getAttribute(IBaseSearch.KEY_SEARCH_ID);
		if(!index.equals(prevSearchID)){
			portletSession.setAttribute(IBaseSearch.KEY_SEARCH_RESULTS_BEAN,null);
		}
		
				
        //	prepare search helper
        searchHelper = new SearchHelper();
        searchBean = new SearchBean();
        searchHelper.setSearchBean(searchBean);
		searchHelper.setSearchCriteriaBean(searchCriteriaBean);
        searchHelper.setPortletContext(portletContext);
        searchHelper.setRequest(request);
        searchHelper.setWpsContext(wpsContext);
        
        previousSearch = searchCriteriaBean.getPreviousSeach();
        if(previousSearch!=null){
			searchInputBean = (SearchInputBean) previousSearch.get(Integer.parseInt(prevSearchID));
			portletSession.setAttribute(IBaseSearch.KEY_SEARCH_ID,prevSearchID);
			search(searchInputBean);
        }
        
    }

	protected void search(SearchInputBean searchInputBean)
		   throws UIException, WPCMediatorException {
		   searchHelper.performSearch(searchInputBean);
	   }

	
    public WPSContext getWpsContext() {
        return wpsContext;
    }

    public void setWpsContext(WPSContext wpsContext) {
        this.wpsContext = wpsContext;
    }

    public PortletContext getPortletContext() {
        return portletContext;
    }

    public void setPortletContext(PortletContext portletContext) {
        this.portletContext = portletContext;
    }

    public void setPortletName(String portletName) {
        this.portletName = portletName;
    }

    public String getPortletName() {
        return portletName;
    }
}
