
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Jul 26, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.ibm.ccd.ui.portlets.search.core.cmd;

import java.io.IOException;

import org.apache.jetspeed.portlet.AccessDeniedException;
import org.apache.jetspeed.portlet.PortletContext;
import org.apache.jetspeed.portlet.PortletRequest;
import org.apache.jetspeed.portlet.PortletResponse;
import org.apache.jetspeed.portlet.PortletSession;
import org.apache.jetspeed.portlet.PortletSettings;

import com.ibm.ccd.ui.context.WPSContext;
import com.ibm.ccd.ui.exception.MessageMap;
import com.ibm.ccd.ui.exception.UIException;
import com.ibm.ccd.ui.mediator.WPCMediatorException;
import com.ibm.ccd.ui.portlets.search.core.IBaseSearch;
import com.ibm.ccd.ui.portlets.search.core.SearchUtil;
import com.ibm.ccd.ui.util.UIUtils;


/**
 * @author administrator
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class UpdateConfigSettingsCmd implements ISearchCommand {
    PortletContext portletContext = null;
    WPSContext wpsContext = null;
    private String portletName = null;

    public UpdateConfigSettingsCmd() {
        super();
    }

    public void execute(PortletRequest request, PortletResponse response)
        throws UIException, WPCMediatorException {
        MessageMap messageMap = null;
        PortletSession portletSession = null;

        //			save config settings
        saveConfig(request);

        //bean set to null for refreshing view mode
        portletSession = request.getPortletSession();
        portletSession.setAttribute(IBaseSearch.KEY_SEARCH_CRITERIA_BEAN, null);
		portletSession.setAttribute(IBaseSearch.KEY_SEARCH_RESULTS_BEAN,null);
        messageMap = SearchUtil.getMessageMap(request);
        messageMap.addInfoMessage(IBaseSearch.MSG_CONFIG_UPDATE_SUCCESS);
    }

    /**
             * @param request
             */
    private void saveConfig(PortletRequest request) throws UIException {
        String sMaxCols = null;
        String sMaxHistory = null;
        String sMaxTraversalSize = null;
        int iMaxlCols = 0;
        int iMaxHistory = 0;
        int iMaxTraversalSize = 0;
        String colName = null;
        PortletSettings portletSettings = null;
        PortletSession portletSession = null;

        sMaxCols = request.getParameter(IBaseSearch.MAX_SEARCH_COLS);
        sMaxHistory = request.getParameter(IBaseSearch.MAX_SEARCH_HISTORY);
        sMaxTraversalSize = request.getParameter(IBaseSearch.MAX_TRAVERSAL_SIZE);
        
        iMaxlCols = getintValue(sMaxCols, IBaseSearch.MAX_SEARCH_COLS, request);
        iMaxHistory = getintValue(sMaxHistory, IBaseSearch.MAX_SEARCH_HISTORY,
                request);
		iMaxTraversalSize = getintValue(sMaxTraversalSize, IBaseSearch.MAX_TRAVERSAL_SIZE,
                request);

        //store the value in portletSettings object
        portletSettings = request.getPortletSettings();

        try {
            portletSettings.setAttribute(IBaseSearch.MAX_SEARCH_COLS, sMaxCols);
            portletSettings.setAttribute(IBaseSearch.MAX_SEARCH_HISTORY,
                sMaxHistory);
            portletSettings.setAttribute(IBaseSearch.MAX_TRAVERSAL_SIZE,
                sMaxTraversalSize);
            portletSettings.store();
        } catch (AccessDeniedException exception) {
            exception.printStackTrace();
            throw new UIException(exception);
        } catch (IOException exception) {
            exception.printStackTrace();
            throw new UIException(exception);
        }
    }

    /**
                     * This method parses the string and returns the int value of string
                     * @param sPaam
                     * @param key
                     * @param request
                     * @return int
                     * @throws UIException
                     * @throws Exception
                     */
    private int getintValue(String sParam, String key, PortletRequest request)
        throws UIException {
        MessageMap messageMap = null;
        int returnValue = 0;
        String colName = null;

        try {
            messageMap = SearchUtil.getMessageMap(request);
            returnValue = Integer.parseInt(sParam);

            if (returnValue < 0) {
                throw new NumberFormatException();
            }
        } catch (NumberFormatException exception) {
            exception.printStackTrace();
            colName = UIUtils.getTextLabel(portletContext, request, key);
            messageMap.addErrorMessage(IBaseSearch.MSG_INVALID_NUMBER_VALUE,
                colName);
            throw new UIException(exception);
        }

        return returnValue;
    }

    public WPSContext getWpsContext() {
        return wpsContext;
    }

    public void setWpsContext(WPSContext wpsContext) {
        this.wpsContext = wpsContext;
    }

    public PortletContext getPortletContext() {
        return portletContext;
    }

    public void setPortletContext(PortletContext portletContext) {
        this.portletContext = portletContext;
    }

    public void setPortletName(String portletName) {
        this.portletName = portletName;
    }

    public String getPortletName() {
        return portletName;
    }
}
