
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Jul 25, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.ibm.ccd.ui.portlets.search.core.cmd;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Iterator;

import org.apache.jetspeed.portlet.AccessDeniedException;
import org.apache.jetspeed.portlet.PortletContext;
import org.apache.jetspeed.portlet.PortletData;
import org.apache.jetspeed.portlet.PortletRequest;
import org.apache.jetspeed.portlet.PortletResponse;
import org.apache.jetspeed.portlet.PortletSession;
import org.apache.jetspeed.portlet.PortletSettings;

import com.ibm.ccd.ui.context.WPSContext;
import com.ibm.ccd.ui.exception.MessageMap;
import com.ibm.ccd.ui.exception.UIException;
import com.ibm.ccd.ui.mediator.WPCMediatorException;
import com.ibm.ccd.ui.portlets.search.ISearch;
import com.ibm.ccd.ui.portlets.search.core.IBaseSearch;
import com.ibm.ccd.ui.portlets.search.core.SearchCriteriaBean;
import com.ibm.ccd.ui.portlets.search.core.SearchResultBean;
import com.ibm.ccd.ui.portlets.search.core.SearchUtil;
import com.ibm.ccd.ui.taglib.dataobjects.BaseSearchElement;
import com.ibm.ccd.ui.taglib.dataobjects.ResultMetaData;
import com.ibm.ccd.ui.util.UIUtils;
import com.ibm.ccd.ui.util.ValidationUtil;


/**
 * @author administrator
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class UpdateSearchCriteriaCmd implements ISearchCommand {
    PortletContext portletContext = null;
    WPSContext wpsContext = null;
    private String portletName = null;

    public UpdateSearchCriteriaCmd() {
        super();
    }

    public void execute(PortletRequest request, PortletResponse response)
        throws UIException, WPCMediatorException {
        SearchCriteriaBean searchCriteriaBean = null;
		SearchFromHistoryCmd command=null;
        searchCriteriaBean = (SearchCriteriaBean) request.getPortletSession()
                                                         .getAttribute(IBaseSearch.KEY_SEARCH_CRITERIA_BEAN);

        MessageMap messageMap = null;
		PortletSession portletSession = request.getPortletSession();
        //			validate input
        validateEditAction(request);

        //update travesal size
        updateTraversalSize(request);

        //  update search criteria and searchbresult prefrences
        updateSearchCriteria(request, searchCriteriaBean);
		portletSession.setAttribute(IBaseSearch.KEY_SEARCH_RESULTS_BEAN,null);
		//perform last search
 	   	command= getCommand();
	   	command.setWpsContext(getWpsContext());
	   	command.setPortletContext(getPortletContext());
	   	command.setPortletName(getPortletName());
	   	command.execute(request, response);
	   	//add message
		messageMap = SearchUtil.getMessageMap(request);
		messageMap.addInfoMessage(IBaseSearch.MSG_EDIT_UPDATE_SUCCESS);
    }

    private void validateEditAction(PortletRequest request)
        throws UIException {
        PortletSettings portletSettings=null;	
        String travesalSize = null;
        MessageMap messageMap = null;
        String colName = null;
        String [] resultAttributes=null;
        String sMaxResultCols=null;
        int iMaxResultCols=0;
        int maxTraversalSize=0;
        int attributeCount=0;
		
		
        try {
            messageMap = SearchUtil.getMessageMap(request);
            travesalSize = request.getParameter(IBaseSearch.KEY_TRAVERSAL_SIZE);
            Integer.parseInt(travesalSize);
        } catch (NumberFormatException exception) {
            colName = UIUtils.getTextLabel(portletContext, request,
                    IBaseSearch.KEY_TRAVERSAL_SIZE);
            messageMap.addErrorMessage(IBaseSearch.MSG_INVALID_NUMBER_VALUE,
                colName);
            throw new UIException(exception);
        }
        
		portletSettings=request.getPortletSettings();
		//validate traversal size
		maxTraversalSize=Integer.parseInt(portletSettings.getAttribute(IBaseSearch.MAX_TRAVERSAL_SIZE));
		if(maxTraversalSize<Integer.parseInt(travesalSize)){
			messageMap.addErrorMessage(IBaseSearch.MSG_INVALID_TRAVERSAL_SIZE,maxTraversalSize+"");
			throw new UIException();
		}
		sMaxResultCols= portletSettings.getAttribute(IBaseSearch.MAX_SEARCH_COLS);
		iMaxResultCols=Integer.parseInt(sMaxResultCols);
		resultAttributes = request.getParameterValues(IBaseSearch.KEY_SELECT_SEARCH_RESULT);
		if(iMaxResultCols<resultAttributes.length){
			messageMap.addErrorMessage(IBaseSearch.MSG_EDIT_INFO, sMaxResultCols);
			throw new UIException();
		}
    }

    private void updateTraversalSize(PortletRequest request)
        throws UIException {
        PortletData portletData = null;
        String traversalSize = null;
        PortletSession portletSession = null;
        SearchResultBean searchResultBean = null;

        portletData = request.getData();
        traversalSize = request.getParameter(IBaseSearch.KEY_TRAVERSAL_SIZE);

        try {
            Integer.parseInt(traversalSize);
        } catch (NumberFormatException exception) {
            throw new UIException();
        }

        try {
            portletData.setAttribute(IBaseSearch.KEY_TRAVERSAL_SIZE,
                traversalSize);
            portletData.store();
        } catch (AccessDeniedException exception) {
            exception.printStackTrace();
            throw new UIException(exception);
        } catch (IOException exception) {
            exception.printStackTrace();
            throw new UIException(exception);
        }

        //update value in bean
        portletSession = request.getPortletSession();
        searchResultBean = (SearchResultBean) portletSession.getAttribute(IBaseSearch.KEY_SEARCH_RESULTS_BEAN);

        if (searchResultBean != null) {
            searchResultBean.setTraversalSize(Integer.parseInt(traversalSize));
        }
    }

    private void updateSearchCriteria(PortletRequest request,
        SearchCriteriaBean searchCriteriaBean) throws UIException {
        ArrayList attributeList = null;
        Iterator attrItr = null;
        BaseSearchElement element = null;
        Enumeration attributes = null;
        ResultMetaData resultMetaData = null;
        ArrayList metaDatalist = null;
        String paramName = null;
        String paramValue = null;
        String elementName = null;
        String[] criteriaAttributes = null;
        String[] resultAttributes = null;
        String attributeName = null;
		String catalogId=null;
		PortletData portletData=null; 
		StringBuffer tokenizedCriteria=null;
		StringBuffer tokenizedResult=null;
		String primaryKey=null;
		
        criteriaAttributes = request.getParameterValues(IBaseSearch.KEY_SELECT_SEARCH_CRITERIA);
        resultAttributes = request.getParameterValues(IBaseSearch.KEY_SELECT_SEARCH_RESULT);

        attributeList = searchCriteriaBean.getAttributeList();
        metaDatalist = searchCriteriaBean.getMetaDataList();

        for (int i = 0; i < attributeList.size(); i++) {
            element = (BaseSearchElement) attributeList.get(i);
            resultMetaData = (ResultMetaData) metaDatalist.get(i);
            element.setIsDisplayable(false);
            resultMetaData.setDisplayable(false);
            if(element.isMandatory()){
				primaryKey=element.getName();	
            }
        }
        
		//if user hs not selected any attribute in search criteria/result then by default
		// display the primary key
		 if(criteriaAttributes==null||criteriaAttributes.length==0){
			criteriaAttributes= new String[ ]{primaryKey};
		 }if(resultAttributes==null||resultAttributes.length==0){
			resultAttributes=new String[ ]{primaryKey};
		}

        //set display for search criteria
		tokenizedCriteria= new StringBuffer();
        for (int i = 0; i < criteriaAttributes.length; i++) {
            attributeName = criteriaAttributes[i];

            for (int j = 0; j < attributeList.size(); j++) {
                element = (BaseSearchElement) attributeList.get(j);
                elementName = element.getName();

                if (elementName.equals(attributeName)) {
                    element.setIsDisplayable(true);
                    element.setListBoxIndex(i);
                    //tokenize the string
                    tokenizedCriteria.append(attributeName);
					tokenizedCriteria.append(ISearch.ATTRIBUTE_INDEX_TOKENIZER);
					tokenizedCriteria.append(i);
					tokenizedCriteria.append(ISearch.ATTRIBUTE_NAME_TOKENIZER);
                }
            }
        }

        //	set display for search result
		tokenizedResult= new StringBuffer();
        for (int i = 0; i < resultAttributes.length; i++) {
            attributeName = resultAttributes[i];

            for (int j = 0; j < metaDatalist.size(); j++) {
                resultMetaData = (ResultMetaData) metaDatalist.get(j);
                elementName = resultMetaData.getName();

                if (elementName.equals(attributeName)) {
                    resultMetaData.setDisplayable(true);
                    resultMetaData.setListBoxIndex(i);
					//tokenize the string
					tokenizedResult.append(attributeName);
					tokenizedResult.append(ISearch.ATTRIBUTE_INDEX_TOKENIZER);
					tokenizedResult.append(i);
					tokenizedResult.append(ISearch.ATTRIBUTE_NAME_TOKENIZER);
                }
            }
        }
          //store the settings
		  catalogId=searchCriteriaBean.getCatalogId();
		  portletData=request.getData();
		  try {
			portletData.setAttribute(IBaseSearch.PREFIX_SEARCH_CRITERIA + catalogId ,tokenizedCriteria.toString());
			portletData.store();
			portletData.setAttribute(IBaseSearch.PREFIX_SEARCH_RESULT + catalogId ,tokenizedResult.toString());
			portletData.store();
		} catch (AccessDeniedException e) {
			throw new UIException();
		}
		catch (IOException e1) {
			throw new UIException();
		}
		  
    }


	public WPSContext getWpsContext() {
        return wpsContext;
    }

    public void setWpsContext(WPSContext wpsContext) {
        this.wpsContext = wpsContext;
    }

    public PortletContext getPortletContext() {
        return portletContext;
    }

    public void setPortletContext(PortletContext portletContext) {
        this.portletContext = portletContext;
    }

    public void setPortletName(String portletName) {
        this.portletName = portletName;
    }

    public String getPortletName() {
        return portletName;
    }
	public SearchFromHistoryCmd getCommand(){
			   return new SearchFromHistoryCmd();
		   }
}
