
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.portlets.searchutil;

import java.io.IOException;

import org.apache.jetspeed.portlet.Portlet;
import org.apache.jetspeed.portlet.PortletException;
import org.apache.jetspeed.portlet.PortletRequest;
import org.apache.jetspeed.portlet.PortletResponse;
import org.apache.jetspeed.portlet.PortletWindow;

import com.ibm.ccd.ui.portlets.search.core.BaseSearchPortlet;
import com.ibm.ccd.ui.portlets.search.core.cmd.ISearchCommand;
import com.ibm.ccd.ui.portlets.searchutil.cmd.SearchUtilViewDataStoreCmd;



public class SearchUtilPortlet extends BaseSearchPortlet {
    protected void render(PortletRequest request, PortletResponse response,
        Portlet.Mode mode) throws PortletException, IOException {
        String jspName = null;
 
        if(!((PortletWindow.State.SOLO.toString()).equals(request.getWindow().getWindowState().toString()))){
			getMessageMap(request).addInfoMessage("MESSAGE_CODE_140");
		}
        if (Portlet.Mode.VIEW.equals(mode)) {
            jspName = ISearchUtil.PATH_SEARCH_VIEW_JSP;
        }

        if (Portlet.Mode.EDIT.equals(mode)) {
            jspName = ISearchUtil.PATH_SEARCH_EDIT_JSP;
        }

        if (Portlet.Mode.CONFIGURE.equals(mode)) {
            jspName = ISearchUtil.PATH_SEARCH_CONFIG_JSP;
        }

        if (Portlet.Mode.HELP.equals(mode)) {
        }

        includeJSP(jspName, request, response);
    }

    protected ISearchCommand getDataStore(Portlet.Mode mode) {
        ISearchCommand command = null;

        if (Portlet.Mode.VIEW.equals(mode)) {
            command = new SearchUtilViewDataStoreCmd();
        } else {
            command = super.getDataStore(mode);
        }

        return command;
    }
}
