
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Aug 3, 2005
 *
 */
package com.ibm.ccd.ui.portlets.searchutil.cmd;

import org.apache.jetspeed.portlet.PortletRequest;
import org.apache.jetspeed.portlet.PortletResponse;
import org.apache.jetspeed.portlet.PortletSession;

import com.ibm.ccd.ui.context.IWPCUser;
import com.ibm.ccd.ui.context.WPCUser;
import com.ibm.ccd.ui.exception.UIException;
import com.ibm.ccd.ui.mediator.WPCMediatorException;
import com.ibm.ccd.ui.portlets.search.core.IBaseSearch;
import com.ibm.ccd.ui.portlets.search.core.cmd.PopulateViewDataStoreCmd;
import com.ibm.ccd.ui.util.IReference;
import com.ibm.ccd.ui.util.ValidationUtil;


public class SearchUtilViewDataStoreCmd extends PopulateViewDataStoreCmd {
    public SearchUtilViewDataStoreCmd() {
        super();
    }

    protected void setSearchCriteria(PortletRequest request,
        PortletResponse response) throws UIException, WPCMediatorException {
        setCurrentCatalog(request);
        super.setSearchCriteria(request, response);
    }

    private void setCurrentCatalog(PortletRequest request) {
        PortletSession portletSession = null;
        String catalogID = null;
        WPCUser user = null;
        String attributeName = null;

        catalogID = request.getParameter(IReference.KEY_CATALOG_NAME);
        attributeName = request.getParameter(IReference.KEY_ATTRIBUTE_NAME);

        if (!ValidationUtil.isNullOrEmpty(catalogID)) {
            user = wpsContext.getWpcUser();
            user.setProperty(IWPCUser.KEY_WPC_CATALOGUE_NAME, catalogID);
            portletSession = request.getPortletSession();

            portletSession.setAttribute(IReference.KEY_ATTRIBUTE_NAME,
                attributeName);

            //if catalog changes cached value is removed from session
            portletSession.setAttribute(IBaseSearch.KEY_SEARCH_CRITERIA_BEAN,
                null);
            portletSession.setAttribute(IBaseSearch.KEY_SEARCH_RESULTS_BEAN,
                null);
        }
    }
}
