/*
 * Licensed Materials: Property of IBM
 * "Restricted Materials of IBM"
 * 5724-I68.
 * (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

package com.ibm.ccd.ui.portlets.user.context;

import java.io.IOException;
import java.io.PrintWriter;

import org.apache.jetspeed.portlet.PortletException;
import org.apache.jetspeed.portlet.PortletRequest;
import org.apache.jetspeed.portlet.PortletResponse;
import org.apache.jetspeed.portlet.PortletSession;

import com.ibm.ccd.ui.context.IWPCUser;
import com.ibm.ccd.ui.context.WPCUser;
import com.ibm.ccd.ui.portlets.BasePortlet;
import com.ibm.ccd.ui.util.IReference;
import com.ibm.ccd.ui.util.UIUtils;

/**
 * @author Administrator
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class UserContextPortlet extends BasePortlet {

	public static String BUSINESS_FUNCTION_USER_CONTEXT = "USER_CONTEXT";

	public static String DEFAULT_ACTION_USER_CONTEXT = "CATALOG_VIEW";

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.ibm.ccd.ui.portlets.BasePortlet#setBusinessFunction(org.apache.jetspeed.portlet.PortletRequest)
	 */
	protected void setBusinessFunction(PortletRequest portletRequest) {
		PortletSession portletSession = portletRequest.getPortletSession();
		portletSession.setAttribute(IReference.SESSION_BUS_FUNCT,
				BUSINESS_FUNCTION_USER_CONTEXT);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.apache.jetspeed.portlet.PortletAdapter#doView(org.apache.jetspeed.portlet.PortletRequest,
	 *         org.apache.jetspeed.portlet.PortletResponse)
	 */
	public void doView(PortletRequest portletRequest,
			PortletResponse portletResponse) throws PortletException,
			IOException {
		// TODO Auto-generated method stub
		super.doView(portletRequest, portletResponse);
		setBusinessFunction(portletRequest);
		portletRequest.getSession().setAttribute(IReference.SESSION_ACTION,
				DEFAULT_ACTION_USER_CONTEXT);

		PrintWriter out = portletResponse.getWriter();
		WPCUser wpcUser = getWPSContext(portletRequest).getWpcUser();
				String currentCatalogId = null;
		String catalogName = UIUtils.getCatalogName(wpcUser);
		//String catalogName = (String) getWPSContext(portletRequest) 
		//		.getWpcUser().getProperty(IWPCUser.KEY_WPC_CATALOGUE_NAME);
		String displayString = this.getTextLabel(portletRequest, "NO_CATALOG");
		if (catalogName != null) {
			displayString = this.getTextLabel(portletRequest, "CATALOG") + catalogName;
		}
		out.println(displayString);
	}
}
