package com.ibm.ccd.ui.portlets.validation;

import java.io.IOException;

import org.apache.jetspeed.portlet.PortletAdapter;
import org.apache.jetspeed.portlet.PortletConfig;
import org.apache.jetspeed.portlet.PortletException;
import org.apache.jetspeed.portlet.PortletRequest;
import org.apache.jetspeed.portlet.PortletResponse;
import org.apache.jetspeed.portlet.PortletWindow;
import org.apache.jetspeed.portlet.UnavailableException;

import com.ibm.ccd.ui.exception.MessageMap;
import com.ibm.ccd.ui.util.IReference;


/**
 *
 * A sample portlet based on PortletAdapter
 * 
 */
public class ValidationErrorPortlet extends PortletAdapter {

    public static final String VIEW_JSP         = "/jsps/html/validationError/ValidationErrorPortletView.";     // JSP file name to be rendered on the view mode


    /**
	 * @see org.apache.jetspeed.portlet.Portlet#init(PortletConfig)
	 */
	public void init(PortletConfig portletConfig) throws UnavailableException {
		super.init(portletConfig);
	}

	/**
	 * @see org.apache.jetspeed.portlet.PortletAdapter#doView(PortletRequest, PortletResponse)
	 */
	public void doView(PortletRequest request, PortletResponse response) throws PortletException, IOException {
       	// Invoke the JSP to render
		if(!((PortletWindow.State.SOLO.toString()).equals(request.getWindow().getWindowState().toString()))){
			getMessageMap(request).addInfoMessage("MESSAGE_CODE_140");
		}
	    getPortletConfig().getContext().include(VIEW_JSP+getJspExtension(request), request, response);
	}

	/**
	 * getMessageMap:Method returns MessageMap after setting it in Request
	 * object
	 * 
	 * @param portletRequest
	 *            PortletRequest
	 */
	private MessageMap getMessageMap(PortletRequest portletRequest) {
		MessageMap mmap = null;
		mmap = (MessageMap) portletRequest.getAttribute(IReference.MESSAGE_KEY);

		if (mmap == null) {
			mmap = new MessageMap();
			portletRequest.setAttribute(IReference.MESSAGE_KEY, mmap);
		}

		return mmap;
	}

	/**
	 * Returns the file extension for the JSP file
	 * 
	 * @param request
	 *            PortletRequest
	 * @return JSP extension
	 */
	private static String getJspExtension(PortletRequest request) {
		String markupName = request.getClient().getMarkupName();
		return "jsp";
	}
	
}
