
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Dec 2, 2004
 */
package com.ibm.ccd.ui.services.user;


/**
 * This interface lists the LDAP related constants & Config file parameters
 */
public interface IUser {
    /**  Ldap User object class
     */
    public static final String OBJECTCLASS = "objectclass";

    /**  Ldap User object class wpcUserClass
     */
    public static final String INETORGPERSON = "inetOrgPerson";

    /**  Ldap User object class organizationalPerson
     */
    public static final String ORGANIZATIONALPERSON = "organizationalPerson";

    /**  Ldap User object class person
     */
    public static final String PERSON = "person";

    /**  Ldap User object class TOP
     */
    public static final String TOP = "top";

    /**  Ldap User object class Attribute cn
     */
    public static final String USER_CN = "cn";

    /**  Ldap User object class Attribute sn
     */
    public static final String USER_SN = "sn";

    /**  Ldap User object class Attribute SupplierGLN
     */
    public static final String SUPPLIER_GLN = "SupplierGLN";

    /**  Ldap User object class Attribute preferredLanguage
     */
    public static final String PREFERRED_LANGUAGE = "preferredLanguage";

    /**  Ldap User object class Attribute preferredLanguage
     */
    public static final String RESTRICTED_LANGUAGE = "restrictedLocale";
    
    /**  Ldap User object class Attribute uid
     */
    public static final String USER_ID = "uid";

    /**  Ldap User object class Attribute userPassword
     */
    public static final String USER_PASSWORD = "userPassword";

    /**  Ldap User object class Attribute givenName
     */
    public static final String USER_GIVENNAME = "givenName";

    /**  Ldap User object class Attribute userStatus
     */
    public static final String USER_STATUS = "userStatus";

    /**  Ldap User object class Attribute company
     */
    public static final String USER_COMPANY = "companyName";

    /**  Ldap User object class Attribute WPCRole
     */
    public static final String USER_WPCROLE = "WPCRole";

    /**  Ldap User object class Attribute mail
     */
    public static final String MAIL = "mail";

    /**  Ldap User object class Attribute wpcUserName
     */
    public static final String WPC_USER_NAME = "wpcUserName";

    /**  Ldap User object class Attribute userStatus value true
     */
    public static final String USER_STATUS_TRUE = "true";

    /**  Ldap User object class Attribute userStatus value false
     */
    public static final String USER_STATUS_FALSE = "false";

    /**  Portal Server Insallation root added in JVM Settings
     */
    public static final String WPS_INSTALL_DIR = "WPS_INSTALL_DIR";

    /**  Ldap related constants present in <WP_ROOT>/config/wpconfig.properties file
     */
    public static final String LDAP_HOSTNAME = "LDAPHostName";
    public static final String LDAP_PORT = "LDAPPort";
    public static final String LDAP_ADMIN_UID = "LDAPAdminUId";
    public static final String LDAP_ADMIN_PWD = "LDAPAdminPwd";
    public static final String LDAP_WEB_TOOLPORT = "LDAPWebToolPort";
    public static final String LDAP_SUFFIX = "LDAPSuffix";
    public static final String LDAP_USERSUFFIX = "LDAPUserSuffix";

    /**  Ldap related Environmental constants
     */
    public static final String LDAP_FACTORY_PACKAGE = "java.naming.factory.url.pkgs";
    public static final String LDAP_JNDI = "com.ibm.jndi";
    public static final String LDAP_FACTORY_INITIAL = "java.naming.factory.initial";
    public static final String LDAP_CONTEXT_FACTORY = "com.ibm.jndi.LDAPCtxFactory";
    public static final String LDAP_NAMING_URL = "java.naming.provider.url";
    public static final String LDAP_SECURITY_USERNAME = "java.naming.security.principal";
    public static final String LDAP_SECURITY_PASSWORD = "java.naming.security.credentials";
}
