
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * This package consists of classes pertaining to Supplier Portal User,
 * Login and LDAP access related functionality.
 */
package com.ibm.ccd.ui.services.user;


/**
 * A User Java bean that stores instance data of the Supplier Portal User.
 */
public class UserBean {
    /** Parameter name for DEFAULT_USER_STATUS
     */
    public static String DEFAULT_USER_STATUS = "false";

    /** Parameter name for DEFAULT_USER_ROLE
     */
    public static String DEFAULT_USER_ROLE = "wpsUser";

    /** Parameter name for DEFAULT_USER_FIELD_VALUE
     */
    public static String DEFAULT_USER_FIELD_VALUE = "";

    /** Parameter name for DEFAULT_WPC_USER_NAME
     */
    public static String DEFAULT_WPC_USER_NAME = "wpcUserName";

    /** Parameter name for SupplierGLN
     */
    private String SupplierGLN = DEFAULT_USER_FIELD_VALUE;

    /** Parameter name for userName
     */
    private String userName = DEFAULT_USER_FIELD_VALUE;

    /** Parameter name for userPassword
     */
    private String userPassword = DEFAULT_USER_FIELD_VALUE;

    /** Parameter name for confirmPassword
     */
    private String confirmPassword = DEFAULT_USER_FIELD_VALUE;

    /** Parameter name for userStatus
     */
    private String userStatus = DEFAULT_USER_STATUS;

    /** Parameter name for eMail
     */
    private String eMail = DEFAULT_USER_FIELD_VALUE;

    /** Parameter name for company
     */
    private String company = DEFAULT_USER_FIELD_VALUE;

    /** Parameter name for wpcRole
     */
    private String wpcRole = DEFAULT_USER_ROLE;

    /** Parameter name for errorMessage
     */
    private String errorMessage = DEFAULT_USER_FIELD_VALUE;

    /** Parameter name for successMessage
     */
    private String successMessage = DEFAULT_USER_FIELD_VALUE;

    /** Parameter name for wpcUserName
     */
    private String wpcUserName = DEFAULT_WPC_USER_NAME;

    /** Parameter name for preferredLanguage
     */
    private String preferredLanguage = DEFAULT_USER_FIELD_VALUE;
    
	/** Parameter name for restrictedLanguage
	 */
	private String restrictedLanguage = DEFAULT_USER_FIELD_VALUE ;
    

    /**
     * @return userGLN
     */
    public String getSupplierGLN() {
        return SupplierGLN;
    }

    /**
     * @param userGLN
     */
    public void setSupplierGLN(String SupplierGLN) {
        this.SupplierGLN = SupplierGLN;
    }

    /**
     * @return userName
     */
    public String getUserName() {
        return userName;
    }

    /**
     * @param userName
     */
    public void setUserName(String userName) {
        this.userName = userName;
    }

    /**
     * @return userPassword
     */
    public String getPassword() {
        return userPassword;
    }

    /**
     * @param userPassword
     */
    public void setPassword(String userPassword) {
        this.userPassword = userPassword;
    }

    /**
     * @return confirmPassword
     */
    public String getConfirm_password() {
        return confirmPassword;
    }

    /**
     * @param confirmPassword
     */
    public void setConfirm_password(String confirmPassword) {
        this.confirmPassword = confirmPassword;
    }

    /**
     * @return userStatus
     */
    public String getUserStatus() {
        return userStatus;
    }

    /**
     * @param userStatus
     */
    public void setUserStatus(String userStatus) {
        this.userStatus = userStatus;
    }

    /**
     * @return eMail
     */
    public String getMail() {
        return eMail;
    }

    /**
     * @param eMail
     */
    public void setMail(String eMail) {
        this.eMail = eMail;
    }

    /**
     * @return company
     */
    public String getCompany() {
        return company;
    }

    /**
     * @param company
     */
    public void setCompany(String company) {
        this.company = company;
    }

    /**
     * @return wpcRole
     */
    public String getWpcrole() {
        return wpcRole;
    }

    /**
     * @param wpcRole
     */
    public void setWpcrole(String wpcRole) {
        this.wpcRole = wpcRole;
    }

    /**
     * @return
     */
    public String getErrorMessage() {
        return errorMessage;
    }

    /**
     * @param errorMessage
     */
    public void setErrorMessage(String errorMessage) {
        this.errorMessage = errorMessage;
    }

    /**
     * @return successMessage
     */
    public String getSuccessMessage() {
        return successMessage;
    }

    /**
     * @param successMessage
     */
    public void setSuccessMessage(String successMessage) {
        this.successMessage = successMessage;
    }

    /**
     * @return wpcUserName
     */
    public String getWpcUserName() {
        return wpcUserName;
    }

    /**
         * @param wpcUserName
         */
    public void setWpcUserName(String wpcUserName) {
        this.wpcUserName = wpcUserName;
    }

    /**
          * @return preferredLanguage
          */
    public String getPreferredLanguage() {
        return preferredLanguage;
    }

    /**
          * @param preferredLanguage
          */
    public void setPreferredLanguage(String preferredLanguage) {
        this.preferredLanguage = preferredLanguage;
    }
	/**
	 * @return
	 */
	public String getRestrictedLanguage() {
		return restrictedLanguage;
	}

	/**
	 * @param string
	 */
	public void setRestrictedLanguage(String string) {
		restrictedLanguage = string;
	}

}
