
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/**
 * This interface defines all the constants related to UI Custom Tags
 *
 */
package com.ibm.ccd.ui.tags;

public interface ITagConstants {
    /**
     * Identifier for maximum length of field
     */
    public final static int DEFAULT_TEXT_MAXLENGTH = 255;

    /**
     * Identifier for ENTRY_FIELD_LENGTH
     */
    public static final int DEFAULT_FIELD_SIZE = 30;

    /**
     * Identifier for SIZE OF LISTBOX
     */
    public static final int DEFAULT_LISTBOX_SIZE = 5;

    /**
     * Identifier for UPLOAD_TEXT_FIELD_LENGTH
     */
    public static final int UPLOAD_TEXT_FIELD_LENGTH = DEFAULT_FIELD_SIZE;

    /**
     * Identifier for default Flag is true
     */
    public static final String DEFAULT_FLAG = "true";

    /**
     * Identifier for attribute Constant
     */
    public static final String VAR_PORTLET_CONFIG = "portletConfig";

    /**
     * Identifier for attribute Constant
     */
    public static final String VAR_PORTLET_REQUEST = "portletRequest";

    /**
     * Identifier for attribute Constant
     */
    public static final String VAR_PORTLET_RESPONSE = "portletResponse";

    /**
     * Identifier for default Currency to appear before currency field
     */
    public static final String DEFAULT_CURRENCY = "";

    /**
     * Identifier for constant for Javascript check mandatory
     */

    /*  The same code should be there js file for validations */
    public String JS_MANDATORYCHK = "1";

    /**
     * Identifier for constant for Javascript check Minimum value
     */
    public String JS_MINVALUECHK = "2";

    /**
     * Identifier for constant for Javascript check Minimum value
     */
    public String JS_NUMBERVALUECHK = "3";

    /**
     * Identifier for constant for Javascript check Minimum value
     *
     */
    public String JS_MINRANGECHK = "4";

    /**
     * Identifier for constant for Javascript check Minimum value
     */
    public String JS_MAXRANGECHK = "5";

    /**
     * attribute stores the default value of class of style of html tags
     */
    public String DEFAULT_EDIT_STYLE = "wpsEditField";

    /**
     * attribute stores the default value of class of style of label tags
     */
    public String DEFAULT_LABEL_STYLE = "wpsLabelText";

    /**
     * attribute defined for paths of images.This images used in error message display
     */
    public String IMAGE_PATH = "/images/";

    /**
     * attribute defined for Fatal Error image.
     */
    public String FATAL_IMAGE_PATH = IMAGE_PATH + "fatal.gif";

    /**
     * attribute defined for Error image.
     */
    public String ERROR_IMAGE_PATH = IMAGE_PATH + "error.gif";

    /**
     * attribute defined for Warning image.
     */
    public String WARN_IMAGE_PATH = IMAGE_PATH + "warning.gif";

    /**
     * attribute defined for Info image
     */
    public String INFO_IMAGE_PATH = IMAGE_PATH + "info.gif";

    /**
     * attribute defined for Debug image
     */
    public String DEBUG_IMAGE_PATH = IMAGE_PATH + "debug.gif";
}
