
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Apr 11, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.ibm.ccd.ui.tags;

import java.io.IOException;

import org.apache.jetspeed.portlet.PortletRequest;
import org.apache.jetspeed.portlet.PortletResponse;
import org.apache.jetspeed.portlet.PortletSession;

import com.ibm.ccd.ui.dataobjects.attributes.Attribute;
import com.ibm.ccd.ui.dataobjects.attributes.DateAttribute;
import com.ibm.ccd.ui.dataobjects.items.CatalogItem;
import com.ibm.ccd.ui.util.UIUtils;


/**
 * @author Senthil kumar
 *
 * UIDatePickerTag is to display DateTime
 *
 */
public class UIDatePickerTag extends BaseUITag {
    PortletRequest portletRequest;

    public UIDatePickerTag() {
        super();
    }

    /**
     * @see com.ibm.ccd.ui.tags.BaseUITag#renderField()
     */
    protected void renderField() throws Exception {
        try {
            StringBuffer htmlCode = new StringBuffer("");
            htmlCode.append("<TD ALIGN =\"LEFT\">");

            if (isEnabled()) {
                renderCalendarScript(htmlCode, name);
            } else {
                if ((value != null) && !("null".equalsIgnoreCase(value))) {
                    htmlCode.append(" " + value);
                }
            }

            htmlCode.append("</TD>");
            out.print(htmlCode.toString());
            log.debug(" renderField <- ");
        } catch (IOException e) {
            log.error(UIUtils.getTextMessages(portletContext, locale,
                    "MESSAGE_CODE_57"));
            e.printStackTrace();
        }
    }

    protected void renderCalendarScript(StringBuffer htmlCode, String calendarId) {
        StringBuffer buffer = new StringBuffer();
        String calendarId1 = calendarId;
        calendarId = calendarId.substring(calendarId.lastIndexOf('/') + 1);

        for (int i = 0; i < calendarId.length(); i++) {
            if (Character.isSpaceChar(calendarId.charAt(i))) {
                continue;
            }

            if (calendarId.charAt(i) != '/') {
                buffer.append(calendarId.charAt(i));
            }
        }

        String encodeurl = ((PortletResponse) pageContext.getAttribute(
                "portletResponse")).encodeURL("/");

        PortletRequest portletRequest = (PortletRequest) pageContext.getAttribute(
                "portletRequest");

        PortletSession portletSession = portletRequest.getPortletSession();

        CatalogItem item = (CatalogItem) portletSession.getAttribute("Item");

        Attribute attrib = item.getAttribute(calendarId1);

        DateAttribute dateAttrib = null;

        String fieldValue = portletRequest.getParameter(calendarId1);

        if ((fieldValue == null) || (fieldValue.trim().length() == 0)) {
            fieldValue = value;
        }

        htmlCode.append("<script language=\"JavaScript\"> ");
        htmlCode.append("document.write(placeCalendar('" + buffer + "','" +
            encodeurl + "','" + calendarId1 + "','" + fieldValue + "'));");
        htmlCode.append("</script>");

        htmlCode.append("<input type=\"hidden\" id=\"" + calendarId1 +
            "\" name=\"" + calendarId1 + "\" value=\"" + fieldValue + "\" >");
    }
}
