
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/**
 * This class is the tag implementation for the File Upload input.
 * Tag attributes
 * Tags inherited from Base tag
 * name
 * id
 * value
 * mandatory
 * style
 * size
 * alt
 * enabled
 */
package com.ibm.ccd.ui.tags;

import java.io.IOException;


public class UIFileUploadTag extends BaseUITag {
    /**
     * renderField : This method renders HTML Dropdown field to response object
     */
    protected void renderField() throws Exception {
        log.debug(" renderField ->");

        try {
            StringBuffer htmlCode = new StringBuffer("");
            htmlCode.append("<TD ALIGN =\"LEFT\">");

            if (value != null) {
                if (isEnabled()) {
                    uploadHtmlString(htmlCode);
                } else {
                    if (!("null".equalsIgnoreCase(value))) {
                        htmlCode.append(" " + value);
                    }
                }
            }

            htmlCode.append("</TD>");
            out.print(htmlCode.toString());
            log.debug(" renderField <- ");
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * uploadHtmlString: This method generates string file input
     * @param htmlCode
     */
    protected void uploadHtmlString(StringBuffer htmlCode) {
        htmlCode.append("<input TYPE=\"FILE\" NAME=\"" + name + "\"");
        htmlCode.append(" id=\"" + id + "\"");
        htmlCode.append(" alt=\"" + getAlt() + "\"");
        htmlCode.append(" class=\"" + getStyle() + "\"");
        htmlCode.append(" size=\"" + UPLOAD_TEXT_FIELD_LENGTH + "\"");
        htmlCode.append(" >");
    }
}
