
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Aug 11, 2005
 *
 */
package com.ibm.ccd.ui.tags;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;

import com.ibm.ccd.ui.portlets.search.core.ICollectionViewBean;
import com.ibm.ccd.ui.taglib.dataobjects.ResultMetaData;
import com.ibm.ccd.ui.taglib.dataobjects.ResultRowData;
import com.ibm.ccd.ui.util.UIUtils;


public class UISearchUtilResultTag extends UISearchResultTag {
    
	/**
	    *@desc Item primary key should be displayed as normal text in SearchUtil portlet and not as hyperlink.
	    *  @throws java.io.IOException
	    * @since Iteration 2
	    */
	    protected void constructRows() throws IOException {
	        boolean flag = true;
	        ResultMetaData metaData = null;
	        ArrayList resultRows = resultsBean.getResultsRows();

	        if (resultRows.isEmpty()) {
	            return;
	        }

	        rowData = new ResultRowData[resultRows.size()];

	        Iterator iterator = resultRows.iterator();
	        int j = 0;

	        while (iterator.hasNext() && (j < resultRows.size())) {
	            ResultRowData resultRowData = (ResultRowData) iterator.next();
	            rowData[j] = resultRowData;
	            j++;
	        }

	        for (int z = 0; z < rowData.length; ++z) {
	            if (flag) {
	                out.print("<TR class=\"wpcGridOddRow\">");
	                flag = false;
	            } else {
	                out.print("<TR class=\"wpcGridEvenRow\">");
	                flag = true;
	            }

	            HashMap dataElements = rowData[z].getRowElements();
	            displayPrimaryKey(dataElements);

	            int size = resultMetaDataArray.length;

	            for (int k = 0; k < size; ++k) {
	                metaData = resultMetaDataArray[k];
	                out.print("<TD CLASS=\"wpcTightRightPaddedNonwrappingCell\">");

	                String colName = metaData.getName();
	                Object textValueObject = dataElements.get(colName);
	                String textValue = "";

	                if (textValueObject != null) {
	                    textValue = UIUtils.escapeForHTML(textValueObject.toString());
	                }

	                switch (metaData.getType()) {
	                case ICollectionViewBean.LINK: {
	                    out.print("<A href=\"javascript:openSelectedObject('" +
	                        "EMPTY_ACTION FOR ELEMENTS" + "',");
	                    out.print("'" + rowData[z].getRowReference() + "',");
	                    out.print("'" + "EMPTY_OPENMODE" + "'");
	                    out.print(");\">");

	                    String spaceIndicator = (textValue.trim().length() > 0)
	                        ? textValue : ("<" + textValue + ">");
	                    out.print(spaceIndicator);
	                    out.print("</A>");

	                    break;
	                }

	                default:

	                    String displayValue = null;
	                    displayValue = getDisplayValue(colName, UIUtils.unescapeForHTML(textValue));
	                    out.print(displayValue);
	                }

	                out.print("</TD>");
	            }

	            out.print("</TR>");
	        }
	    }
	
	protected void displayPrimaryKey(HashMap dataElements)
        throws IOException {
        String textValue = "";
        String inputType = "radio";

        Object textValueObject = dataElements.get(primaryKey);

        if (textValueObject != null) {
            textValue = UIUtils.escapeForHTML(textValueObject.toString());
        }

        out.print("<TD CLASS=\"wpcGridCheckboxCell\">");
        out.print("<INPUT TYPE=\"" + inputType +
            "\" name ='itemPrimaryKey' value='" + textValue + "' />");
        out.print("</TD>");
    }

    protected void displayTitle() throws IOException {
        //SearchUtilResult allows single selections, so check all control is not equired
        out.print("<TD CLASS=\"wpcGridColumnHeadings\">");

        //out.print("&nbsp;");
        out.print("</TD>");

        return;
    }
}
