
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.tags;

import java.io.IOException;
import java.util.ArrayList;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspTagException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.TagSupport;

import org.apache.jetspeed.portlet.PortletConfig;
import org.apache.jetspeed.portlet.PortletContext;
import org.apache.jetspeed.portlet.PortletRequest;

import com.ibm.ccd.ui.util.IReference;
import com.ibm.ccd.ui.util.UIUtils;


public class UISelectListTag extends TagSupport {
    /**
     * indicates the default style
     */
    public static final String DEFAULT_STYLE = "width:250px";

    /**
     *  to write the HTML output.
     */
    private JspWriter out;
    PortletContext portletContext = null;
    PortletRequest portletRequest = null;
    private String size = null;
    private String name = null;
    private ArrayList list = null;
    private String source = null;
    private String destination = null;
    private String style = null;
    private ISelectListTag[] orderedList = null;

    public UISelectListTag() {
        super();
    }

    /**
     * @purpose This method is the first method that gets called for Custom Tags.
     * @desc The doStartTag() method initializes output stream.and calls the generate SearchTable.
     *                  This method initializes the  SearchCriteriaElements to be used by the generateSearchTable().
     * @throws javax.servlet.jsp.JspException
     * @return int
     * @since Iteration 2
     */
    public int doStartTag() throws JspException {
        try {
            PortletConfig portletconfig = (PortletConfig) pageContext.getAttribute(ITagConstants.VAR_PORTLET_CONFIG);
            portletContext = portletconfig.getContext();
            portletRequest = (PortletRequest) pageContext.getAttribute(ITagConstants.VAR_PORTLET_REQUEST);
            out = pageContext.getOut();
            orderList();
            display();
        } catch (Exception ex) {
            throw new JspTagException(ex.getMessage());
        }

        return SKIP_BODY;
    }

    /**
     * @return
     */
    public ArrayList getList() {
        return list;
    }

    /**
     * @return
     */
    public String getName() {
        return name;
    }

    /**
     * @return
     */
    public String getSize() {
        return size;
    }

    /**
     * @param list
     */
    public void setList(ArrayList list) {
        this.list = list;
    }

    /**
     * @param string
     */
    public void setName(String string) {
        name = string;
    }

    /**
     * @param string
     */
    public void setSize(String string) {
        size = string;
    }

    private void orderList() {
        ISelectListTag iList = null;
        int size = list.size();
        int index=-1;
        int listBoxIndex = 0;
        int count = 0;

        for (int i = 0; i < size; i++) {
            iList = (ISelectListTag) list.get(i);

            if (iList.isSelected()) {
                count++;
            }
        }

        orderedList = new ISelectListTag[count];

        for (int i = 0; i < size; i++) {
            iList = (ISelectListTag) list.get(i);

            if (iList.isSelected()) {
                listBoxIndex = iList.getListBoxIndex();
                if(listBoxIndex>=0){
					orderedList[listBoxIndex] = iList;
                }else{
					orderedList[++index] = iList;
                }
                
            }
        }
    }

    private void display() throws IOException {
        int size = 0;
        ISelectListTag iList = null;
        String list1Name = getName() + "_1";
        String list2Name = getName();
        String name = null;
        String displayName = null;

        out.println("<TABLE border=\"0\">");
        out.println("<TR><TD ALIGN=\"CENTER\">" + getSource() + "</TD>");
        out.println("<TD ALIGN=\"CENTER\">&nbsp;</TD>");
        out.println("<TD ALIGN=\"CENTER\">" + getDestination() + "</TD>");
        out.println("<TD ALIGN=\"CENTER\">&nbsp;</TD></TR>");        
        out.println("<TR><TD><SELECT  style=\"" + getStyle() + "\"  name=\"" +
            list1Name + "\"  id=\"" + list1Name + "\" size=" + getSize() +
            "\"  multiple=\"multiple\" >");
        size = list.size();

        for (int i = 0; i < size; i++) {
            iList = (ISelectListTag) list.get(i);
            name = iList.getName();

            if (name.equals(IReference.SUPPLIER_ATTR_NAME)) {
                continue;
            }

            if (!iList.isSelected()) {
                out.println("<OPTION value=\"" + name + "\">");
                displayName = iList.getDisplayName();
                out.println(displayName);
                out.println("</OPTION>");
            }
        }

        out.println("</SELECT></TD>");

        out.println("<TD>");
        out.println(
            "<input type=\"button\" class=\"wpsButtonBlueSmall\" name=\"oneright\" value=\"&gt;\" onClick=\"moveOptions(this.form." +
            list1Name + ", this.form." + list2Name + ",false)\"><br>");
        out.println(
            "<input type=\"button\" class=\"wpsButtonBlueSmall\" name=\"allright\" value=\"&gt;&gt;\" onClick=\"moveOptions(this.form." +
            list1Name + ", this.form." + list2Name + ",true)\"><br>");
        out.println(
            "<input type=\"button\" class=\"wpsButtonBlueSmall\" name=\"allleft\" value=\"&lt;&lt;\" onClick=\"moveOptions(this.form." +
            list2Name + ", this.form." + list1Name + ",true)\"><br>");
        out.println(
            "<input type=\"button\" class=\"wpsButtonBlueSmall\" name=\"oneleft\" value=\"&lt;\" onClick=\"moveOptions(this.form." +
            list2Name + ", this.form." + list1Name + ",false)\"><br>");

        out.println("</TD>");

        out.println("<TD><SELECT style=\"" + getStyle() + "\" name=\"" +
            list2Name + "\"  id=\"" + list2Name + "\" size=\"" + getSize() +
            "\" multiple=\"multiple\">");
        size = orderedList.length;

        for (int i = 0; i < size; i++) {
            iList = orderedList[i];

            if (iList.isSelected()) {
                out.println("<OPTION value=\"" + iList.getName() + "\">");
                out.println(iList.getDisplayName());
                out.println("</OPTION>");
            }
        }

        out.println("</SELECT></TD>");
        out.println("<TD>");
        out.println(
            "<input type=\"button\" class=\"wpsButtonBlueSmall\" name=\"allleft\" value=\"^\" onClick=\"moveOptionsUp(this.form." +
            list2Name + ")\"><br>");
        out.println(
            "<input type=\"button\" class=\"wpsButtonBlueSmall\" name=\"allright\" value=\"V\" onClick=\"moveOptionsDown(this.form." +
            list2Name + ")\"><br>");
        out.println("</TD></TR>");
        out.println("</TABLE>");
    }

    /**
     * @return
     */
    public String getSource() {
        String value = null;
        value = UIUtils.getTextLabel(portletContext, portletRequest, source);

        return value;
    }

    /**
     * @return
     */
    public String getDestination() {
        String value = null;
        value = UIUtils.getTextLabel(portletContext, portletRequest, destination);

        return value;
    }

    /**
     * @param string
     */
    public void setSource(String string) {
        source = string;
    }

    /**
     * @param string
     */
    public void setDestination(String string) {
        destination = string;
    }

    /**
     * @return
     */
    public String getStyle() {
        if (style == null) {
            style = DEFAULT_STYLE;
        }

        return style;
    }

    /**
     * @param string
     */
    public void setStyle(String string) {
        style = string;
    }
}
