
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/**
 *
 * This class is the tag implementation for the Textbox input and password input.Javascript is disabled.
 * Tag attributes
 * maxValue : Maximum length of textbox.
 * Inherited from Base tag
 * name
 * id
 * value
 * mandatory
 * style
 * size
 * alt
 * enabled
 */
package com.ibm.ccd.ui.tags;

import java.io.IOException;

import com.ibm.ccd.ui.util.UIUtils;


public class UITextAttachFileTag extends BaseUITag {
    private String maxValue = String.valueOf(DEFAULT_TEXT_MAXLENGTH);

    /**
     * attribute to decide whether text input is password or simple text input
     */
    /**
     * Constructor
     */
    public UITextAttachFileTag() {
        super();
    }

    /*
     * This method renders HTML text field to response object
     */
    protected void renderField() throws Exception {
        log.debug(" renderField ->");

        try {
            StringBuffer htmlCode = new StringBuffer("");

            //StringBuffer htmlField = new StringBuffer("");
            htmlCode.append("<TD ALIGN =\"LEFT\">");

            if (isEnabled()) {
                renderTextAttachTagHtml(htmlCode);
            } else {
                if ((value != null) && !("null".equalsIgnoreCase(value))) {
                    htmlCode.append(" " + value);
                }
            }

            htmlCode.append("</TD>");
            out.print(htmlCode.toString());
            log.debug(" renderField <- ");
        } catch (IOException e) {
            log.error(UIUtils.getTextMessages(portletContext, locale,
                    "MESSAGE_CODE_57"));
            e.printStackTrace();
        }
    }

    protected void renderTextAttachTagHtml(StringBuffer htmlCode) {
        htmlCode.append("<input type=\"");
        htmlCode.append("text\"");
        htmlCode.append(" name=\"" + name + "\"");

        if ((value != null) && !("null".equalsIgnoreCase(value))) {
            htmlCode.append(" value=\"" + value + "\"");
        }

        htmlCode.append(" id=\"" + id + "\"");
        htmlCode.append(" alt=\"" + getAlt() + "\"");

        try {
            htmlCode.append(" class=\"" + getStyle() + "\"");
            htmlCode.append(" size=\"" + getSize() + "\"");
            htmlCode.append(" maxlength=\"" + maxValue + "\"");
        } catch (Exception eh) {
            log.warn(UIUtils.getTextMessages(portletContext, locale,
                    "MESSAGE_CODE_55"));
            eh.printStackTrace();
        }

        htmlCode.append(" readonly >&nbsp;");
        htmlCode.append("<input type=\"");
        htmlCode.append("Button\"");
        htmlCode.append(" name=\"" + name + "_BUTTON\"");

        if ((value != null) && !("null".equalsIgnoreCase(value))) {
            htmlCode.append(" value=\"" +
                UIUtils.getTextLabel(portletContext, locale, "ATTACH_BUTTON") +
                "\"");
        }

        htmlCode.append(" id=\"" + id + "_BUTTON\"");
        htmlCode.append(" class=\"wpsButtonText\"");

        htmlCode.append(" size=\"10\" ");
        htmlCode.append(" onClick=\"javascript:openWin('" + id + "')\">");
    }

    /**
     * @return
     */
    public String getMaxValue() {
        return maxValue;
    }

    /**
     * @param string
     */
    public void setMaxValue(String string) {
        maxValue = string;
    }
}
