
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.tags;

import java.io.IOException;
import java.util.Enumeration;

import javax.servlet.jsp.JspWriter;

import org.apache.jetspeed.portlet.PortletContext;
import org.apache.jetspeed.portlet.PortletLog;
import org.apache.jetspeed.portlet.PortletResponse;
import org.apache.jetspeed.portlet.PortletURI;

import com.ibm.ccd.ui.portlets.catalog.CatalogTree;
import com.ibm.ccd.ui.portlets.catalog.ItemNodeCatalog;


/**
 *  UITag to render HTML Tree
 */
public class UITreeTag extends BaseUITag {
    private boolean flag;
    private StringBuffer buffer;
    private ItemNodeCatalog treeNode;
    private CatalogTree catalog;
    private PortletURI expand;
    private PortletURI select;
    private JspWriter out;
    private String encodeurl;
    private Object selitem;
    private String sItem;
    private String hideitem;    
    private String encoded_itemForm;

    public UITreeTag() {
    }

    /**
     * @see javax.servlet.jsp.tagext.TagSupport#doStartTag()
     */
    public int doStartTag() {
        buffer = new StringBuffer();
        out = pageContext.getOut();

        PortletResponse portletResponse = (PortletResponse) pageContext.getAttribute(
                "portletResponse");

        encodeurl = portletResponse.encodeURL("/images/");

        encoded_itemForm = portletResponse.encodeNamespace("itemForm");

        sItem = String.valueOf(selitem);

        if (catalog != null) {
            try {
                traverse(catalog.getRoot());
            } catch (Exception e) {
                throw new Error(e.getMessage());
            }
        }

        return SKIP_BODY;
    }

    /**
     * @see javax.servlet.jsp.tagext.TagSupport#doEndTag()
     */
    public int doEndTag() {
        try {
            out.println(buffer.toString());
        } catch (Exception e) {
            throw new Error(e.getMessage());
        }

        return 0;
    }

    public void traverse(ItemNodeCatalog tree) throws IOException {
        if (!tree.isLeaf()) {
            if (tree.isExpanded()) {
                buffer.append("<ul " + ((!flag) ? "id=\"menu\" " : "") +
                    " class=\"open\">");
            } else {
                buffer.append("<ul " + ((!flag) ? "id=\"menu\" " : "") + ">");
            }

            flag = true;

            Enumeration enumValues = tree.children();

            while (enumValues.hasMoreElements()) {
                ItemNodeCatalog item = (ItemNodeCatalog) enumValues.nextElement();

                String expandCmd = expand.toString();

                String command = select.toString();

                if (item.isLeaf()) {
                    
                	if ((item.getType() == CatalogTree.ITEM) && (isHideItem())) {                		
               			continue;
					}
                    
                    if (item.getType() == CatalogTree.ITEM) {
                        if (item.getId().equals(sItem)) {
                            buffer.append("<li><img src=\"" + encodeurl +
                                "book_leaf.gif\" alt=\"" + item +
                                "\" border=\"0\" class=\"imgNode\"><span class='seltxt'>" +
                                item.getDisplayName() + "</span></li>");
                        } else {
                            buffer.append("<li><img src=\"" + encodeurl +
                                "book_leaf.gif\" alt=\"" + item +
                                "\" border=\"0\" class=\"imgNode\"><a href=\"" +
                                "JavaScript:treenode_onclick('" +
                                encoded_itemForm + "','" + command + "','" +
                                item.getId() + "');\" " +
                                "\" class=\"linker\"><span class='txt'>" +
                                item.getDisplayName() + "</span></a></li>");
                        }
                    } else {
                    	if(item.isExpanded()) {
							if (item.getId().equals(sItem)) {
								buffer.append("<li><a href=\"" +
									"JavaScript:treenode_onclick('" +
									encoded_itemForm + "','" + expandCmd + "','" +
									item.getId() + "'); " + "\"><img src=\"" +
									encodeurl +
									"minus.gif\" alt=\"Collapse\" border=\"0\" class=\"imgExpand\"></a><img src=\"" +
									encodeurl + "open_book.gif\" alt=\"" + item +
									"\" alt=\"open_book.gif\" border=\"0\" class=\"imgFolderOpen\"> <span class='seltxt'>" +
									item.getDisplayName() + "</span></li>");
							} else {
								buffer.append("<li><a href=\"" +
									"JavaScript:treenode_onclick('" +
									encoded_itemForm + "','" + expandCmd + "','" +
									item.getId() + "'); " + "\"><img src=\"" +
									encodeurl +
									"minus.gif\" alt=\"Collapse\" border=\"0\" class=\"imgExpand\"></a><img src=\"" +
									encodeurl + "open_book.gif\" alt=\"" + item +
									"\" alt=\"open_book.gif\" border=\"0\" class=\"imgFolderOpen\"><a href=\"" +
									"JavaScript:treenode_onclick('" +
									encoded_itemForm + "','" + command + "','" +
									item.getId() + "');\" " +
									"\" class=\"linker\"><span class='txt'>" +
									item.getDisplayName() + "</span></a></li>");
							}
                    	}else {
							if (item.getId().equals(sItem)) {
								buffer.append("<li><a href=\"" +
									"JavaScript:treenode_onclick('" +
									encoded_itemForm + "','" + expandCmd + "','" +
									item.getId() + "'); " + "\"><img src=\"" +
									encodeurl +
									"plus.gif\" alt=\"Expand\" border=\"0\" class=\"imgCollapse\"></a><img src=\"" +
									encodeurl + "closed_book.gif\" alt=\"" + item +
									"\" border=\"0\" class=\"imgFolderClose\"> <span class='seltxt'> " +
									item.getDisplayName() + "</span></li>");
							} else {
								buffer.append("<li><a href=\"" +
									"JavaScript:treenode_onclick('" +
									encoded_itemForm + "','" + expandCmd + "','" +
									item.getId() + "'); " + "\"><img src=\"" +
									encodeurl +
									"plus.gif\" alt=\"Expand\" border=\"0\" class=\"imgCollapse\"></a><img src=\"" +
									encodeurl + "closed_book.gif\" alt=\"" + item +
									"\" border=\"0\" class=\"imgFolderClose\"><a href=\"" +
									"JavaScript:treenode_onclick('" +
									encoded_itemForm + "','" + command + "','" +
									item.getId() + "');\" " +
									"\" class=\"linker\"> <span class='txt'> " +
									item.getDisplayName() + "</span></a></li>");
							}
                    	}
                    }
                } else {
                    if (item.isExpanded()) {
                        if (item.getId().equals(sItem)) {
                            buffer.append("<li><a href=\"" +
                                "JavaScript:treenode_onclick('" +
                                encoded_itemForm + "','" + expandCmd + "','" +
                                item.getId() + "'); " + "\"><img src=\"" +
                                encodeurl +
                                "minus.gif\" alt=\"Collapse\" border=\"0\" class=\"imgExpand\"></a><img src=\"" +
                                encodeurl + "open_book.gif\" alt=\"" + item +
                                "\" alt=\"open_book.gif\" border=\"0\" class=\"imgFolderOpen\"> <span class='seltxt'>" +
                                item.getDisplayName() + "</span></li>");
                        } else {
                            buffer.append("<li><a href=\"" +
                                "JavaScript:treenode_onclick('" +
                                encoded_itemForm + "','" + expandCmd + "','" +
                                item.getId() + "'); " + "\"><img src=\"" +
                                encodeurl +
                                "minus.gif\" alt=\"Collapse\" border=\"0\" class=\"imgExpand\"></a><img src=\"" +
                                encodeurl + "open_book.gif\" alt=\"" + item +
                                "\" alt=\"open_book.gif\" border=\"0\" class=\"imgFolderOpen\"><a href=\"" +
                                "JavaScript:treenode_onclick('" +
                                encoded_itemForm + "','" + command + "','" +
                                item.getId() + "');\" " +
                                "\" class=\"linker\"><span class='txt'>" +
                                item.getDisplayName() + "</span></a></li>");
                        }

                        /*
                         * Traverse the node only when that node is Open
                         */
                        traverse(item);
                    } else {
                        if (item.getId().equals(sItem)) {
                            buffer.append("<li><a href=\"" +
                                "JavaScript:treenode_onclick('" +
                                encoded_itemForm + "','" + expandCmd + "','" +
                                item.getId() + "'); " + "\"><img src=\"" +
                                encodeurl +
                                "plus.gif\" alt=\"Expand\" border=\"0\" class=\"imgCollapse\"></a><img src=\"" +
                                encodeurl + "closed_book.gif\" alt=\"" + item +
                                "\" border=\"0\" class=\"imgFolderClose\"> <span class='seltxt'> " +
                                item.getDisplayName() + "</span></li>");
                        } else {
                            buffer.append("<li><a href=\"" +
                                "JavaScript:treenode_onclick('" +
                                encoded_itemForm + "','" + expandCmd + "','" +
                                item.getId() + "'); " + "\"><img src=\"" +
                                encodeurl +
                                "plus.gif\" alt=\"Expand\" border=\"0\" class=\"imgCollapse\"></a><img src=\"" +
                                encodeurl + "closed_book.gif\" alt=\"" + item +
                                "\" border=\"0\" class=\"imgFolderClose\"><a href=\"" +
                                "JavaScript:treenode_onclick('" +
                                encoded_itemForm + "','" + command + "','" +
                                item.getId() + "');\" " +
                                "\" class=\"linker\"> <span class='txt'> " +
                                item.getDisplayName() + "</span></a></li>");
                        }
                    }
                }
            } // end of while 

            buffer.append("</ul>");
        }
    }

    /**
     * @see com.ibm.ccd.ui.tags.BaseUITags#renderHTML
     */
    public String renderHTML(String key) {
        return "";
    }

    /**
     * @see com.ibm.ccd.ui.mediator.IRenderer#renderField()
     */
    public void renderField() {
    }

    /**
     * @see com.ibm.ccd.ui.mediator.IRenderer#setLog(org.apache.jetspeed.portlet.PortletLog)
     */
    public void setLog(PortletLog log) {
    }

    /**
     * @see com.ibm.ccd.ui.mediator.IRenderer#setPortletContext(org.apache.jetspeed.portlet.PortletContext)
     */
    public void setPortletContext(PortletContext portletContext) {
    }

    /**
     * @return
     */
    public PortletURI getExpand() {
        return expand;
    }

    /**
     * @return
     */
    public PortletURI getSelect() {
        return select;
    }

    /**
     * @param portletURI
     */
    public void setExpand(PortletURI portletURI) {
        expand = portletURI;
    }

    /**
     * @param portletURI
     */
    public void setSelect(PortletURI portletURI) {
        select = portletURI;
    }

    /**
     * @return
     */
    public Object getSelitem() {
        return selitem;
    }

    /**
     * @param string
     */
    public void setSelitem(Object string) {
        selitem = string;
    }

    /**
     * @return
     */
    public CatalogTree getCatalog() {
        return catalog;
    }

    /**
     * @param tree
     */
    public void setCatalog(CatalogTree tree) {
        catalog = tree;
    }
    /**
     * @return Returns the hideitem.
     */
    public String getHideitem() {
        return hideitem;
    }
    /**
     * @param hideitem The hideitem to set.
     */
    public void setHideitem(String hideitem) {
        this.hideitem = hideitem;
    }
    protected boolean isHideItem(){
        if ((hideitem != null) && (hideitem.equalsIgnoreCase("true") || hideitem.equalsIgnoreCase("yes"))) {
            return true;
        }
        return false;
    }
}
