
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/**
 * This class is the tag implementation for the Image Upload tag input.
 * This allows user to preview the image.
 * attributes
 * Tags inherited from Base tag
 * name
 * id
 * value
 * style
 * alt
 * enabled
 */
package com.ibm.ccd.ui.tags;

import java.io.IOException;

import org.apache.jetspeed.portlet.PortletResponse;

import com.ibm.ccd.ui.util.UIUtils;


public class UIUploadPreviewTag extends UITextAttachFileTag {
    String imageURI = null;
    String imageWidth = null;
    String imageHeight = null;

    /**
     * This method renders HTML field to response object for upload file and preview
     */
    protected void renderField() throws Exception {
        StringBuffer htmlCode = new StringBuffer("");

        try {
            if (isEnabled()) {
                htmlCode.append("<TD ALIGN =\"LEFT\" nowrap>");
                renderTextAttachTagHtml(htmlCode);
            } else {
                htmlCode.append("<TD ALIGN =\"LEFT\">");

                if ((value != null) && !("null".equalsIgnoreCase(value))) {
                    htmlCode.append(" " + value);
                }
            }

            if ((getImageURI() != null) && !(getImageURI().equals(""))) {
                htmlCode.append("&nbsp;<INPUT class=\"wpsButtonText\" ")
                        .append(" name=\"PREVIEW_BUTTON\"")
                        .append(" value=\"" +
                    UIUtils.getTextLabel(portletContext, locale,
                        "FILE_UPLOAD.VIEW.PREVIEW") + "\"")
                        .append(" type=\"BUTTON\" onClick=\"javascript:winopen('" +
                    ((PortletResponse) pageContext.getAttribute(
                        VAR_PORTLET_RESPONSE)).encodeURL(getImageURI()) +
                    "')\" ").append(" ALT=\"Preview\">");
            }

            htmlCode.append("</TD>");
            out.print(htmlCode.toString());
        } catch (IOException e) {
            log.error(UIUtils.getTextMessages(portletContext, locale,
                    "MESSAGE_CODE_57"));
            e.printStackTrace();
        }
    }

    /**
     * @return
     */
    public String getImageURI() {
        return imageURI;
    }

    /**
     * @param string
     */
    public void setImageURI(String string) {
        imageURI = string;
    }

    /**
     * @return
     */
    public String getImageHeight() {
        return imageHeight;
    }

    /**
     * @return
     */
    public String getImageWidth() {
        return imageWidth;
    }

    /**
     * @param string
     */
    public void setImageHeight(String string) {
        imageHeight = string;
    }

    /**
     * @param string
     */
    public void setImageWidth(String string) {
        imageWidth = string;
    }
}
