/*
 * Licensed Materials: Property of IBM
 * "Restricted Materials of IBM"
 * 5724-I68.
 * (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

/*
 * Created on Jul 15, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.ibm.ccd.ui.tags.element;

import java.io.IOException;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpSession;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.TagSupport;

import org.apache.jetspeed.portlet.PortletConfig;
import org.apache.jetspeed.portlet.PortletContext;
import org.apache.jetspeed.portlet.PortletRequest;
import org.apache.jetspeed.portlet.PortletURI;

import com.ibm.ccd.ui.context.IWPCUser;
import com.ibm.ccd.ui.context.WPCUser;
import com.ibm.ccd.ui.context.WPSContext;
import com.ibm.ccd.ui.dataobjects.attributes.Attribute;
import com.ibm.ccd.ui.dataobjects.attributes.AttributeTypes;
import com.ibm.ccd.ui.dataobjects.attributes.GroupAttribute;
import com.ibm.ccd.ui.dataobjects.items.CatalogItem;
import com.ibm.ccd.ui.mediator.WPCMediator;
import com.ibm.ccd.ui.tags.ITagConstants;
import com.ibm.ccd.ui.util.UIUtils;

/**
 * @author administrator
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class AttributeTag extends TagSupport {

	protected JspWriter out = null;

	protected Map flatAttrib = null;

	protected String attribname = null;

	protected Attribute attribute = null;

	protected GroupAttribute groupAttribute = null;

	protected PortletURI portletURI = null;

	protected AttributeCollectionTag attribCollTag = null;

	protected GroupAttributeTag groupAttribTag = null;

	protected HttpSession session = null;

	protected PortletRequest portletRequest = null;

	protected PortletConfig portletConfig = null;

	private Attribute[] attributes = null;

	private StringBuffer buffer = null;
	
	private String editable = null;
	// For Binary attachment 
	private String preview = "false";

	// For Date Element only 
	private String parentformname = null;

	public AttributeTag() {
		buffer = new StringBuffer();
	}

	protected void initilize() {
		try {
			attribCollTag =
				(AttributeCollectionTag) findAncestorWithClass(this,
					Class.forName(
						"com.ibm.ccd.ui.tags.element.AttributeCollectionTag"));

			if (attribCollTag != null) {
				flatAttrib = attribCollTag.getMap();
				portletURI = attribCollTag.getPortletURI();
			} else {
				throw new RuntimeException("Attribute Collection Map not set ");
			}
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}

		try {
			groupAttribTag =
				(GroupAttributeTag) findAncestorWithClass(this,
					Class.forName(
						"com.ibm.ccd.ui.tags.element.GroupAttributeTag"));

			if (groupAttribTag != null) {
				groupAttribute =
					(GroupAttribute) groupAttribTag.getGroupAttribute();
			}
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
	}

	/**
	 * @see javax.servlet.jsp.tagext.TagSupport#doStartTag()
	 */
	public int doStartTag() throws JspException {

		initilize();

		out = pageContext.getOut();

		portletRequest =
			(PortletRequest) pageContext.getAttribute(
				ITagConstants.VAR_PORTLET_REQUEST);

		portletConfig =
			(PortletConfig) pageContext.getAttribute(
				ITagConstants.VAR_PORTLET_CONFIG);

		session = pageContext.getSession();

		CatalogItem item = (CatalogItem) session.getAttribute("Item");

		String attributeName = getAttribname();
		String groupindex =
			(String) pageContext.getAttribute(IHTMLRenderer.GROUP_INDEX);
		String groupAppendPath =
			(String) pageContext.getAttribute(
				GroupAttributeTag.GROUP_APPEND_PATH);

		if (attributeName != null) {
			if (flatAttrib.get(attributeName) != null) {
				if (groupAttribute != null && groupindex != null) {

					try {
						attribute =
							item.getAttributeFromGroupPath(groupAppendPath);
					} catch (Exception e1) {
						e1.printStackTrace();
					}

					String parentPath =
						(String) pageContext.getAttribute(
							GroupAttributeTag.GROUP_APPEND_PATH);
					try {

						Attribute[] attribs =
							item.getAttributesFromGroupPath(
								parentPath.substring(1));

						for (int i = 0; i < attribs.length; i++) {
							if (attributeName.equals(attribs[i].getName())) {
								attribute = attribs[i];
								attribute.setParentPath(parentPath);
								break;
							}
							if (i == attribs.length) {
								System.out.println(
									"ATTRIBUTE NOT FOUND " + attributeName);
							}
						}
					} catch (Exception e) {
						e.printStackTrace();
						return SKIP_PAGE;
					}

				} else {
					attribute = (Attribute) flatAttrib.get(attributeName);
				}

				String hashName =
					((Attribute) flatAttrib.get(attributeName)).getHashName()
						+ "";
				attribute.setHashName(hashName);

				try {
					if (attribute != null) {
						/**
						 * Inserting code here to enable the Localization of
						 * values. An attribute may be localized, and if so,
						 * only its localized value should be displayed. get the
						 * locale, and the attribute matching that locale, and
						 * work with that attribute.
						 */
						Attribute localizedAttributeForRendering = attribute;
						
						if (attribute.isLocalized()) {
							WPSContext context =
								UIUtils.getWPSContext(
									portletRequest,
									portletConfig);
							String restrictedLocale =
								(String) context.getWpcUser().getProperty(
									IWPCUser.KEY_RESTRICTED_LANGUAGE);
								
							if (!(UIUtils.isEmpty(restrictedLocale))) {
								String name =
									attribute.getName()
										+ "/"
										+ restrictedLocale;
								Attribute localizedAttribute = null;
							
								for (int j = 0;
									j < attribute.getLocalizedValues().size();
									j++) {
							
									if (((Attribute) attribute
										.getLocalizedValues()
										.get(j))
										.getName()
										.equalsIgnoreCase(name)) {
										
										localizedAttribute =
											(Attribute) attribute
												.getLocalizedValues()
												.get(
												j);
									}
								}

								if (localizedAttribute != null) {
									localizedAttributeForRendering =
										localizedAttribute;
									/*
									 * For fix : WPC00024563 
									 */
									out.println(
											renderElement(localizedAttributeForRendering));

								}
							} else {
								return SKIP_BODY;
							}
						} else {
							out.println(
								renderElement(localizedAttributeForRendering));
						}

					} else
						return SKIP_BODY;
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
		return SKIP_BODY;
	}

	public String renderElement(Attribute attribute) {
		int attribType = attribute.getType();
		BaseElement baseElement = null;
		String outputHTML = "";

		switch (attribType) {
			case AttributeTypes.STRING :
				{
					baseElement = new TextElement(attribute, portletURI);

					break;
				}

			case AttributeTypes.PASSWORD :
				{
					baseElement = new PasswordElement(attribute, portletURI);

					break;
				}

			case AttributeTypes.URL :
				{
					baseElement = new URLElement(attribute, portletURI);

					break;
				}

			case AttributeTypes.LOOKUP_TABLE :
				{
					baseElement = new LookupElement(attribute, portletURI);

					break;
				}

			case AttributeTypes.RELATIONSHIP :
				{
					RelationElement relationElement = null;
					WPSContext context = null;
					WPCUser user = null;
					PortletRequest request = null;
					String[] catalogNames = null;
					HttpSession httpSession = null;
					request =
						(PortletRequest) pageContext.getAttribute(
							"portletRequest");

					//This should be used when Item catalog portlet is able to set
					// availabel catalogs in
					// httpSession from persisted beans and
					// BasePortlet.createWPSContext() reads from the bean

					/*
					 * context=(WPSContext)
					 * httpSession.getAttribute(WPSContext.KEY_WPS_CONTEXT_BEAN);
					 * if(context!=null){ user=context.getWpcUser(); if(user!=null){
					 * catalogNames=UIUtils.getAvailabelCatalogs(user); } }
					 */

					//temp work around solution :Get availabel catalogs from
					// portletContext set by Item catalog portlet
					PortletContext portletContext =
						((PortletConfig) pageContext
							.getAttribute("portletConfig"))
							.getContext();
					catalogNames =
						(String[]) portletContext.getAttribute(
							IWPCUser.KEY_AVAILABEL_CATALOGS);

					if ((catalogNames == null) || (catalogNames.length <= 0)) {
						catalogNames = new String[1];
						catalogNames[0] =
							WPCMediator.getInstance().getDefaultCatalog();
					}

					relationElement =
						new RelationElement(attribute, portletURI);
					relationElement.setCatalogNames(catalogNames);
					baseElement = relationElement;

					break;
				}

			case AttributeTypes.BINARY :
				{
					BinaryAttachElement binaryElement =
						new BinaryAttachElement(attribute, portletURI);
					binaryElement.setPreview(getPreview());
					baseElement = binaryElement;
					break;
				}

			case AttributeTypes.IMAGE :
				{
					ImageAttachElement imageElement = new ImageAttachElement(attribute, portletURI);
					imageElement.setPreview(getPreview());
					baseElement = imageElement;
					break;
				}

			case AttributeTypes.DATE :
				{
					DateElement dateElement = new DateElement(attribute, portletURI);
					dateElement.setParentformname(getParentformname());
					baseElement = dateElement; 
					break;
				}

			case AttributeTypes.NUMBER :
				{
					baseElement = new NumberElement(attribute, portletURI);

					break;
				}

			case AttributeTypes.INTEGER :
				{
					baseElement = new IntegerElement(attribute, portletURI);

					break;
				}

			case AttributeTypes.FLAG :
				{
					baseElement = new FlagElement(attribute, portletURI);

					break;
				}

			case AttributeTypes.STRING_ENUMERATION :
				{
					baseElement =
						new StringEnumerationElement(attribute, portletURI);
					break;
				}

			case AttributeTypes.NUMBER_ENUMERATION :
				{
					baseElement =
						new NumberEnumerationElement(attribute, portletURI);
					break;
				}

			case AttributeTypes.THUMB_NAIL_IMAGE :
				{
					ThumbNailImageElement thumbNailImageElement =
						new ThumbNailImageElement(attribute, portletURI);
					thumbNailImageElement.setPreview(getPreview());
					baseElement = thumbNailImageElement;

					break;
				}

			case AttributeTypes.THUMB_NAIL_IMAGE_URL :
				{
					baseElement =
						new ThumbNailImageURLElement(attribute, portletURI);
					break;
				}

			case AttributeTypes.IMAGE_URL :
				{
					baseElement = new ImageURLElement(attribute, portletURI);
					break;
				}

			case AttributeTypes.CURRENCY :
				{
					baseElement = new CurrencyElement(attribute, portletURI);
					break;
				}

			case AttributeTypes.SEQUENCE :
				{
					baseElement = new SequenceElement(attribute, portletURI);
					break;
				}

			case AttributeTypes.TIMEZONE :
				{
					baseElement = new TimezoneElement(attribute, portletURI);
					break;
				}
			case AttributeTypes.PERIOD :
				{
					baseElement = new PeriodElement(attribute, portletURI);
					break;
				}

			case AttributeTypes.GROUP :
				{
					GroupAttribute groupAttribute = (GroupAttribute) attribute;
					groupAttribute.setGroupIndex(-1);

					while (groupAttribute.hasNextGroup()) {
						pageContext.setAttribute(
							IHTMLRenderer.GROUP_INDEX,
							String.valueOf(groupAttribute.getGroupIndexPos()));

						String appendPath =
							groupAttribute.getParentPath()
								+ "_"
								+ groupAttribute.getHashName()
								+ "_"
								+ groupAttribute.getGroupIndexPos();

						groupAttribute.setGroupAppendPath(appendPath);
						groupAttribute.setPath(appendPath);

						GroupElement groupElement =
							new GroupElement(groupAttribute, portletURI);
						groupElement.setImageURI(attribCollTag.getImageURI());
						groupElement.setGroupID(
							String.valueOf(groupAttribute.getGroupIndexPos()));
						groupElement.setPageContext(pageContext);

						Attribute[] attributes = groupAttribute.nextGroup();
						buffer.append(groupElement.displayHeader());

						for (int i = 0; i < attributes.length; i++) {

							attributes[i].setParentPath(
								attributes[i].getAttributeParentPath());

							if (attributes[i].getType()
								!= AttributeTypes.GROUP) {
								buffer.append(renderElement(attributes[i]));
							} else {
								renderElement(attributes[i]);
							}
						}
						buffer.append(groupElement.displayFooter());
					}
					pageContext.removeAttribute(IHTMLRenderer.GROUP_INDEX);
					return buffer.toString();
				}

		}

		if (attribCollTag.getUpdateMode().equalsIgnoreCase("false")
			|| attribCollTag.getUpdateMode().equalsIgnoreCase("no")) {
			baseElement.setEditable(false);
		}else {
			if(editable != null && editable.equals("false")) {
				baseElement.setEditable(false);
				attribute.setEditable(false);
			}
		}

		baseElement.setImageURI(attribCollTag.getImageURI());
		baseElement.setGroupID(getGroupIndex());
		baseElement.setPageContext(pageContext);
		outputHTML = baseElement.renderElement();

		return outputHTML;
	}

	/**
	 * @return
	 */
	public String getAttribname() {
		return attribname;
	}

	/**
	 * @param string
	 */
	public void setAttribname(String string) {
		attribname = string;
	}

	/**
	 * @return
	 */
	public GroupAttribute getGroupAttribute() {
		if (groupAttribute == null) {
			try {
				throw new Exception(
					attribute.getName() + " is not nested under any Group");
			} catch (Exception e) {
			}
		}

		return groupAttribute;
	}

	public String getGroupIndex() {
		String groupindex =
			(String) pageContext.getAttribute(IHTMLRenderer.GROUP_INDEX);

		if (!UIUtils.isEmpty(groupindex) && (groupAttribute != null)) {
			return "_" + groupAttribute.getHashName() + "_" + groupindex + "_";
		} else {
			return "_";
		}
	}

	/**
	 *	check for localized attribute rendering 
	 * 
	 * @param attribute
	 * @param flag true checks for localized attribute rendering
	 * @return
	 */
	protected String renderElement(Attribute attribute, boolean flag) {

		/**
		 * Inserting code here to enable the Localization of
		 * values. An attribute may be localized, and if so,
		 * only its localized value should be displayed. get the
		 * locale, and the attribute matching that locale, and
		 * work with that attribute.
		 */
		Attribute localizedAttributeForRendering = attribute;

		if (attribute.isLocalized()) {
			WPSContext context =
				UIUtils.getWPSContext(portletRequest, portletConfig);
			String restrictedLocale =
				(String) context.getWpcUser().getProperty(
					IWPCUser.KEY_RESTRICTED_LANGUAGE);

			if (null != restrictedLocale) {
				String name = attribute.getName() + "/" + restrictedLocale;
				Attribute localizedAttribute = null;

				for (int j = 0;
					j < attribute.getLocalizedValues().size();
					j++) {
					if (((Attribute) attribute.getLocalizedValues().get(j))
						.getName()
						.equalsIgnoreCase(name)) {
						localizedAttribute =
							(Attribute) attribute.getLocalizedValues().get(j);
					}
				}
				if (localizedAttribute != null) {
					localizedAttributeForRendering = localizedAttribute;
				}
				return (renderElement(localizedAttributeForRendering));
			} else {
				List localizedValues = attribute.getLocalizedValues();
				for (Iterator iter = localizedValues.iterator();
					iter.hasNext();
					) {
					Attribute localeAttribute = (Attribute) iter.next();
					return (renderElement(localeAttribute));
				}
			}
		} else {
			return renderElement(attribute);
		}
		return "";

	}

	/**
	 * @return
	 */
	public String getEditable() {
		return editable;
	}

	/**
	 * @param string
	 */
	public void setEditable(String string) {
		editable = string;
	}
	/**
	 * @param preview The preview to set.
	 */
	public void setPreview(String preview) {
		this.preview = preview;
	}
	/**
	 * @return Returns the preview.
	 */
	public String getPreview() {
		return preview;
	}

	/**
	 * @return Returns the parentformname.
	 */
	public String getParentformname() {
		return parentformname;
	}
	/**
	 * @param parentformname The parentformname to set.
	 */
	public void setParentformname(String parentformname) {
		this.parentformname = parentformname;
	}
}
