
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Jul 20, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.ibm.ccd.ui.tags.element;

import java.util.HashMap;

import javax.servlet.jsp.PageContext;

import org.apache.jetspeed.portlet.PortletResponse;
import org.apache.jetspeed.portlet.PortletURI;

import com.ibm.ccd.ui.dataobjects.attributes.Attribute;
import com.ibm.ccd.ui.dataobjects.attributes.GroupAttribute;
import com.ibm.ccd.ui.util.UIUtils;


/**
 * @author administrator
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public abstract class BaseElement implements IHTMLRenderer {
    public int NO_SHOW_PLUS_MINUS = 0;
    public int SHOW_PLUS_MINUS = 1;
    public int SHOW_PLUS = 2;
    public int SHOW_MINUS = 3;
    protected Attribute attribute = null;
    protected HashMap html_prop_map = null;
    protected PortletURI portletURI = null;
    protected String imageURI = null;
    protected boolean isUpdateMode;
    private String groupID = null;
    private boolean editable;
    protected PageContext pageContext = null;
    private static boolean colorFlag = false;
    private static final String COLOR_WHITE="#FAFAFA";
	private static final String COLOR_GRAY="#EEEEEE";
	
	public boolean showLabel = true;
    
	
    public BaseElement(Attribute attribute, PortletURI portletURI) {
        html_prop_map = new HashMap();
        this.attribute = attribute;
        this.portletURI = portletURI;
        this.editable = attribute.isEditable();
    }

    public boolean isShowLabel() {
		return showLabel;
	}
    
	public void setShowLabel(boolean showLabel) {
		this.showLabel = showLabel;
	}
	
    public abstract String renderElement();

    /**
     * @return attribute
     */
    public Attribute getAttribute() {
        return attribute;
    }

    public void addHTMLProperty(String propName, String propValue) {
        if (propName != null) {
            html_prop_map.put(propName, propValue);
        }
    }

    public String getHTMLValue(String propName) {
        StringBuffer buffer = new StringBuffer();
        String hvalue = "";

        if (!UIUtils.isEmpty(propName) && html_prop_map.containsKey(propName)) {
            hvalue = (String) html_prop_map.get(propName);

            if (!UIUtils.isEmpty(hvalue)) {
                buffer.append(propName + HTML_OPEN_QUOTE).append(hvalue).append(HTML_CLOSE_QUOTE);
            }
        }

        return buffer.toString();
    }

    public int getDisplayState() {
        if (attribute.getMinimumOccurrence() == attribute.getMaximumOccurrence()) {
            return NO_SHOW_PLUS_MINUS;
        } else if ((attribute.getCurrOccurrence() == attribute.getMinimumOccurrence()) ||
                (attribute.getCurrOccurrence() == 1)) {
            return SHOW_PLUS;
        } else if (attribute.getCurrOccurrence() == attribute.getMaximumOccurrence()) {
            return SHOW_MINUS;
        } else {
            return SHOW_PLUS_MINUS;
        }
    }

	protected String displayOccurrenceNumber(long index) {
		return "<span class=\"autoNum\">&nbsp;"+(index+1)+"&nbsp;</span>&nbsp; ";
	}
	
    protected String displayPlusMinus(long index) {
        String imageURL = getImageURI();

        StringBuffer buffer = new StringBuffer();

        if (attribute.isMultiValued()) {
            buffer.append(HTML_SPACE + HTML_SPACE);

            PortletURI expURI = portletURI;
            PortletURI colURI = portletURI;
            expURI.addAction(ATTRIB_ADD_EVENT);

            String path = "";
            int pathIndex;

            if (attribute instanceof GroupAttribute) {
				path = ((GroupAttribute)attribute).getGroupAppendPath();
				//path = getAttributeID(String.valueOf(index));
                expURI.addParameter(ATTRIB_PARAM, path);
                attribute.setPath(path);
            } else {
				path = getAttributeID(String.valueOf(index));
                expURI.addParameter(ATTRIB_PARAM, path);
                attribute.setPath(path);
            }

            String exp = expURI.toString();

            colURI.addAction(ATTRIB_REMOVE_EVENT);

            if (attribute instanceof GroupAttribute) {
				path = ((GroupAttribute)attribute).getGroupAppendPath();
				//path = getAttributeID(String.valueOf(index));
                colURI.addParameter(ATTRIB_PARAM, path);
                attribute.setPath(path);
            } else {
				path = getAttributeID(String.valueOf(index));
                colURI.addParameter(ATTRIB_PARAM, path);
                attribute.setPath(path);
            }

            String col = colURI.toString();
            String path1 = path.substring(0,path.lastIndexOf('_'));

            switch (getDisplayState()) {
            //SHOW_PLUS_MINUS
            case 1:
                buffer.append(
                    "<span class=\"autoNum\">&nbsp;"+(index+1)+"&nbsp;</span> "+
                    "<a href=JavaScript:validateText('"+path1+"');submitForm(document.workCatalogForm,'" +
                    exp + "')"//+ exp
                     + " ><img src=\"" + imageURL +
					"plus.gif\" border='0' width=12 height=12 align=middle></a>").append(
					"&nbsp;<a href=JavaScript:validateText('"+path1+"');submitForm(document.workCatalogForm,'" +
                    col + "')><img src=\"" + imageURL +
					"minus.gif\" border='0' width=12 height=12 align=middle></a>");


                break;

            //SHOW_PLUS
            case 2:
                buffer.append(
					"<span class=\"autoNum\">&nbsp;"+(index+1)+"&nbsp;</span> "+
                    "<a href=JavaScript:validateText('"+path1+"');submitForm(document.workCatalogForm,'" +
                    exp + "')"//+ exp
                     + " ><img src=\"" + imageURL +
					"plus.gif\" border='0' width=12 height=12 align=middle></a>").append("&nbsp;<img src=\"" +
                    imageURL +
					"minus.gif\" style=\"display:none\" border='0' width=12 height=12 align=middle>");

                break;

            //SHOW_MINUS
            case 3:
                buffer.append(
					"<span class=\"autoNum\">&nbsp;"+(index+1)+"&nbsp;</span> "+
                    "<a href=JavaScript:submitForm(document.workCatalogForm,'" +
                    exp + "')"//+ exp
                     + " ><img src=\"" + imageURL +
					"plus.gif\" style=\"display:none\" border='0' width=12 height=12 align=middle></a>")
                      .append(
					"&nbsp;<a href=JavaScript:validateText('"+path1+"');submitForm(document.workCatalogForm,'" + 
					col + "')><img src=\"" +
					imageURL + "minus.gif\" border='0' width=12 height=12 align=middle></a>");


                break;
            }
        }

        return buffer.toString();
    }

    public String displayError(String error) {
    	PortletResponse portletResponse = (PortletResponse) pageContext.getAttribute("portletResponse");
        StringBuffer buffer = new StringBuffer();
        String displayBorderColor = "";
        if(!colorFlag) {
			displayBorderColor = COLOR_GRAY;
			colorFlag = true;         	
        }else {
        	displayBorderColor = COLOR_WHITE;
			colorFlag = false;
        }
       // 	buffer.append(
       //     "<tr align=\"CENTER\"><td valign=\"top\" align=\"RIGHT\" CLASS=\"wpsLabelText\" nowrap>");
        buffer.append(
            	
                "<tr align=\"LEFT\" bgcolor=\""+displayBorderColor+"\">" +
                "<td><img src=\""+getImageURI()+"spacer.gif\" width=\"1\" height=\"20\" style=\"display:block\">" +
                "</td>" +
                "<td valign=\"center\" align=\"LEFT\" CLASS=\"wpsLabelText\" nowrap>");
        	buffer.append("<IMG SRC=\"");
	        buffer.append(portletResponse.encodeURL("/images/fatal.gif"));
	        buffer.append("\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=0 title= \" ");
	        buffer.append(error);
	        buffer.append("\">");
	        
	        if (!attribute.isOptional()) {
	            buffer.append("<SPAN CLASS=\"wpcFormAsterisk\"> * </SPAN>");
	        }
	        String appendLocaleName = "";
			
	        if (!UIUtils.isEmpty(attribute.getLocaleName())){
	        	appendLocaleName = "<SPAN CLASS=\"smallText\"> (" + attribute.getLocaleName() + ")</SPAN>";
	        }
	        //buffer.append(getAttributePartialName(attribute.getName())).append(
	        buffer.append(attribute.getDisplayLabelName()).append(appendLocaleName).append(" &nbsp;&nbsp;</td>");

	        return buffer.toString();
    }
    
    public String displayLabel() {
        StringBuffer buffer = new StringBuffer();
        String displayBorderColor = "";
        if(!colorFlag) {
			displayBorderColor = COLOR_GRAY;
			colorFlag = true;         	
        }else {
        	displayBorderColor = COLOR_WHITE;
			colorFlag = false;
        }
        
        buffer.append(
        	
            "<tr align=\"LEFT\" bgcolor=\""+displayBorderColor+"\">" +
            "<td><img src=\""+getImageURI()+"spacer.gif\" width=\"1\" height=\"20\" style=\"display:block\">" +
            "</td>" +
            "<td valign=\"center\" align=\"LEFT\" CLASS=\"wpsLabelText\" nowrap>");

        if (!attribute.isOptional()) {
            buffer.append("<SPAN CLASS=\"wpcFormAsterisk\"> * </SPAN>");
        }
        String appendLocaleName = "";
		
        if (!UIUtils.isEmpty(attribute.getLocaleName())){
        	appendLocaleName = "<SPAN CLASS=\"smallText\"> (" + attribute.getLocaleName() + ")</SPAN>";
        }
        buffer.append(attribute.getDisplayLabelName()).append(appendLocaleName).append(" &nbsp;&nbsp;</td>");

        return buffer.toString();
    }

    public abstract String displayField(long id, Object value);

    /**
     * @return
     */
    public String getImageURI() {
        return imageURI;
    }

    /**
     * @param string
     */
    public void setImageURI(String string) {
        imageURI = string;
    }

    private String getAttributePartialName(String attribName) {
        if (attribName != null) {
            int lastIndex = attribName.lastIndexOf("/");

            if (lastIndex != -1) {
                return attribName.substring(lastIndex + 1);
            } else {
                return attribName;
            }
        } else {
            return "";
        }
    }

    /**
     * @return
     */
    public String getGroupID() {
        if (groupID == null) {
            return "";
        }

        return groupID;
    }

    /**
     * @param string
     */
    public void setGroupID(String string) {
        groupID = string;
    }

    public String getAttributeID(String index) {

		if (attribute.isMultiValued()) {
		  return attribute.getParentPath()+"_"+attribute.getHashName() + "_" + index;		
		} else {
		  return attribute.getParentPath()+"_"+attribute.getHashName() + "_" + "0";

        }
    }

    /**
     * @param attribute
     */
    public void setAttribute(Attribute attribute) {
        this.attribute = attribute;
    }

    /**
     * @return
     */
    public boolean isUpdateMode() {
        return isUpdateMode;
    }

    /**
     * @param b
     */
    public void setUpdateMode(boolean b) {
        isUpdateMode = b;
    }

    /**
     * @return
     */
    public boolean isEditable() {
        return editable;
    }

    /**
     * @param b
     */
    public void setEditable(boolean b) {
        editable = b;
    }

    /**
     * @return
     */
    public PageContext getPageContext() {
        return pageContext;
    }

    /**
     * @param context
     */
    public void setPageContext(PageContext context) {
        pageContext = context;
    }

}
