
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

package com.ibm.ccd.ui.tags.element;

import java.io.IOException;
import java.util.Iterator;
import java.util.List;

import javax.servlet.jsp.JspException;

import org.apache.jetspeed.portlet.PortletConfig;
import org.apache.jetspeed.portlet.PortletRequest;

import com.ibm.ccd.ui.context.IWPCUser;
import com.ibm.ccd.ui.context.WPSContext;
import com.ibm.ccd.ui.dataobjects.attributes.Attribute;
import com.ibm.ccd.ui.dataobjects.items.CatalogItem;
import com.ibm.ccd.ui.tags.ITagConstants;
import com.ibm.ccd.ui.util.UIUtils;

/**
 * @author Administrator
 * renders all attributes types which is categoryspecific 
 */
public class CategorySpecificAttributeTag extends AttributeTag {

	/**
	 * @see javax.servlet.jsp.tagext.TagSupport#doStartTag()
	 */
	public int doStartTag() throws JspException {
		initilize();

		out = pageContext.getOut();

		portletRequest =
			(PortletRequest) pageContext.getAttribute(
				ITagConstants.VAR_PORTLET_REQUEST);

		portletConfig =
			(PortletConfig) pageContext.getAttribute(
				ITagConstants.VAR_PORTLET_CONFIG);

		session = pageContext.getSession();

		CatalogItem item = (CatalogItem) session.getAttribute("Item");

		String attributeName = null;

		Attribute[] attributes = item.getAttributes();
		
		for (int i = 0; i < attributes.length; i++) {

			if (!attributes[i].isCategorySpecificAttribute())
				continue;

			attribute = attributes[i];
			
			try {
				out.println(renderElement(attribute,true));
			} catch (IOException e) {
				e.printStackTrace();
			}
			

		} //end of for statement
		
		return SKIP_BODY;
	}

}
