
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.tags.element;

import org.apache.jetspeed.portlet.PortletURI;

import com.ibm.ccd.ui.dataobjects.attributes.Attribute;
import com.ibm.ccd.ui.dataobjects.attributes.CurrencyAttribute;


public class CurrencyElement extends NumberElement {
    public CurrencyElement(Attribute attribute, PortletURI portletURI) {
        super(attribute, portletURI);
    }

    /**
     * @param attribute
     * @param index
     * @return
     */
    protected String getStringValue(Attribute attribute, int index) {
        CurrencyAttribute currencyAttribute = (CurrencyAttribute) attribute;

        if (currencyAttribute.getCurrentOccurrence() > 0) {
            if (currencyAttribute.isMultiValued()) {
                String[] values = currencyAttribute.getValues();
                index = (index < values.length) ? index : 0;

                return values[index] + "";
            } else {
                return currencyAttribute.getValue() + "";
            }
        } else {
            return currencyAttribute.getDefaultValue() + "";
        }
    }
}
