
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

package com.ibm.ccd.ui.tags.element;

import java.io.IOException;

import javax.servlet.jsp.JspException;

import org.apache.jetspeed.portlet.PortletConfig;
import org.apache.jetspeed.portlet.PortletContext;
import org.apache.jetspeed.portlet.PortletRequest;
import org.apache.jetspeed.portlet.PortletResponse;

import com.ibm.ccd.ui.dataobjects.attributes.Attribute;
import com.ibm.ccd.ui.dataobjects.attributes.AttributeTypes;
import com.ibm.ccd.ui.dataobjects.attributes.BinaryAttribute;
import com.ibm.ccd.ui.dataobjects.items.CatalogItem;
import com.ibm.ccd.ui.tags.ITagConstants;
import com.ibm.ccd.ui.util.UIUtils;

/**
 * @author Administrator
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ImagePreviewAttributeTag extends AttributeTag {

	private String uriPathWebImage = null;

	/**
	 * @see com.ibm.ccd.ui.tags.element.AttributeTag#doStartTag()
	 */
	public int doStartTag() throws JspException {

		initilize();
		
		out = pageContext.getOut();

		portletRequest =
			(PortletRequest) pageContext.getAttribute(
				ITagConstants.VAR_PORTLET_REQUEST);

		portletConfig =
			(PortletConfig) pageContext.getAttribute(
				ITagConstants.VAR_PORTLET_CONFIG);

		session = pageContext.getSession();

		CatalogItem item = (CatalogItem) session.getAttribute("Item");

		String attributeName = getAttribname();

		// Getting web image for displaying the icon.

		Attribute webImageIconAttr =
			(Attribute) item.getFlatAttributeMap().get(attributeName);

		if (webImageIconAttr != null && (webImageIconAttr.getType() == AttributeTypes.BINARY ||
				webImageIconAttr.getType() == AttributeTypes.IMAGE ||
				webImageIconAttr.getType() == AttributeTypes.THUMB_NAIL_IMAGE) ) {
			BinaryAttribute binaryImgAttWebImage =
				(BinaryAttribute) webImageIconAttr;
			
			uriPathWebImage =  binaryImgAttWebImage.getLocalPath();

			try {
				out.println(renderElement());
			} catch (IOException e) {
				e.printStackTrace();
			}
			
		}

		return SKIP_BODY;
	}

	public String renderElement() {
		StringBuffer buffer = new StringBuffer();
		buffer.append("<TD ALIGN=\"RIGHT\">");

		if (uriPathWebImage != null) {
			PortletResponse portletResponse = (PortletResponse) pageContext.getAttribute(
				"portletResponse");
							
			buffer.append(
				"<IMG SRC=\"" + portletResponse.encodeURL("/")+ uriPathWebImage + "\" style=\"width:70%;\"");
		} else {
			
			PortletContext portletContext = ((PortletConfig) pageContext.getAttribute(
					"portletConfig")).getContext();
								
			String value = UIUtils.getTextLabel(portletContext,pageContext.getRequest().getLocale(),"WORK_WITH_ITEM.WEBIMAGE_NOT_AVAILABLE");
			
			buffer.append(UIUtils.escapeForHTML(value));
		}

		buffer.append("</TD>");

		return buffer.toString();
	}

}
