
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.tags.element;

import org.apache.jetspeed.portlet.PortletURI;

import com.ibm.ccd.ui.dataobjects.attributes.Attribute;
import com.ibm.ccd.ui.dataobjects.attributes.IntegerAttribute;


public class IntegerElement extends TextElement {
    public IntegerElement(Attribute attribute, PortletURI portletURI) {
        super(attribute, portletURI);
    }

    /**
     * @param attribute
     * @param index
     * @return
     */
    protected String getStringValue(Attribute attribute, int index) {
        IntegerAttribute integerAttrib = (IntegerAttribute) attribute;

        if (integerAttrib.getCurrentOccurrence() > 0) {
            if (integerAttrib.isMultiValued()) {
                String[] values = integerAttrib.getValues();
                index = (index < values.length) ? index : 0;
                String path = getAttributeID(String.valueOf(index));
                if(integerAttrib.getValidationError(path) != null)
                	return values[index];
                else
                	return getLocalizedInteger(values[index] + "");
            } else {
            	String path = getAttributeID(String.valueOf(0));
                if(integerAttrib.getValidationError(path) != null)
                	return integerAttrib.getValue();
                else
                	return getLocalizedInteger(integerAttrib.getValue() + "");
            }
        } else {
            return getLocalizedInteger(integerAttrib.getDefaultValue() + "");
        }
    }
}
