
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Jul 26, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.ibm.ccd.ui.tags.element;

import org.apache.jetspeed.portlet.PortletConfig;
import org.apache.jetspeed.portlet.PortletContext;
import org.apache.jetspeed.portlet.PortletRequest;
import org.apache.jetspeed.portlet.PortletURI;

import com.ibm.ccd.ui.dataobjects.NVPair;
import com.ibm.ccd.ui.dataobjects.attributes.Attribute;
import com.ibm.ccd.ui.dataobjects.attributes.LookupTableAttribute;
import com.ibm.ccd.ui.tags.ITagConstants;
import com.ibm.ccd.ui.util.UIUtils;


/**
 * @author administrator
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class LookupElement extends BaseElement {
    private String LABEL_KEY_MENU_OPTION_SEARCH = "WORK_WITH_ITEM.VIEW.REL_ATTR_MENU_SEARCH";
	private String LABEL_KEY_NONE="DROPDOWN_VALUE_NONE";
    protected PortletContext portletContext = null;
    protected PortletRequest portletRequest = null;
    protected String value;
    protected String maxLength = "1000";
    protected String size = "20";
    protected String styleClass = "wpsEditField";

    //protected NVPair [] defaultValues=null;

    /**
     * @param attribute
     * @param portletURI
     */
    public LookupElement(Attribute attribute, PortletURI portletURI) {
        super(attribute, portletURI);
    }

    public String renderElement() {
        portletRequest = (PortletRequest) pageContext.getAttribute(ITagConstants.VAR_PORTLET_REQUEST);
        portletContext = ((PortletConfig) pageContext.getAttribute(ITagConstants.VAR_PORTLET_CONFIG)).getContext();

        StringBuffer buffer = new StringBuffer();

        if (attribute.isMultiValued()) {
            for (int i = 0; i < attribute.getCurrOccurrence(); i++) {
            	if(isShowLabel())
            		buffer.append(displayLabel());
                buffer.append(displayField(i, getStringValue(attribute, i)));
            }
        } else {
        	if(isShowLabel())
        		buffer.append(displayLabel());
            buffer.append(displayField(0, getStringValue(attribute, 0)));
        }

        return buffer.toString();
    }

    public String displayField(long id, Object pValue) {
        String path = null;
        String imageURL = getImageURI();
        StringBuffer buffer = new StringBuffer();
        String value = "";
        String menuName = null;
        String menuOptionSearch = null;
        NVPair[] defaultValues = null;
        String lookup_key = null;
        String lookup_value = null;
        String lookupTableName=null;
        boolean editable=false;
        if (pValue != null) {
            value = UIUtils.escapeForHTML(pValue.toString());
        }
		
		editable=isEditable();
        path =  getAttributeID(String.valueOf(id));
        attribute.setPath(path);

		String path1 = path.substring(0,path.lastIndexOf('_'));
		if(isShowLabel())
			addHTMLProperty(JS_EVENT_ONCHANGE,"validateText('"+path1+"')");
		else 
			addHTMLProperty(JS_EVENT_ONCHANGE,"validateText(\\'"+path1+"\\')"); 
        
        defaultValues = ((LookupTableAttribute) attribute).getLookupTable();
		lookupTableName=((LookupTableAttribute) attribute).getLookupTableName();
		//lookupTableName="Lookup Table 2";
        menuName = "menu" + path;

        //get localised values of menu options
        menuOptionSearch = getMenuOption(LABEL_KEY_MENU_OPTION_SEARCH);

        buffer.append("<td width=\"100%\" ALIGN=\"LEFT\">")
              .append(" <TABLE><TR>").append("<TD ALIGN=\"LEFT\">");

		if(attribute.isMultiValued() && !editable) {
			buffer.append(displayOccurrenceNumber(id));	
		}   
        if ((defaultValues != null) && (defaultValues.length > 0)) {
			defaultValues= addNoneOption(defaultValues);
            buffer.append("<SELECT NAME=\"" + path + "\" id = \"lookupComponent\" ");
            if(isShowLabel())
				  buffer.append(getHTMLValue(JS_EVENT_ONCHANGE));
            	if(!editable){
					buffer.append(" disabled=\"disabled\" ");
            	}
				buffer.append(" >");

            for (int i = 0; i < defaultValues.length; i++) {
                lookup_key = defaultValues[i].getName();
                lookup_value =(String) defaultValues[i].getValue();
                lookup_key = UIUtils.escapeForHTML(lookup_key);
                lookup_value = UIUtils.escapeForHTML(lookup_value);
                
                buffer.append("<OPTION VALUE=\"" + lookup_value + "\"");

                if (value.equals(lookup_value)) {
                    buffer.append(" SELECTED");
                }

                buffer.append(">");
                buffer.append(lookup_key);
                buffer.append("</OPTION>");
            }

            buffer.append("</SELECT>");
        } else {
            buffer.append("<INPUT TYPE=\"TEXT\" id = \"lookupComponent\" NAME=\"" + path + "\" VALUE=\"" + value + "\" " )
				  .append(getHTMLValue(JS_EVENT_ONCHANGE));
			if(!editable){
				buffer.append(" disabled=\"disabled\" ");
			}
            buffer.append(" />");
        }

        buffer.append("</TD><TD  ALIGN=\"LEFT\">")
              .append("<table ALIGN=\"LEFT\"><tr>")
              .append("<td> ");
             
        if(editable){
        	
        	if(isShowLabel()){
				buffer.append(" <a href=\"#\" onClick=\"openLookupTable('" + lookupTableName + "','" + path+  "');validateText('"+path1+"');\">");
        	}else{
        		buffer.append(" <a href=\"#\" onClick=\"openLookupTable(\\'" + lookupTableName + "\\',\\'" + path+  "\\'  );\">");
        	}
			buffer.append("<IMG SRC=\"" + imageURL + "Search.gif\" title=\""+menuOptionSearch +"\" border=\"0\"/></a>");
         }

			buffer.append("</td>")
			.append("</tr>")
			.append("</table>")
			
			.append("</TD><TD ALIGN=\"LEFT\">");

        if (attribute.isMultiValued() && editable) {
            buffer.append(displayPlusMinus(id));
        }

        buffer.append("</TD></TR></TABLE>").append("</TD></TR>");

        return buffer.toString();
    }

    /**
	 * @param defaultValues
	 * @return
	 */
	private NVPair[] addNoneOption(NVPair[] defaultValues) {
		int size=defaultValues.length+1;
		NVPair[] values= new NVPair [size];
		String labelNone=getMenuOption(LABEL_KEY_NONE);
		values[0]= new NVPair(labelNone,"");
		for(int i=0;i<defaultValues.length;i++){
			values[i+1]= new NVPair(defaultValues[i].getName(),defaultValues[i].getName());
		}
		return values;
	}

	protected String getStringValue(Attribute attribute, int index) {
        LookupTableAttribute lookupAttrib = (LookupTableAttribute) attribute;

        if (lookupAttrib.getCurrentOccurrence() > 0) {
            if (lookupAttrib.isMultiValued()) {
                String[] values = lookupAttrib.getValues();

                return values[index];
            } else {
                return lookupAttrib.getValue();
            }
        } else {
            return lookupAttrib.getDefaultValue();
        }
    }

    public String getMaxLength() {
        return maxLength;
    }

    /**
     * @return
     */
    public String getSize() {
        return size;
    }

    /**
     * @return
     */
    public String getStyleClass() {
        return styleClass;
    }

    /**
     * @return
     */
    public String getValue() {
        return value;
    }

    /**
     * @param string
     */
    public void setMaxLength(String string) {
        maxLength = string;
    }

    /**
     * @param string
     */
    public void setSize(String string) {
        size = string;
    }

    /**
     * @param string
     */
    public void setStyleClass(String string) {
        styleClass = string;
    }

    /**
     * @param string
     */
    public void setValue(String string) {
        value = string;
    }

    /**
             * @param LABEL_KEY_MENU_OPTION_SEARCH
             * @return
             */
    private String getMenuOption(String key) {
        String value = null;
        value = UIUtils.getTextLabel(portletContext, portletRequest, key);

        return value;
    }
}
