/*
 * Created on Jul 17, 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package com.ibm.ccd.ui.tags.element;

import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpSession;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.TagSupport;

import org.apache.jetspeed.portlet.PortletContext;
import org.apache.jetspeed.portlet.PortletRequest;
import org.apache.jetspeed.portlet.PortletResponse;
import org.apache.jetspeed.portlet.PortletSession;
import org.apache.jetspeed.portlet.PortletURI;

import com.ibm.ccd.ui.context.IWPCUser;
import com.ibm.ccd.ui.context.WPCUser;
import com.ibm.ccd.ui.context.WPSContext;
import com.ibm.ccd.ui.dataobjects.attributes.Attribute;
import com.ibm.ccd.ui.dataobjects.attributes.AttributeTypes;
import com.ibm.ccd.ui.mediator.WPCMediator;
import com.ibm.ccd.ui.portlets.massupdate.IMassUpdate;
import com.ibm.ccd.ui.portlets.massupdate.ItemAttribute;
import com.ibm.ccd.ui.portlets.massupdate.MassUpdateBean;
import com.ibm.ccd.ui.tags.ITagConstants;
import com.ibm.ccd.ui.util.UIUtils;
 
public class MassUpdateAttributeTag extends TagSupport {
	
	protected JspWriter out = null;
	
	protected PortletRequest portletRequest = null;
	protected PortletSession portletSession = null;
	protected PortletResponse portletResponse = null;
	
	protected MassUpdateBean bean = null;
	protected Iterator keySetIterator = null;
	
	private PortletURI portletURI = null;
	
	
	
	public int doStartTag() throws JspException {
		
		out = pageContext.getOut();
		
		StringBuffer htmlBuffer = new StringBuffer();
		
		portletRequest = (PortletRequest) pageContext.getAttribute(ITagConstants.VAR_PORTLET_REQUEST);
		portletResponse = (PortletResponse) pageContext.getAttribute(ITagConstants.VAR_PORTLET_RESPONSE);
		
		bean = (MassUpdateBean) portletRequest.getAttribute(IMassUpdate.KEY_ITEMSLIST);
		
		String mode = bean.getMode();
		List allAttrListDisp = bean.getItemAttributeList();
		
		Iterator attributeIterator =  allAttrListDisp.iterator();
		htmlBuffer.append("<SCRIPT>");
		htmlBuffer.append("itemSkeleton = {\"attributeList\": [");
		while(attributeIterator.hasNext()){
			
			ItemAttribute attributeSpec = (ItemAttribute) attributeIterator.next();
			if(attributeSpec.getIsDisplayable()){
				htmlBuffer.append("{\"name\":\""+UIUtils.replaceEmptyStr(UIUtils.replaceSlash(attributeSpec.getName()))+"\",");
				htmlBuffer.append("\"type\":\""+AttributeTypes.getString(attributeSpec.getAttribute().getType())+"\",");
				htmlBuffer.append("\"displayName\":\""+attributeSpec.getAttribute().getDisplayLabelName()+"\",");
				htmlBuffer.append("\"innerHTML\":'"+ renderElement(attributeSpec.getAttribute()) + "'},");
			}
		}
		htmlBuffer.substring(0,htmlBuffer.length()-1);
		htmlBuffer.append("]};");
		htmlBuffer.append("</SCRIPT>");
		
		try{
			out.print(htmlBuffer.toString());
		} catch(Exception e){
			
		}
		
		return SKIP_BODY;
	}
	
	public String renderElement(Attribute attribute) {
		int attribType = attribute.getType();
		BaseElement baseElement = null;
		String outputHTML = "";

		switch (attribType) {
			case AttributeTypes.STRING :
				{
					baseElement = new TextElement(attribute, portletURI);
					baseElement.addHTMLProperty(BaseElement.HTMLSIZE, "10");
					break;
				}

			case AttributeTypes.URL :
				{
					//baseElement = new URLElement(attribute, portletURI);
					baseElement = new URLElement(attribute, portletURI);
					baseElement.addHTMLProperty(BaseElement.HTMLSIZE, "10");
					break;
				}

			case AttributeTypes.LOOKUP_TABLE :
				{
					baseElement = new LookupElement(attribute, portletURI);
					baseElement.setImageURI(portletResponse.encodeURL("/images/"));
					break;
				}

			case AttributeTypes.RELATIONSHIP :
				{
					RelationElement relationElement = null;
					WPSContext context = null;
					WPCUser user = null;
					PortletRequest request = null;
					String[] catalogNames = null;
					HttpSession httpSession = null;
					request =
						(PortletRequest) pageContext.getAttribute(
							"portletRequest");

					//This should be used when Item catalog portlet is able to set
					// availabel catalogs in
					// httpSession from persisted beans and
					// BasePortlet.createWPSContext() reads from the bean

					/*
					 * context=(WPSContext)
					 * httpSession.getAttribute(WPSContext.KEY_WPS_CONTEXT_BEAN);
					 * if(context!=null){ user=context.getWpcUser(); if(user!=null){
					 * catalogNames=UIUtils.getAvailabelCatalogs(user); } }
					 */

					//temp work around solution :Get availabel catalogs from
					// portletContext set by Item catalog portlet
					PortletContext portletContext =
						((org.apache.jetspeed.portlet.PortletConfig) pageContext
							.getAttribute("portletConfig"))
							.getContext();
					catalogNames =
						(String[]) portletContext.getAttribute(
							IWPCUser.KEY_AVAILABEL_CATALOGS);

					if ((catalogNames == null) || (catalogNames.length <= 0)) {
						catalogNames = new String[1];
						catalogNames[0] =
							WPCMediator.getInstance().getDefaultCatalog();
					}

					relationElement =
						new RelationElement(attribute, portletURI);
					relationElement.setCatalogNames(catalogNames);
					baseElement = relationElement;
					baseElement.setImageURI(portletResponse.encodeURL("/images/"));

					break;
				} 

			case AttributeTypes.DATE :
				{
					baseElement = new TextElement(attribute, portletURI);
					baseElement.addHTMLProperty(BaseElement.HTMLSIZE, "10");

					break;
				} 
			case AttributeTypes.NUMBER :
				{
					baseElement = new NumberElement(attribute, portletURI);

					break;
				}

			case AttributeTypes.INTEGER :
				{
					baseElement = new IntegerElement(attribute, portletURI);

					break;
				}

			case AttributeTypes.FLAG :
				{
					baseElement = new FlagElement(attribute, portletURI);
					
					break;
				} 

			case AttributeTypes.STRING_ENUMERATION :
				{
					baseElement =
						new StringEnumerationElement(attribute, portletURI);
					break;
				}

			case AttributeTypes.NUMBER_ENUMERATION :
				{
					baseElement =
						new NumberEnumerationElement(attribute, portletURI);
					break;
				}

			case AttributeTypes.THUMB_NAIL_IMAGE_URL :
				{
					baseElement =
						new ThumbNailImageURLElement(attribute, portletURI);
					break;
				}

			case AttributeTypes.IMAGE_URL :
				{
					baseElement = new ImageURLElement(attribute, portletURI);
					break;
				}

			case AttributeTypes.CURRENCY :
				{
					baseElement = new CurrencyElement(attribute, portletURI);
					break;
				}

			case AttributeTypes.SEQUENCE :
				{
					baseElement = new SequenceElement(attribute, portletURI);
					break;
				}

			case AttributeTypes.TIMEZONE :
				{
					baseElement = new TimezoneElement(attribute, portletURI);
					break;
				}

			/*case AttributeTypes.GROUP :
				{
					GroupAttribute groupAttribute = (GroupAttribute) attribute;
					groupAttribute.setGroupIndex(-1);

					while (groupAttribute.hasNextGroup()) {
						pageContext.setAttribute(
							IHTMLRenderer.GROUP_INDEX,
							String.valueOf(groupAttribute.getGroupIndexPos()));

						String appendPath =
							groupAttribute.getParentPath()
								+ "_"
								+ groupAttribute.getHashName()
								+ "_"
								+ groupAttribute.getGroupIndexPos();

						groupAttribute.setGroupAppendPath(appendPath);
						groupAttribute.setPath(appendPath);

						GroupElement groupElement =
							new GroupElement(groupAttribute, portletURI);
						groupElement.setImageURI(attribCollTag.getImageURI());
						groupElement.setGroupID(
							String.valueOf(groupAttribute.getGroupIndexPos()));
						groupElement.setPageContext(pageContext);

						Attribute[] attributes = groupAttribute.nextGroup();
						buffer.append(groupElement.displayHeader());

						for (int i = 0; i < attributes.length; i++) {

							attributes[i].setParentPath(
								attributes[i].getAttributeParentPath());

							if (attributes[i].getType()
								!= AttributeTypes.GROUP) {
								buffer.append(renderElement(attributes[i]));
							} else {
								renderElement(attributes[i]);
							}
						}
						buffer.append(groupElement.displayFooter());
					}
					pageContext.removeAttribute(IHTMLRenderer.GROUP_INDEX);
					return buffer.toString();
				} */

		}

		/*if (attribCollTag.getUpdateMode().equalsIgnoreCase("false")
			|| attribCollTag.getUpdateMode().equalsIgnoreCase("no")) {
			baseElement.setEditable(false);
		}

		
		baseElement.setImageURI(attribCollTag.getImageURI()); */
		//baseElement.setGroupID(getGroupIndex());
		 
		//baseElement.setMassEditFlag(true);
		
		if(baseElement != null) {
		
			baseElement.setPageContext(pageContext);
			baseElement.setShowLabel(false);
			baseElement.addHTMLProperty(BaseElement.HTMLSIZE, "20");
			outputHTML = baseElement.renderElement();
		}

		return outputHTML;
	}
	
	

}
