
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

package com.ibm.ccd.ui.tags.element;

import java.io.IOException;

import javax.servlet.jsp.JspException;

import org.apache.jetspeed.portlet.PortletConfig;
import org.apache.jetspeed.portlet.PortletRequest;

import com.ibm.ccd.ui.dataobjects.attributes.Attribute;
import com.ibm.ccd.ui.dataobjects.items.CatalogItem;
import com.ibm.ccd.ui.tags.ITagConstants;

/**
 * @author Administrator
 *
 * NestedAttribute Tag can render both single attribute and group attribute.
 *  
 */
public class NestedAttributeTag extends AttributeTag {

	/**
	 * @see javax.servlet.jsp.tagext.TagSupport#doStartTag()
	 */
	public int doStartTag() throws JspException {
		initilize();

		out = pageContext.getOut();

		portletRequest =
			(PortletRequest) pageContext.getAttribute(
				ITagConstants.VAR_PORTLET_REQUEST);

		portletConfig =
			(PortletConfig) pageContext.getAttribute(
				ITagConstants.VAR_PORTLET_CONFIG);

		session = pageContext.getSession();

		CatalogItem item = (CatalogItem) session.getAttribute("Item");

		attribute = (Attribute) item.getFlatAttributeMap().get(getAttribname());

		try {
			out.println(renderElement(attribute,true));
		} catch (IOException e) {
			e.printStackTrace();
		}

		return SKIP_BODY;
	}

}
