
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.tags.element;

import org.apache.jetspeed.portlet.PortletURI;

import com.ibm.ccd.ui.dataobjects.attributes.Attribute;
import com.ibm.ccd.ui.dataobjects.attributes.NumberAttribute;


public class NumberElement extends TextElement {
    public NumberElement(Attribute attribute, PortletURI portletURI) {
        super(attribute, portletURI);
    }

    /**
     * @param attribute
     * @param index
     * @return
     */
    protected String getStringValue(Attribute attribute, int index) {
        NumberAttribute numberAttribute = (NumberAttribute) attribute;

        if (numberAttribute.getCurrentOccurrence() > 0) {
            if (numberAttribute.isMultiValued()) {
                String[] values = numberAttribute.getValues();
                index = (index < values.length) ? index : 0;
				return values[index] + "";
            } else {
				return numberAttribute.getValue() + "";
            }
        } else {
            return numberAttribute.getDefaultValue() + "";
        }
    }
	/**
	 * @param id
	 * @param value
	 * @return
	 */
	public String displayField(long id, Object value) {
	
		String newValue = replaceSpecialCharacters((String)value);
		value = newValue;
		StringBuffer buffer = new StringBuffer();
		String formattedNumber = null;
		String path = getAttributeID(String.valueOf(id));
		if(attribute.getValidationError(path) == null){
			formattedNumber = getLocalizedNumber(value+"");
		}else {
        	formattedNumber = (String)value;
		}
		addHTMLProperty(HTMLVALUE,formattedNumber) ;
		attribute.setPath(path);

		String path1 = path.substring(0,path.lastIndexOf('_'));
		addHTMLProperty(JS_EVENT_ONCHANGE,"validateText('"+path1+"')");   
		
		addHTMLProperty(
			HTMLID,path);
		addHTMLProperty(
			HTMLNAME,path);
		buffer.append(HTML_ATTRIBUTE_START);
		if (isEditable()) {
			buffer
				.append(HTML_SPACE)
				.append(HTML_TEXT)
				.append(getHTMLValue(HTMLID))
				.append(getHTMLValue(HTMLNAME))
				.append(getHTMLValue(HTMLVALUE))
				.append(getHTMLValue(HTMLSIZE))
				.append(getHTMLValue(HTMLSTYLECLASS));
				if(isShowLabel())
					buffer.append(getHTMLValue(JS_EVENT_ONCHANGE));				
				buffer.append(HTML_CLOSE_TAG);
			if (attribute.isMultiValued()) {
				if(isShowLabel())
					buffer.append(displayPlusMinus(id));
			}
		} else {
			if(attribute.isMultiValued()) {
				buffer.append(displayOccurrenceNumber(id));	
			}        	
			buffer.append(formattedNumber);
		}
		buffer.append(HTML_ATTRIBUTE_END);

		return buffer.toString();
	}
}
