
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.tags.element;

import org.apache.jetspeed.portlet.PortletURI;

import com.ibm.ccd.ui.dataobjects.attributes.Attribute;
import com.ibm.ccd.ui.dataobjects.attributes.SequenceAttribute;
import com.ibm.ccd.ui.util.UIUtils;


public class SequenceElement extends TextElement {
    public SequenceElement(Attribute attribute, PortletURI portletURI) {
        super(attribute, portletURI);
    }

    /**
     * @see com.ibm.ccd.wpc.tags.BaseElement#renderElement()
     */
    public String renderElement() {
        StringBuffer buffer = new StringBuffer();
        buffer.append(displayLabel());

        String value = ((SequenceAttribute) attribute).getValue();
        buffer.append(displayField(0, getStringValue(attribute, 0)));

        return buffer.toString();
    }

    /**
     * @param id
     * @param value
     * @return
     */
    public String displayField(long id, Object value) {
        StringBuffer buffer = new StringBuffer();

        buffer.append(HTML_ATTRIBUTE_START);
		buffer.append(UIUtils.escapeForHTML((String)value));

        if (attribute.isMultiValued()) {
            buffer.append(displayPlusMinus(id));
        }

        buffer.append(HTML_ATTRIBUTE_END);

        return buffer.toString();
    }
}
