
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

/*
 * Created on Jul 15, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.ibm.ccd.ui.tags.element;

import org.apache.jetspeed.portlet.PortletRequest;
import org.apache.jetspeed.portlet.PortletURI;

import com.ibm.ccd.ui.dataobjects.attributes.Attribute;
import com.ibm.ccd.ui.dataobjects.attributes.StringAttribute;
import com.ibm.ccd.ui.util.UIUtils;

/**
 * @author administrator
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class TextElement extends BaseElement {
	protected String value;
	protected String maxLength = "1000";
	protected String size = "50";
	protected String styleClass = "wpsEditField";

	public TextElement(Attribute attribute, PortletURI portletURI) {
		super(attribute, portletURI);

		addHTMLProperty(HTMLSIZE, size);
		addHTMLProperty(HTMLMAXLENGTH, attribute.getMaximumLength()+"");
		addHTMLProperty(HTMLVALUE, value);
		addHTMLProperty(HTMLSTYLECLASS, styleClass);
		
	}

	/**
	 * @see com.ibm.ccd.wpc.tags.BaseElement#renderElement()
	 */
	public String renderElement() {
		StringBuffer buffer = new StringBuffer();

		if (attribute.isMultiValued()) {
			for (int i = 0; i < attribute.getCurrOccurrence(); i++) {
				String path = getAttributeID(String.valueOf(i));
				String error = attribute.getValidationError(path);
				if(error != null){
					if(isShowLabel())
						buffer.append(displayError(error));
				}
				else{
					if(isShowLabel())
						buffer.append(displayLabel());
				}
				buffer.append(displayField(i, getStringValue(attribute, i)));
			}
		} else {
			String path = getAttributeID(String.valueOf(0));
			String error = attribute.getValidationError(path);
			if(error != null){
				if(isShowLabel())
				buffer.append(displayError(error));
			}
			else{
				if(isShowLabel())
					buffer.append(displayLabel());
			}
			buffer.append(displayField(0, getStringValue(attribute, 0)));
		}

		return buffer.toString();
	}

	/**
	 * @param id
	 * @param value
	 * @return
	 */
	public String displayField(long id, Object value) {
		String value1 = UIUtils.escapeForHTML((String)value);
		StringBuffer buffer = new StringBuffer();
		addHTMLProperty(HTMLVALUE, value1);
		String path = getAttributeID(String.valueOf(id));
		attribute.setPath(path);

		String path1 = path.substring(0,path.lastIndexOf('_'));
		addHTMLProperty(JS_EVENT_ONCHANGE,"validateText('"+path1+"')");   
		
		addHTMLProperty(
			HTMLID,path);
		addHTMLProperty(
			HTMLNAME,path);
		buffer.append(HTML_ATTRIBUTE_START);
		if (isEditable()) {
			buffer
				.append(HTML_SPACE)
				.append(HTML_TEXT)
				.append(getHTMLValue(HTMLID))
				.append(getHTMLValue(HTMLNAME))
				.append(getHTMLValue(HTMLVALUE))
				.append(getHTMLValue(HTMLSIZE))
				.append(getHTMLValue(HTMLSTYLECLASS))
				.append(getHTMLValue(HTMLMAXLENGTH));
				if(isShowLabel())
					buffer.append(getHTMLValue(JS_EVENT_ONCHANGE));
				buffer.append(HTML_CLOSE_TAG);
			if (attribute.isMultiValued()) {
				if(isShowLabel())
					buffer.append(displayPlusMinus(id));
			}
		} else {
			if(attribute.isMultiValued()) {
				buffer.append(displayOccurrenceNumber(id));	
			}
			buffer.append(value1);
			
		}
		buffer.append(HTML_ATTRIBUTE_END);

		return buffer.toString();
	}

	/**
	 * @param attribute
	 * @param index
	 * @return
	 */
	protected String getStringValue(Attribute attribute, int index) {
		StringAttribute stringAttrib = (StringAttribute) attribute;

		if (stringAttrib.getCurrentOccurrence() > 0) {
			if (stringAttrib.isMultiValued()) {
				String[] values = stringAttrib.getValues();

				if ((values != null) || (values.length > 0)) {
					return values[index];
				} else {
					return "";
				}
			} else {
				return (stringAttrib.getValue() != null)
					? stringAttrib.getValue()
					: "";
			}
		} else {
			return (stringAttrib.getDefaultValue() != null)
				? stringAttrib.getDefaultValue()
				: "";
		}
	}

	/**
	 * @return
	 */
	public String getMaxLength() {
		return maxLength;
	}

	/**
	 * @return
	 */
	public String getSize() {
		return size;
	}

	/**
	 * @return
	 */
	public String getValue() {
		return value;
	}

	/**
	 * @param string
	 */
	public void setMaxLength(String string) {
		maxLength = string;
	}

	/**
	 * @param string
	 */
	public void setSize(String string) {
		size = string;
	}

	/**
	 * @param string
	 */
	public void setValue(String string) {
		value = string;
	}
	/**
	 * @param value
	 * @return
	 */
	protected String getLocalizedNumber(String value) {
		//Hack for "null" value
		if(value != null){
			if(value.equals("null"))
				return "";
			
		}
		if(UIUtils.isEmpty(value)) return "";
		
		PortletRequest portletRequest = (PortletRequest) pageContext.getAttribute("portletRequest");
		return UIUtils.formatNumber(value,portletRequest.getLocale());

	}
	
	/**
	 * 
	 * @param value
	 * @return
	 */
	protected String getLocalizedInteger(String value) {
		//Hack for "null" value
		if(value != null){
			if(value.equals("null"))
				return "";
		}
		if(UIUtils.isEmpty(value)) return "";
		PortletRequest portletRequest = (PortletRequest) pageContext.getAttribute("portletRequest");
		return UIUtils.formatInteger(value,portletRequest.getLocale());
	}
	
	protected String replaceSpecialCharacters(String str){
		if(str == null)
			return str;
		if(str.equals("&nbsp;"))
			return "&amp;nbsp;";
		else if(str.equals("&gt;"))
			return "&amp;gt;";
		else if(str.equals("&lt;"))
			return "&amp;lt;";
			return str;
	}
}
