
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.tags.element;

import org.apache.jetspeed.portlet.PortletURI;

import com.ibm.ccd.ui.dataobjects.FileUploadResource;
import com.ibm.ccd.ui.dataobjects.attributes.Attribute;
import com.ibm.ccd.ui.dataobjects.attributes.ThumbnailImageAttribute;


public class ThumbNailImageElement extends ImageAttachElement {
    public ThumbNailImageElement(Attribute attribute, PortletURI portletURI) {
        super(attribute, portletURI);
    }

    /**
     * @param attribute
     * @param index
     * @return
     */
    protected String getStringValue(Attribute attribute, int index) {
        ThumbnailImageAttribute thumbImgAttrib = (ThumbnailImageAttribute) attribute;

        if (thumbImgAttrib.getCurrentOccurrence() > 0) {
            if (thumbImgAttrib.isMultiValued()) {
                FileUploadResource[] files = thumbImgAttrib.getValues();

                return (files[index].getName() != null)
                ? files[index].getName() : "";
            } else {
                return (thumbImgAttrib.getValue().getName() != null)
                ? thumbImgAttrib.getValue().getName() : "";
            }
        } else {
            //return thumbImgAttrib.getDefaultValue().getName();
            return "";
        }
    }
}
