
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.tags.element;

import java.net.URL;

import org.apache.jetspeed.portlet.PortletURI;

import com.ibm.ccd.ui.dataobjects.attributes.Attribute;
import com.ibm.ccd.ui.dataobjects.attributes.ThumbnailImageURLAttribute;


public class ThumbNailImageURLElement extends URLElement {
    public ThumbNailImageURLElement(Attribute attribute, PortletURI portletURI) {
        super(attribute, portletURI);
    }

    /**
     * @param attribute
     * @param index
     * @return
     */
    protected String getStringValue(Attribute attribute, int index) {
        ThumbnailImageURLAttribute thumbnailImageURLAttribute = (ThumbnailImageURLAttribute) attribute;

        if (thumbnailImageURLAttribute.getCurrentOccurrence() > 0) {
            if (thumbnailImageURLAttribute.isMultiValued()) {
                String[] values = thumbnailImageURLAttribute.getValues();

                return (values[index] != null) ? values[index].toString() : "";
            } else {
                return (thumbnailImageURLAttribute.getValue() != null)
                ? thumbnailImageURLAttribute.getValue().toString() : "";
            }
        } else {
            return "";
        }
    }
}
