
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.tags.element;

import java.net.URL;

import org.apache.jetspeed.portlet.PortletURI;

import com.ibm.ccd.ui.dataobjects.attributes.Attribute;
import com.ibm.ccd.ui.dataobjects.attributes.URLAttribute;


public class URLElement extends TextElement {
    public URLElement(Attribute attribute, PortletURI portletURI) {
        super(attribute, portletURI);
    }

    /**
     * @see com.ibm.ccd.wpc.tags.BaseElement#renderElement()
     */
    public String renderElement() {
        StringBuffer buffer = new StringBuffer();

        if (attribute.isMultiValued()) {
            for (int i = 0; i < attribute.getCurrOccurrence(); i++) {
            	String path = getAttributeID(String.valueOf(i));
            	String error = attribute.getValidationError(path);
				if(error != null){
					if(isShowLabel())
						buffer.append(displayError(error));
				}
				else{
					if(isShowLabel())
		                buffer.append(displayLabel());
				}
                buffer.append(displayField(i, getStringValue(attribute, i)));
            }
        } else {
        	String path = getAttributeID(String.valueOf(0));
        	String error = attribute.getValidationError(path);
			if(error != null){
				if(isShowLabel())
					buffer.append(displayError(error));
			}
			else{
				if(isShowLabel())
		            buffer.append(displayLabel());
			}
            buffer.append(displayField(0, getStringValue(attribute, 0)));
        }

        return buffer.toString();
    }

    /**
     * @param attribute
     * @param index
     * @return
     */
    protected String getStringValue(Attribute attribute, int index) {
        URLAttribute urlAttrib = (URLAttribute) attribute;

        if (urlAttrib.getCurrentOccurrence() > 0) {
            if (urlAttrib.isMultiValued()) {
                String[] url = urlAttrib.getValues();

                return (url[index] != null) ? url[index].toString() : "";
            } else {
                return (urlAttrib.getValue() != null)
                ? urlAttrib.getValue().toString() : "";
            }
        } else {
            return "";
        }
    }
}
