
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corpe, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/**
  *
  * This interface stores general constants in the application.
  */
package com.ibm.ccd.ui.util;



public interface IReference {
    /*
     * Session business function variable is stored in session.This stores
     * the business function of current screen.That will be prepended to the key
     * while fetching text from resource bundle.
     */
    public final static String SESSION_BUS_FUNCT = "SESSION_BUS_FUNC";

    /**
     * indicates image directory name created to storing the images on file system.
     *
     */
    public final static String WORKWITHITEM_IMAGEDIR = "wpcImagesDir";
    /**
     * indicates pdf directory name created to storing the images on file system.
     *
     */    
    public final static String ITEM_ATTACHMENTS_DIR = "wpcAttachmentsDir";

    /**
     * indicates Supplier attribute name used to skipping this particular attribute in
     *
     */
    public final static String SUPPLIER_ATTR_NAME = "Master Item Spec/Supplier_ID";

    /**
     * Framework Configuration parameters. These values are defined in the framework_configuration.xml file.
     */
    public final static String PRIMARY_CATALOG = "PRIMARY_CATALOG";
    public final static String AXIS_CLIENT_TIMEOUT_MILLISECONDS = "AXIS_CLIENT_TIMEOUT_MILLISECONDS";
    /*
     * This property acts as a switch for anbling and disabling the wpc portlets cache
     */
    public final static String CACHE_ENABLED = "GLOBAL_CACHE";
    
    /**
     * constant used as key to extract from HashMap.Mediator sets the items objects list fetched from WPC
     * in HashMap with following key.
     */
    public final static String MASSUPDATE_MAP_LIST_KEY = "ITEM_LISTKEY";

    /**
     * constant used as key to extract from HashMap.Mediator sets the data(unsuccessful item ids)
     * in HashMap with following key
     */
    public final static String MASSUPDATE_MAP_MESSAGE_KEY = "MESSAGE_KEY";

    /*
     * Session business function variable is stored in session.This stores
     * the Action of current screen for eg. ADD,EDIT..etc.It will prepend action to
     * make the key while fetching text from resource bundle.
     * For Eg. SESSION_BUS_FUNCT.ACTION.NAME
     * NAME = key
     */
    String SESSION_ACTION = "SESSION_ACTION";

    /*
     * Message key variable is stored in request scope for error messages.
     * This is stores the MessageMap object.
     */
    String MESSAGE_KEY = "MESSAGE_KEY";

    /**
     * Identifier for Resource Bundle Name Label Messages.
     */
    String BUNDLE_WPC_UI_LABELS = "com.ibm.ccd.ui.nls.labels.wpclabels";

    /**
     * Identifier for Resource Bundle Name for wpcPortlet for error Messages
     */
    String BUNDLE_WPC_UI_MESSAGES = "com.ibm.ccd.ui.nls.messages.wpcmessages";

    /**
     * Identifier for Resource Bundle Name js Messages.
     */
    String BUNDLE_WPC_UI_JSMESSAGES = "com.ibm.ccd.ui.nls.messages.js.wpcjsmessages";

    /**
     * Identifier for Transaction file location
     */
    String TRANSACTION_PATH = "transdb";

    /**
     * Identifier for Resource Bundle Name js Messages.
     */
    String TRANS_LOG_FILE = "transdb.properties";

    /*
     * Flag to enable the conditional compilation
     */
    boolean COND_CMPL = true;
    String KEY_CATALOG_NAME = "CATALOG_NAME";
    String KEY_ATTRIBUTE_NAME = "ATTR_NAME";
}
