
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Nov 29, 2004
 */
package com.ibm.ccd.ui.util;

import java.net.Authenticator;
import java.net.PasswordAuthentication;


/**
 * This class is used for Authenticating server with a login/password.
 *
 */
public class SimpleAuthenticator extends Authenticator {
    private String username;
    private String password;

    /**
     * Default Constructor
     */
    public SimpleAuthenticator() {
        super();
    }

    /**
     *Constructor with user name and password.
     * @param username
     * @param password
     */
    public SimpleAuthenticator(String username, String password) {
        this.username = username;
        this.password = password;
    }

    /**
     * This method consructs the  <code>PasswordAuthentication</code> and returns
     * the same.
     * @return PasswordAuthentication
     */
    protected PasswordAuthentication getPasswordAuthentication() {
        return new PasswordAuthentication(username, password.toCharArray());
    }
}
