
/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/*
 * Created on Nov 24, 2004
 */
package com.ibm.ccd.ui.util;

import java.util.Collection;
import java.util.Map;


/**
 * This is support class used for general purpose validations in the WPS UI framework
 */
public class ValidationUtil {
    /**
             * Checks if the input parameter is Null or Empty. If so, it returns
             * <code>true</code> else <code>false</code>.
             * The input parameter is set as an object. It first checks if the
             * object is null.
             * If it is not null,
             * <li>if the data type is a String, it checks if the value is empty.</li>
             * <li>if the data type is a Collection, it checks if its size is empty.</li>
             * <li>if the data type is a Map, it checks if its size is empty.</li>
             * @param dataValue the input value
             * @return the boolean value <code>true</code> or <code>false</code>
             */
    public static boolean isNullOrEmpty(Object dataValue) {
        boolean isNullAndEmpty = false;

        if (dataValue == null) {
            isNullAndEmpty = true;
        } else if (dataValue instanceof String &&
                ((String) dataValue).trim().equals("")) {
            isNullAndEmpty = true;
        } else if (dataValue instanceof Collection &&
                (((Collection) dataValue).size() == 0)) {
            isNullAndEmpty = true;
        } else if (dataValue instanceof Map && (((Map) dataValue).size() == 0)) {
            isNullAndEmpty = true;
        }

        return isNullAndEmpty;
    }
}
