-- Licensed Materials - Property of IBM
-- 5724-I68
--
--  Copyright IBM Corp. 2000, 2007 
--
-- US Government Users Restricted Rights - Use, duplication, or
-- disclosure restricted by GSA ADP Schedule Contract with IBM Corp.



update command options using c off;

-- ===================================================================
--
-- Table tpfm_pfm_performance
--

-- ===================================================================

drop table tpfm_pfm_performance;
create table tpfm_pfm_performance
( 
    pfm_index                     integer,
    pfm_nref                      integer,
    pfm_max                       integer,
    pfm_min                       integer,
    pfm_count                     integer,
    pfm_total                     integer
) 

in users index in indx;


drop synonym pfm;
create synonym pfm for tpfm_pfm_performance;

-- ===================================================================
--
-- Table tpfm_pfi_perf_index
--

-- ===================================================================

drop table tpfm_pfi_perf_index;
create table tpfm_pfi_perf_index
( 
    pfi_index                     integer,
    pfi_info                      varchar(100)
) 

in users index in indx;


drop synonym pfi;
create synonym pfi for tpfm_pfi_perf_index;

drop sequence qpfm_pfi_index restrict;
create sequence qpfm_pfi_index start with 1 increment by 200 nocache;

-- ===================================================================
--
-- Table tpfm_ppr_profile
--

-- ===================================================================

drop table tpfm_ppr_profile;
create table tpfm_ppr_profile
( 
    ppr_company_id                integer,
    ppr_profile_id                integer,
    ppr_index                     bigint,
    ppr_start_time                bigint,
    ppr_depth                     integer,
    ppr_name                      varchar(128),
    ppr_elapsed_time              integer,
    ppr_count_iterations          integer,
    ppr_avg_per_iteration         integer,
    ppr_min_per_iteration         integer,
    ppr_max_per_iteration         integer,
    ppr_date                      timestamp
) 

in users index in indx;


drop synonym ppr;
create synonym ppr for tpfm_ppr_profile;

-- ===================================================================
--
-- Table tpfm_ppi_profile_info
--

-- ===================================================================

drop table tpfm_ppi_profile_info;
create table tpfm_ppi_profile_info
( 
    ppi_company_id                integer,
    ppi_user_id                   integer,
    ppi_profile_id                integer,
    ppi_profile_name              varchar(128),
    ppi_start_time                bigint,
    ppi_date                      timestamp
) 

in users index in indx;


drop synonym ppi;
create synonym ppi for tpfm_ppi_profile_info;

drop sequence qpfm_ppi_profile_id restrict;
create sequence qpfm_ppi_profile_id start with 1 increment by 200 nocache;

-- ===================================================================
--
-- Table tpfm_psi_profile_schedule_info
--

-- ===================================================================

drop table tpfm_psi_profile_schedule_info;
create table tpfm_psi_profile_schedule_info
( 
    psi_company_id                integer,
    psi_profile_id                integer,
    psi_schedule_index            integer,
    psi_debug_log_path            varchar(256),
    psi_date                      timestamp
) 

in users index in indx;


drop synonym psi;
create synonym psi for tpfm_psi_profile_schedule_info;

-- ===================================================================
--
-- Table tpfm_psd_schedule_detail
--

-- ===================================================================

drop table tpfm_psd_schedule_detail;
create table tpfm_psd_schedule_detail
( 
    psd_company_id                integer,
    psd_schedule_index            integer,
    psd_percent_complete          integer,
    psd_elapsed_time              integer,
    psd_date                      timestamp
) 

in users index in indx;


drop synonym psd;
create synonym psd for tpfm_psd_schedule_detail;



commit;

update command options using c on;

terminate;