-- Licensed Materials - Property of IBM
-- 5724-I68
--
--  Copyright IBM Corp. 2000, 2007 
--
-- US Government Users Restricted Rights - Use, duplication, or
-- disclosure restricted by GSA ADP Schedule Contract with IBM Corp.



update command options using c off;

drop index icnt_sen_0;
create index icnt_sen_0 on tcnt_sen_selected_entry (
        sen_selection_id,
        sen_src_container_id,
        sen_company_id
)   ALLOW REVERSE SCANS;

drop index icnt_cnt_0;
create index icnt_cnt_0 on tcnt_cnt_container (
        cnt_company_id
)   ALLOW REVERSE SCANS;

drop index icnt_cnt_1;
create index icnt_cnt_1 on tcnt_cnt_container (
        cnt_id,
        cnt_name,
        cnt_company_id
)   ALLOW REVERSE SCANS;

drop index icnt_cnt_2;
create index icnt_cnt_2 on tcnt_cnt_container (
        cnt_name,
        cnt_company_id
)   ALLOW REVERSE SCANS;

drop index icnt_cna_0;
create index icnt_cna_0 on tcnt_cna_container_attributes (
        cna_container_id,
        cna_next_version_id,
        cna_version_id,
        cna_company_id
)   ALLOW REVERSE SCANS;

drop index icnt_cna_1;
create index icnt_cna_1 on tcnt_cna_container_attributes (
        cna_name,
        cna_value,
        cna_container_id,
        cna_next_version_id,
        cna_version_id,
        cna_company_id
)   ALLOW REVERSE SCANS;

drop index icnt_ent_0;
create index icnt_ent_0 on tcnt_ent_entry (
        ent_id,
        ent_next_version_id,
        ent_version_id,
        ent_primary_key,
        ent_container_id,
        ent_company_id
)   ALLOW REVERSE SCANS;

drop index icnt_ent_1;
create index icnt_ent_1 on tcnt_ent_entry (
        ent_primary_key,
        ent_container_id,
        ent_next_version_id,
        ent_version_id,
        ent_id,
        ent_company_id
)   ALLOW REVERSE SCANS;

drop index icnt_ent_2;
create index icnt_ent_2 on tcnt_ent_entry (
        ent_container_id,
        ent_next_version_id,
        ent_version_id,
        ent_id,
        ent_company_id
)   ALLOW REVERSE SCANS;

drop index icnt_eta_0;
create index icnt_eta_0 on tcnt_eta_entry_attributes (
        eta_entry_id,
        eta_next_version_id,
        eta_version_id,
        eta_container_id,
        eta_node_id
)   ALLOW REVERSE SCANS;

drop index icnt_eta_1;
create index icnt_eta_1 on tcnt_eta_entry_attributes (
        eta_node_id,
        eta_value_numeric,
        eta_next_version_id,
        eta_version_id,
        eta_container_id,
        eta_entry_id
)   ALLOW REVERSE SCANS;

drop index icnt_eta_2;
create index icnt_eta_2 on tcnt_eta_entry_attributes (
        eta_node_id,
        eta_value_string,
        eta_next_version_id,
        eta_version_id,
        eta_container_id,
        eta_entry_id
)   ALLOW REVERSE SCANS;

drop index icnt_esa_0;
create index icnt_esa_0 on tcnt_esa_entry_sys_attr (
        esa_entry_id,
        esa_next_version_id,
        esa_version_id,
        esa_company_id
)   ALLOW REVERSE SCANS;

drop index icnt_esa_1;
create index icnt_esa_1 on tcnt_esa_entry_sys_attr (
        esa_name,
        esa_value,
        esa_next_version_id,
        esa_version_id,
        esa_container_id
)   ALLOW REVERSE SCANS;

drop index icnt_esa_2;
create index icnt_esa_2 on tcnt_esa_entry_sys_attr (
        esa_container_id,
        esa_name,
        esa_next_version_id,
        esa_version_id
)   ALLOW REVERSE SCANS;

drop index icnt_esm_0;
create index icnt_esm_0 on tcnt_esm_entry_spec_map (
        esm_company_id
)   ALLOW REVERSE SCANS;

drop index icnt_esm_1;
create index icnt_esm_1 on tcnt_esm_entry_spec_map (
        esm_spec_id,
        esm_next_version_id,
        esm_version_id,
        esm_company_id
)   ALLOW REVERSE SCANS;

drop index icnt_esm_2;
create index icnt_esm_2 on tcnt_esm_entry_spec_map (
        esm_filter_container_id,
        esm_next_version_id,
        esm_version_id,
        esm_company_id,
        esm_spec_id
)   ALLOW REVERSE SCANS;

drop index icnt_esm_3;
create index icnt_esm_3 on tcnt_esm_entry_spec_map (
        esm_container_id,
        esm_next_version_id,
        esm_version_id,
        esm_filter_container_id,
        esm_company_id,
        esm_spec_id
)   ALLOW REVERSE SCANS;

drop index icnt_esm_4;
create index icnt_esm_4 on tcnt_esm_entry_spec_map (
        esm_entry_id,
        esm_next_version_id,
        esm_version_id,
        esm_filter_container_id,
        esm_company_id,
        esm_spec_id
)   ALLOW REVERSE SCANS;

drop index icnt_esm_5;
create index icnt_esm_5 on tcnt_esm_entry_spec_map (
        esm_entry_id,
        esm_version_id,
        esm_next_version_id,
        esm_company_id
)   ALLOW REVERSE SCANS;

drop index icnt_efp_0;
create index icnt_efp_0 on tcnt_efp_entry_full_paths (
        efp_entry_id,
        efp_next_version_id,
        efp_version_id,
        efp_company_id
)   ALLOW REVERSE SCANS;

drop index icnt_efp_1;
create index icnt_efp_1 on tcnt_efp_entry_full_paths (
        efp_full_path_type,
        efp_full_path,
        efp_next_version_id,
        efp_version_id,
        efp_container_id
)   ALLOW REVERSE SCANS;

drop index icnt_efp_2;
create index icnt_efp_2 on tcnt_efp_entry_full_paths (
        efp_container_id,
        efp_full_path_type,
        efp_next_version_id,
        efp_version_id
)   ALLOW REVERSE SCANS;

drop index icnt_ehi_0;
create index icnt_ehi_0 on tcnt_ehi_entry_hierarchy (
        ehi_child_id,
        ehi_next_version_id,
        ehi_version_id,
        ehi_company_id,
        ehi_container_id,
        ehi_parent_id
)   ALLOW REVERSE SCANS;

drop index icnt_ehi_1;
create index icnt_ehi_1 on tcnt_ehi_entry_hierarchy (
        ehi_parent_id,
        ehi_next_version_id,
        ehi_version_id,
        ehi_company_id,
        ehi_container_id,
        ehi_child_id
)   ALLOW REVERSE SCANS;

drop index icnt_eem_0;
create index icnt_eem_0 on tcnt_eem_entry_entry_map (
        eem_src_container_id,
        eem_dst_container_id,
        eem_next_version_id,
        eem_version_id,
        eem_company_id
)   ALLOW REVERSE SCANS;

drop index icnt_eem_1;
create index icnt_eem_1 on tcnt_eem_entry_entry_map (
        eem_dst_container_id,
        eem_src_container_id,
        eem_next_version_id,
        eem_version_id,
        eem_company_id
)   ALLOW REVERSE SCANS;

drop index icnt_eem_2;
create index icnt_eem_2 on tcnt_eem_entry_entry_map (
        eem_src_entry_id,
        eem_src_container_id,
        eem_map_type,
        eem_version_id,
        eem_company_id
)   ALLOW REVERSE SCANS;



commit;

update command options using c on;

terminate;