-- Licensed Materials - Property of IBM
-- 5724-I68
--
--  Copyright IBM Corp. 2000, 2007 
--
-- US Government Users Restricted Rights - Use, duplication, or
-- disclosure restricted by GSA ADP Schedule Contract with IBM Corp.



update command options using c off;

drop index ictg_sel_0;
create index ictg_sel_0 on tctg_sel_selection (
        sel_selection_id,
        sel_catalog_id,
        sel_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_sel_1;
create index ictg_sel_1 on tctg_sel_selection (
        sel_selection_name,
        sel_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_sel_2;
create index ictg_sel_2 on tctg_sel_selection (
        sel_catalog_id,
        sel_hidden_flag,
        sel_selection_type,
        sel_version_id,
        sel_selection_id,
        sel_selection_name,
        sel_cat_tree_id,
        sel_object_group_id
)   ALLOW REVERSE SCANS;

drop index ictg_dys_0;
create index ictg_dys_0 on tctg_dys_dynamic_selection (
        dys_selection_id,
        dys_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_sit_0;
create index ictg_sit_0 on tctg_sit_selected_item (
        sit_selection_id,
        sit_catalog_id,
        sit_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_sca_0;
create index ictg_sca_0 on tctg_sca_selected_category (
        sca_selection_id,
        sca_catalog_id,
        sca_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_dso_0;
create index ictg_dso_0 on tctg_dso_data_source (
        dso_id,
        dso_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_dso_1;
create index ictg_dso_1 on tctg_dso_data_source (
        dso_name,
        dso_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_dsd_0;
create index ictg_dsd_0 on tctg_dsd_data_source_details (
        dsd_datasource_id,
        dsd_name,
        dsd_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_fee_0;
create index ictg_fee_0 on tctg_fee_feed (
        fee_feed_id,
        fee_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_fee_1;
create index ictg_fee_1 on tctg_fee_feed (
        fee_ctg_id,
        fee_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_fee_2;
create index ictg_fee_2 on tctg_fee_feed (
        fee_ctr_id,
        fee_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_fee_3;
create index ictg_fee_3 on tctg_fee_feed (
        fee_data_source_id,
        fee_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_fee_4;
create index ictg_fee_4 on tctg_fee_feed (
        fee_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_ftf_0;
create index ictg_ftf_0 on tctg_ftf_fetched_files (
        ftf_feed_id,
        ftf_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_ftf_1;
create index ictg_ftf_1 on tctg_ftf_fetched_files (
        ftf_filename
)   ALLOW REVERSE SCANS;

drop index ictg_ftf_2;
create index ictg_ftf_2 on tctg_ftf_fetched_files (
        ftf_doc_store_path
)   ALLOW REVERSE SCANS;

drop index ictg_syn_0;
create index ictg_syn_0 on tctg_syn_syndication (
        syn_catalog_id,
        syn_version_id,
        syn_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_syn_1;
create index ictg_syn_1 on tctg_syn_syndication (
        syn_syndication_id,
        syn_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_syn_2;
create index ictg_syn_2 on tctg_syn_syndication (
        syn_cat_tree_id,
        syn_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_syn_3;
create index ictg_syn_3 on tctg_syn_syndication (
        syn_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_cce_0;
create index ictg_cce_0 on tctg_cce_ctlg_ctlg_export (
        cce_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_cce_1;
create index ictg_cce_1 on tctg_cce_ctlg_ctlg_export (
        cce_id,
        cce_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_cce_2;
create index ictg_cce_2 on tctg_cce_ctlg_ctlg_export (
        cce_name,
        cce_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_cce_3;
create index ictg_cce_3 on tctg_cce_ctlg_ctlg_export (
        cce_dest_catalog_id,
        cce_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_cce_4;
create index ictg_cce_4 on tctg_cce_ctlg_ctlg_export (
        cce_src_catalog_id,
        cce_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_fi2_0;
create index ictg_fi2_0 on tctg_fi2_file (
        fi2_file_id,
        fi2_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_fi2_1;
create index ictg_fi2_1 on tctg_fi2_file (
        fi2_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_fia_0;
create index ictg_fia_0 on tctg_fia_file_attribute (
        fia_file_id,
        fia_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_ctg_0;
create index ictg_ctg_0 on tctg_ctg_catalog (
        ctg_company_id,
        ctg_id,
        ctg_name
)   ALLOW REVERSE SCANS;

drop index ictg_ctg_1;
create index ictg_ctg_1 on tctg_ctg_catalog (
        ctg_id,
        ctg_name,
        ctg_object_group_id,
        ctg_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_ctg_2;
create index ictg_ctg_2 on tctg_ctg_catalog (
        ctg_name,
        ctg_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_ctg_3;
create index ictg_ctg_3 on tctg_ctg_catalog (
        ctg_company_id,
        ctg_type,
        ctg_id,
        ctg_name
)   ALLOW REVERSE SCANS;

drop index ictg_caa_0;
create index ictg_caa_0 on tctg_caa_catalog_attributes (
        caa_catalog_id,
        caa_next_version_id,
        caa_version_id,
        caa_company_id,
        caa_name,
        caa_value
)   ALLOW REVERSE SCANS;

drop index ictg_caa_1;
create index ictg_caa_1 on tctg_caa_catalog_attributes (
        caa_name,
        caa_value,
        caa_catalog_id,
        caa_next_version_id,
        caa_version_id,
        caa_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_ver_0;
create index ictg_ver_0 on tctg_ver_version (
        ver_company_id,
        ver_id
)   ALLOW REVERSE SCANS;

drop index ictg_ver_1;
create index ictg_ver_1 on tctg_ver_version (
        ver_id,
        ver_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_ver_2;
create index ictg_ver_2 on tctg_ver_version (
        ver_object_id,
        ver_object_type,
        ver_company_id,
        ver_id
)   ALLOW REVERSE SCANS;

drop index ictg_ver_3;
create index ictg_ver_3 on tctg_ver_version (
        ver_object_type,
        ver_object_id,
        ver_company_id,
        ver_id
)   ALLOW REVERSE SCANS;

drop index ictg_itm_0;
create index ictg_itm_0 on tctg_itm_item (
        itm_primary_key,
        itm_container_id,
        itm_next_version_id,
        itm_version_id,
        itm_id,
        itm_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_itm_1;
create index ictg_itm_1 on tctg_itm_item (
        itm_container_id,
        itm_next_version_id,
        itm_version_id,
        itm_id,
        itm_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_itd_0;
create index ictg_itd_0 on tctg_itd_item_detail (
        itd_item_id,
        itd_next_version_id,
        itd_version_id
)   ALLOW REVERSE SCANS;

drop index ictg_ita_0;
create index ictg_ita_0 on tctg_ita_item_attributes (
        ita_item_id,
        ita_next_version_id,
        ita_version_id,
        ita_catalog_id,
        ita_node_id,
        ita_occurrence_id
)   ALLOW REVERSE SCANS;

drop index ictg_ita_1;
create index ictg_ita_1 on tctg_ita_item_attributes (
        ita_node_id,
        ita_value_numeric,
        ita_next_version_id,
        ita_version_id,
        ita_catalog_id,
        ita_occurrence_id,
        ita_item_id
)   ALLOW REVERSE SCANS;

drop index ictg_ita_2;
create index ictg_ita_2 on tctg_ita_item_attributes (
        ita_node_id,
        ita_value_string,
        ita_next_version_id,
        ita_version_id,
        ita_catalog_id,
        ita_occurrence_id,
        ita_item_id
)   ALLOW REVERSE SCANS;

drop index ictg_ita_3;
create index ictg_ita_3 on tctg_ita_item_attributes (
        ita_node_id,
        ita_value_string_ignorecase,
        ita_next_version_id,
        ita_version_id,
        ita_catalog_id,
        ita_occurrence_id,
        ita_item_id
)   ALLOW REVERSE SCANS;

drop index ictg_ctr_0;
create index ictg_ctr_0 on tctg_ctr_category_tree (
        ctr_id,
        ctr_name,
        ctr_object_group_id
)   ALLOW REVERSE SCANS;

drop index ictg_ctr_1;
create index ictg_ctr_1 on tctg_ctr_category_tree (
        ctr_company_id,
        ctr_id,
        ctr_name
)   ALLOW REVERSE SCANS;

drop index ictg_ctr_2;
create index ictg_ctr_2 on tctg_ctr_category_tree (
        ctr_name,
        ctr_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_ctr_3;
create index ictg_ctr_3 on tctg_ctr_category_tree (
        ctr_company_id,
        ctr_type,
        ctr_id,
        ctr_name
)   ALLOW REVERSE SCANS;

drop index ictg_cta_0;
create index ictg_cta_0 on tctg_cta_categ_tree_attribute (
        cta_cat_tree_id,
        cta_next_version_id,
        cta_version_id,
        cta_company_id,
        cta_name,
        cta_value
)   ALLOW REVERSE SCANS;

drop index ictg_cta_1;
create index ictg_cta_1 on tctg_cta_categ_tree_attribute (
        cta_name,
        cta_cat_tree_id,
        cta_next_version_id,
        cta_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_cat_0;
create index ictg_cat_0 on tctg_cat_category (
        cat_container_id,
        cat_next_version_id,
        cat_version_id,
        cat_primary_key,
        cat_id
)   ALLOW REVERSE SCANS;

drop index ictg_cat_1;
create index ictg_cat_1 on tctg_cat_category (
        cat_primary_key,
        cat_next_version_id,
        cat_version_id,
        cat_container_id,
        cat_id
)   ALLOW REVERSE SCANS;

drop index ictg_cat_2;
create index ictg_cat_2 on tctg_cat_category (
        cat_container_id,
        cat_last_modified,
        cat_id
)   ALLOW REVERSE SCANS;

drop index ictg_cad_0;
create index ictg_cad_0 on tctg_cad_category_detail (
        cad_category_id,
        cad_next_version_id,
        cad_version_id,
        cad_container_id,
        cad_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_cad_1;
create index ictg_cad_1 on tctg_cad_category_detail (
        cad_container_id,
        cad_next_version_id,
        cad_version_id,
        cad_category_id,
        cad_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_cab_0;
create index ictg_cab_0 on tctg_cab_category_attributes (
        cab_category_id,
        cab_next_version_id,
        cab_version_id,
        cab_cat_tree_id,
        cab_node_id,
        cab_occurrence_id
)   ALLOW REVERSE SCANS;

drop index ictg_cab_1;
create index ictg_cab_1 on tctg_cab_category_attributes (
        cab_node_id,
        cab_occurrence_id,
        cab_value_string,
        cab_next_version_id,
        cab_version_id,
        cab_cat_tree_id,
        cab_category_id
)   ALLOW REVERSE SCANS;

drop index ictg_cab_2;
create index ictg_cab_2 on tctg_cab_category_attributes (
        cab_node_id,
        cab_occurrence_id,
        cab_value_numeric,
        cab_next_version_id,
        cab_version_id,
        cab_cat_tree_id,
        cab_category_id
)   ALLOW REVERSE SCANS;

drop index ictg_cab_3;
create index ictg_cab_3 on tctg_cab_category_attributes (
        cab_node_id,
        cab_occurrence_id,
        cab_value_string_ignorecase,
        cab_next_version_id,
        cab_version_id,
        cab_cat_tree_id,
        cab_category_id
)   ALLOW REVERSE SCANS;

drop index ictg_csm_0;
create index ictg_csm_0 on tctg_csm_category_spec_map (
        csm_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_csm_1;
create index ictg_csm_1 on tctg_csm_category_spec_map (
        csm_spec_id,
        csm_next_version_id,
        csm_version_id,
        csm_company_id,
        csm_cat_tree_id,
        csm_filter_catalog_id
)   ALLOW REVERSE SCANS;

drop index ictg_csm_2;
create index ictg_csm_2 on tctg_csm_category_spec_map (
        csm_filter_catalog_id,
        csm_next_version_id,
        csm_version_id,
        csm_company_id,
        csm_spec_id
)   ALLOW REVERSE SCANS;

drop index ictg_csm_3;
create index ictg_csm_3 on tctg_csm_category_spec_map (
        csm_cat_tree_id,
        csm_next_version_id,
        csm_version_id,
        csm_filter_catalog_id,
        csm_company_id,
        csm_spec_id
)   ALLOW REVERSE SCANS;

drop index ictg_csm_4;
create index ictg_csm_4 on tctg_csm_category_spec_map (
        csm_category_id,
        csm_next_version_id,
        csm_version_id,
        csm_filter_catalog_id,
        csm_company_id,
        csm_spec_id
)   ALLOW REVERSE SCANS;

drop index ictg_csm_5;
create index ictg_csm_5 on tctg_csm_category_spec_map (
        csm_category_id,
        csm_version_id,
        csm_next_version_id,
        csm_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_csa_0;
create index ictg_csa_0 on tctg_csa_cat_sys_attr (
        csa_category_id,
        csa_next_version_id,
        csa_version_id,
        csa_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_csa_1;
create index ictg_csa_1 on tctg_csa_cat_sys_attr (
        csa_name,
        csa_value,
        csa_next_version_id,
        csa_version_id,
        csa_cat_tree_id,
        csa_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_csa_2;
create index ictg_csa_2 on tctg_csa_cat_sys_attr (
        csa_cat_tree_id,
        csa_name,
        csa_next_version_id,
        csa_version_id
)   ALLOW REVERSE SCANS;

drop index ictg_cfp_0;
create index ictg_cfp_0 on tctg_cfp_cat_full_paths (
        cfp_category_id,
        cfp_next_version_id,
        cfp_version_id,
        cfp_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_cfp_1;
create index ictg_cfp_1 on tctg_cfp_cat_full_paths (
        cfp_cat_tree_id,
        cfp_full_path_type,
        cfp_next_version_id,
        cfp_version_id
)   ALLOW REVERSE SCANS;

drop index ictg_chi_0;
create index ictg_chi_0 on tctg_chi_category_hierarchy (
        chi_child_id,
        chi_next_version_id,
        chi_version_id,
        chi_company_id,
        chi_cat_tree_id,
        chi_parent_id
)   ALLOW REVERSE SCANS;

drop index ictg_chi_1;
create index ictg_chi_1 on tctg_chi_category_hierarchy (
        chi_parent_id,
        chi_next_version_id,
        chi_version_id,
        chi_company_id,
        chi_cat_tree_id,
        chi_child_id
)   ALLOW REVERSE SCANS;

drop index ictg_ccm_0;
create index ictg_ccm_0 on tctg_ccm_category_category_map (
        ccm_src_cat_tree_id,
        ccm_dst_cat_tree_id,
        ccm_next_version_id,
        ccm_version_id,
        ccm_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_ccm_1;
create index ictg_ccm_1 on tctg_ccm_category_category_map (
        ccm_dst_cat_tree_id,
        ccm_src_cat_tree_id,
        ccm_next_version_id,
        ccm_version_id,
        ccm_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_icm_0;
create index ictg_icm_0 on tctg_icm_item_category_map (
        icm_item_id,
        icm_category_id,
        icm_next_version_id,
        icm_version_id,
        icm_cat_tree_id,
        icm_catalog_id
)   ALLOW REVERSE SCANS;

drop index ictg_icm_1;
create index ictg_icm_1 on tctg_icm_item_category_map (
        icm_category_id,
        icm_next_version_id,
        icm_version_id,
        icm_cat_tree_id,
        icm_catalog_id,
        icm_item_id
)   ALLOW REVERSE SCANS;

drop index ictg_icm_2;
create index ictg_icm_2 on tctg_icm_item_category_map (
        icm_catalog_id,
        icm_next_version_id,
        icm_version_id,
        icm_cat_tree_id,
        icm_category_id,
        icm_item_id
)   ALLOW REVERSE SCANS;

drop index ictg_spc_0;
create index ictg_spc_0 on tctg_spc_specification (
        spc_id,
        spc_company_id,
        spc_name
)   ALLOW REVERSE SCANS;

drop index ictg_spc_1;
create index ictg_spc_1 on tctg_spc_specification (
        spc_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_spc_2;
create index ictg_spc_2 on tctg_spc_specification (
        spc_name,
        spc_company_id,
        spc_id
)   ALLOW REVERSE SCANS;

drop index ictg_spa_0;
create index ictg_spa_0 on tctg_spa_spec_attributes (
        spa_spec_id,
        spa_next_version_id,
        spa_version_id,
        spa_name
)   ALLOW REVERSE SCANS;

drop index ictg_spa_1;
create index ictg_spa_1 on tctg_spa_spec_attributes (
        spa_spec_id,
        spa_name,
        spa_value,
        spa_next_version_id
)   ALLOW REVERSE SCANS;

drop index ictg_spa_2;
create index ictg_spa_2 on tctg_spa_spec_attributes (
        spa_name,
        spa_value,
        spa_next_version_id,
        spa_company_id,
        spa_spec_id
)   ALLOW REVERSE SCANS;

drop index ictg_nod_0;
create index ictg_nod_0 on tctg_nod_node (
        nod_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_nod_1;
create index ictg_nod_1 on tctg_nod_node (
        nod_spec_id,
        nod_next_version_id,
        nod_version_id,
        nod_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_nod_2;
create index ictg_nod_2 on tctg_nod_node (
        nod_name,
        nod_spec_id,
        nod_next_version_id,
        nod_version_id,
        nod_company_id,
        nod_id
)   ALLOW REVERSE SCANS;

drop index ictg_noa_0;
create index ictg_noa_0 on tctg_noa_node_attributes (
        noa_node_id,
        noa_next_version_id,
        noa_version_id,
        noa_company_id,
        noa_spec_id,
        noa_order
)   ALLOW REVERSE SCANS;

drop index ictg_noa_1;
create index ictg_noa_1 on tctg_noa_node_attributes (
        noa_spec_id,
        noa_node_id,
        noa_next_version_id,
        noa_version_id,
        noa_name,
        noa_order
)   ALLOW REVERSE SCANS;

drop index ictg_noa_2;
create index ictg_noa_2 on tctg_noa_node_attributes (
        noa_name,
        noa_next_version_id,
        noa_version_id,
        noa_company_id,
        noa_value
)   ALLOW REVERSE SCANS;

drop index ictg_noa_3;
create index ictg_noa_3 on tctg_noa_node_attributes (
        noa_node_id,
        noa_next_version_id,
        noa_name,
        noa_value
)   ALLOW REVERSE SCANS;

drop index ictg_noa_4;
create index ictg_noa_4 on tctg_noa_node_attributes (
        noa_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_noh_0;
create index ictg_noh_0 on tctg_noh_node_hierarchy (
        noh_child_node_id,
        noh_next_version_id,
        noh_version_id,
        noh_spec_id,
        noh_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_noh_1;
create index ictg_noh_1 on tctg_noh_node_hierarchy (
        noh_parent_node_id,
        noh_next_version_id,
        noh_version_id,
        noh_spec_id,
        noh_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_noh_2;
create index ictg_noh_2 on tctg_noh_node_hierarchy (
        noh_child_node_id,
        noh_parent_node_id,
        noh_next_version_id,
        noh_version_id,
        noh_spec_id,
        noh_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_nom_0;
create index ictg_nom_0 on tctg_nom_node_mapping (
        nom_sub_spec_id,
        nom_sub_spec_node_id,
        nom_master_spec_id,
        nom_master_spec_node_id
)   ALLOW REVERSE SCANS;

drop index ictg_nom_1;
create index ictg_nom_1 on tctg_nom_node_mapping (
        nom_sub_spec_node_id,
        nom_master_spec_node_id,
        nom_next_version_id
)   ALLOW REVERSE SCANS;

drop index ictg_obm_0;
create index ictg_obm_0 on tctg_obm_object_map (
        obm_id,
        obm_type,
        obm_version_id,
        obm_next_version_id,
        obm_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_obm_1;
create index ictg_obm_1 on tctg_obm_object_map (
        obm_name,
        obm_type,
        obm_version_id,
        obm_next_version_id,
        obm_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_obm_2;
create index ictg_obm_2 on tctg_obm_object_map (
        obm_type,
        obm_src_object_id,
        obm_dst_object_id,
        obm_version_id,
        obm_next_version_id,
        obm_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_omd_0;
create index ictg_omd_0 on tctg_omd_object_map_detail (
        omd_object_map_id,
        omd_next_version_id,
        omd_version_id,
        omd_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_oms_0;
create index ictg_oms_0 on tctg_oms_object_map_scripts (
        oms_object_map_id,
        oms_next_version_id,
        oms_version_id,
        oms_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_ctm_0;
create index ictg_ctm_0 on tctg_ctm_categorization_map (
        ctm_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_ctm_1;
create index ictg_ctm_1 on tctg_ctm_categorization_map (
        ctm_categmap_id,
        ctm_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_cmd_0;
create index ictg_cmd_0 on tctg_cmd_categmap_detail (
        cmd_categmap_id,
        cmd_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_cmd_1;
create index ictg_cmd_1 on tctg_cmd_categmap_detail (
        cmd_detail_id,
        cmd_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_cmc_0;
create index ictg_cmc_0 on tctg_cmc_categmap_categories (
        cmc_detail_id,
        cmc_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_cmc_1;
create index ictg_cmc_1 on tctg_cmc_categmap_categories (
        cmc_category_id,
        cmc_detail_id,
        cmc_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_cgm_0;
create index ictg_cgm_0 on tctg_cgm_catalog_catalog_map (
        cgm_src_ctg_id,
        cgm_src_node_id,
        cgm_next_version_id,
        cgm_version_id,
        cgm_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_cgm_1;
create index ictg_cgm_1 on tctg_cgm_catalog_catalog_map (
        cgm_dst_ctg_id,
        cgm_dst_node_id,
        cgm_next_version_id,
        cgm_version_id,
        cgm_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_seq_0;
create index ictg_seq_0 on tctg_seq_sequence (
        seq_name,
        seq_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_epr_0;
create index ictg_epr_0 on tctg_epr_entry_processor_run (
        epr_user_id,
        epr_type,
        epr_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_epr_1;
create index ictg_epr_1 on tctg_epr_entry_processor_run (
        epr_run_id
)   ALLOW REVERSE SCANS;

drop index ictg_rul_0;
create index ictg_rul_0 on tctg_rul_inheritance_rule (
        rul_src_ctg_id,
        rul_src_ctr_id,
        rul_next_version_id,
        rul_version_id,
        rul_id
)   ALLOW REVERSE SCANS;

drop index ictg_rul_1;
create index ictg_rul_1 on tctg_rul_inheritance_rule (
        rul_id,
        rul_next_version_id,
        rul_version_id,
        rul_src_ctg_id,
        rul_src_ctr_id,
        rul_name
)   ALLOW REVERSE SCANS;

drop index ictg_rul_2;
create index ictg_rul_2 on tctg_rul_inheritance_rule (
        rul_company_id,
        rul_next_version_id,
        rul_version_id,
        rul_collab_id,
        rul_src_ctg_id,
        rul_src_ctr_id,
        rul_name,
        rul_id
)   ALLOW REVERSE SCANS;

drop index ictg_rul_3;
create index ictg_rul_3 on tctg_rul_inheritance_rule (
        rul_company_id,
        rul_next_version_id,
        rul_version_id,
        rul_collab_id,
        rul_name,
        rul_id
)   ALLOW REVERSE SCANS;

drop index ictg_rgm_0;
create index ictg_rgm_0 on tctg_rgm_rul_group_map (
        rgm_rule_id,
        rgm_next_version_id,
        rgm_version_id,
        rgm_attr_group_id
)   ALLOW REVERSE SCANS;

drop index ictg_rgm_1;
create index ictg_rgm_1 on tctg_rgm_rul_group_map (
        rgm_attr_group_id,
        rgm_next_version_id,
        rgm_version_id,
        rgm_rule_id
)   ALLOW REVERSE SCANS;

drop index ictg_tmt_0;
create index ictg_tmt_0 on tctg_tmt_test_multi_row (
        tmt_node_id,
        tmt_next_version_id,
        tmt_version_id,
        tmt_catalog_id,
        tmt_item_id
)   ALLOW REVERSE SCANS;

drop index ictg_tmt_1;
create index ictg_tmt_1 on tctg_tmt_test_multi_row (
        tmt_item_id,
        tmt_catalog_id,
        tmt_next_version_id,
        tmt_version_id,
        tmt_node_id
)   ALLOW REVERSE SCANS;

drop index ictg_etp_0;
create index ictg_etp_0 on tctg_etp_entry_tabbed_pane (
        etp_container_type,
        etp_container_id
)   ALLOW REVERSE SCANS;

drop index ictg_etp_1;
create index ictg_etp_1 on tctg_etp_entry_tabbed_pane (
        etp_tab_id
)   ALLOW REVERSE SCANS;

drop index ictg_etp_2;
create index ictg_etp_2 on tctg_etp_entry_tabbed_pane (
        etp_ctg_view_id,
        etp_ctg_sub_view_id,
        etp_tab_id,
        etp_tab_name
)   ALLOW REVERSE SCANS;

drop index ictg_tpa_0;
create index ictg_tpa_0 on tctg_tpa_tabbed_pane_attr (
        tpa_tab_id,
        tpa_attr_group_id
)   ALLOW REVERSE SCANS;

drop index ictg_tpa_1;
create index ictg_tpa_1 on tctg_tpa_tabbed_pane_attr (
        tpa_tab_id,
        tpa_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_ord_0;
create index ictg_ord_0 on tctg_ord_ordering (
        ord_id,
        ord_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_ord_1;
create index ictg_ord_1 on tctg_ord_ordering (
        ord_catalog_id,
        ord_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_ord_2;
create index ictg_ord_2 on tctg_ord_ordering (
        ord_cat_tree_id,
        ord_catalog_id,
        ord_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_odd_0;
create index ictg_odd_0 on tctg_odd_ord_detail (
        odd_catalog_id,
        odd_next_version_id,
        odd_version_id,
        odd_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_odd_1;
create index ictg_odd_1 on tctg_odd_ord_detail (
        odd_ord_id,
        odd_next_version_id,
        odd_version_id,
        odd_parent_id,
        odd_type,
        odd_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_odd_2;
create index ictg_odd_2 on tctg_odd_ord_detail (
        odd_parent_id,
        odd_next_version_id,
        odd_version_id,
        odd_ord_id,
        odd_type,
        odd_company_id,
        odd_child_id
)   ALLOW REVERSE SCANS;

drop index ictg_odd_3;
create index ictg_odd_3 on tctg_odd_ord_detail (
        odd_cat_tree_id,
        odd_catalog_id,
        odd_next_version_id,
        odd_version_id,
        odd_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_atg_0;
create index ictg_atg_0 on tctg_atg_attr_group (
        atg_id,
        atg_name
)   ALLOW REVERSE SCANS;

drop index ictg_atg_1;
create index ictg_atg_1 on tctg_atg_attr_group (
        atg_name,
        atg_company_id,
        atg_id
)   ALLOW REVERSE SCANS;

drop index ictg_atg_2;
create index ictg_atg_2 on tctg_atg_attr_group (
        atg_company_id,
        atg_type,
        atg_id
)   ALLOW REVERSE SCANS;

drop index ictg_agn_0;
create index ictg_agn_0 on tctg_agn_attr_group_node (
        agn_attr_group_id,
        agn_next_version_id,
        agn_version_id,
        agn_spec_id,
        agn_node_id
)   ALLOW REVERSE SCANS;

drop index ictg_agn_1;
create index ictg_agn_1 on tctg_agn_attr_group_node (
        agn_node_id,
        agn_next_version_id,
        agn_version_id,
        agn_attr_group_id
)   ALLOW REVERSE SCANS;

drop index ictg_agn_2;
create index ictg_agn_2 on tctg_agn_attr_group_node (
        agn_spec_id,
        agn_next_version_id,
        agn_version_id,
        agn_attr_group_id
)   ALLOW REVERSE SCANS;

drop index ictg_agl_0;
create index ictg_agl_0 on tctg_agl_attr_group_locale (
        agl_attr_group_id,
        agl_next_version_id,
        agl_version_id,
        agl_locale
)   ALLOW REVERSE SCANS;

drop index ictg_agd_0;
create index ictg_agd_0 on tctg_agd_attr_group_dyn_node (
        agd_attr_group_id,
        agd_spec_id,
        agd_node_id,
        agd_next_version_id,
        agd_version_id
)   ALLOW REVERSE SCANS;

drop index ictg_sim_0;
create index ictg_sim_0 on tctg_sim_status_image_map (
        sim_object_container_id,
        sim_object_type,
        sim_status,
        sim_company_id,
        sim_image_url
)   ALLOW REVERSE SCANS;

drop index ictg_rec_0;
create index ictg_rec_0 on tctg_rec_relation_container (
        rec_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_rec_1;
create index ictg_rec_1 on tctg_rec_relation_container (
        rec_ctg_id
)   ALLOW REVERSE SCANS;

drop index ictg_rea_0;
create index ictg_rea_0 on tctg_rea_relation_attributes (
        rea_relation_id,
        rea_next_version_id,
        rea_version_id,
        rea_company_id,
        rea_name,
        rea_value
)   ALLOW REVERSE SCANS;

drop index ictg_rea_1;
create index ictg_rea_1 on tctg_rea_relation_attributes (
        rea_name,
        rea_value,
        rea_relation_id,
        rea_next_version_id,
        rea_version_id,
        rea_company_id
)   ALLOW REVERSE SCANS;

drop index ictg_esr_0;
create index ictg_esr_0 on tctg_esr_entry_search_result (
        esr_entry_id,
        esr_sel_id,
        esr_ctg_id
)   ALLOW REVERSE SCANS;



commit;

update command options using c on;

terminate;