-- Licensed Materials - Property of IBM
-- 5724-I68
--
--  Copyright IBM Corp. 2000, 2007 
--
-- US Government Users Restricted Rights - Use, duplication, or
-- disclosure restricted by GSA ADP Schedule Contract with IBM Corp.



update command options using c off;

drop index iwfl_std_0;
create index iwfl_std_0 on twfl_std_step_def (
        std_id,
        std_type
)   ALLOW REVERSE SCANS;

drop index iwfl_std_1;
create index iwfl_std_1 on twfl_std_step_def (
        std_wfl_id,
        std_cmp_id
)   ALLOW REVERSE SCANS;

drop index iwfl_stp_0;
create index iwfl_stp_0 on twfl_stp_step_performer (
        stp_step_id,
        stp_cmp_id
)   ALLOW REVERSE SCANS;

drop index iwfl_ste_0;
create index iwfl_ste_0 on twfl_ste_step_exit_value (
        ste_step_id,
        ste_cmp_id
)   ALLOW REVERSE SCANS;

drop index iwfl_stg_0;
create index iwfl_stg_0 on twfl_stg_step_attr_group (
        stg_step_id,
        stg_cmp_id
)   ALLOW REVERSE SCANS;

drop index iwfl_wfd_0;
create index iwfl_wfd_0 on twfl_wfd_workflow_def (
        wfd_id,
        wfd_name,
        wfd_cmp_id
)   ALLOW REVERSE SCANS;

drop index iwfl_wfg_0;
create index iwfl_wfg_0 on twfl_wfg_workflow_graph (
        wfg_wfl_id,
        wfg_cmp_id
)   ALLOW REVERSE SCANS;

drop index iwfl_wfg_1;
create index iwfl_wfg_1 on twfl_wfg_workflow_graph (
        wfg_src_step_id,
        wfg_exit_value,
        wfg_cmp_id
)   ALLOW REVERSE SCANS;

drop index iwfl_wfg_2;
create index iwfl_wfg_2 on twfl_wfg_workflow_graph (
        wfg_dst_step_id,
        wfg_cmp_id
)   ALLOW REVERSE SCANS;

drop index iwfl_spt_0;
create index iwfl_spt_0 on twfl_spt_step_path (
        spt_id,
        spt_leaf_step_id,
        spt_leaf_step_path
)   ALLOW REVERSE SCANS;

drop index iwfl_spt_1;
create index iwfl_spt_1 on twfl_spt_step_path (
        spt_leaf_step_path
)   ALLOW REVERSE SCANS;

drop index iwfl_spt_2;
create index iwfl_spt_2 on twfl_spt_step_path (
        spt_leaf_wfl_id
)   ALLOW REVERSE SCANS;

drop index iwfl_spt_3;
create index iwfl_spt_3 on twfl_spt_step_path (
        spt_root_wfl_id,
        spt_leaf_step_text_path
)   ALLOW REVERSE SCANS;

drop index iwfl_spt_4;
create index iwfl_spt_4 on twfl_spt_step_path (
        spt_id,
        spt_root_wfl_id
)   ALLOW REVERSE SCANS;

drop index iwfl_coa_0;
create index iwfl_coa_0 on twfl_coa_collaboration_area (
        coa_name,
        coa_cmp_id
)   ALLOW REVERSE SCANS;

drop index iwfl_coa_1;
create index iwfl_coa_1 on twfl_coa_collaboration_area (
        coa_container_type,
        coa_src_container_id,
        coa_cmp_id
)   ALLOW REVERSE SCANS;

drop index iwfl_coa_2;
create index iwfl_coa_2 on twfl_coa_collaboration_area (
        coa_container_type,
        coa_dst_container_id,
        coa_cmp_id
)   ALLOW REVERSE SCANS;

drop index iwfl_coa_3;
create index iwfl_coa_3 on twfl_coa_collaboration_area (
        coa_id,
        coa_wfl_id
)   ALLOW REVERSE SCANS;

drop index iwfl_cae_0;
create index iwfl_cae_0 on twfl_cae_coll_area_entry (
        cae_ca_id,
        cae_step_path_id,
        cae_entry_id,
        cae_cmp_id
)   ALLOW REVERSE SCANS;

drop index iwfl_cae_1;
create index iwfl_cae_1 on twfl_cae_coll_area_entry (
        cae_lock_id,
        cae_entry_id,
        cae_step_path_id,
        cae_ca_id,
        cae_cmp_id
)   ALLOW REVERSE SCANS;

drop index iwfl_csj_0;
create index iwfl_csj_0 on twfl_csj_coll_area_step_job (
        csj_cmp_id,
        csj_schedule_id
)   ALLOW REVERSE SCANS;

drop index iwfl_ceh_0;
create index iwfl_ceh_0 on twfl_ceh_coll_entry_history (
        ceh_entry_key,
        ceh_ca_name
)   ALLOW REVERSE SCANS;

drop index iwfl_ceh_1;
create index iwfl_ceh_1 on twfl_ceh_coll_entry_history (
        ceh_date,
        ceh_ca_name
)   ALLOW REVERSE SCANS;

drop index iwfl_cel_0;
create index iwfl_cel_0 on twfl_cel_coll_entry_lock (
        cel_container_id,
        cel_container_type,
        cel_user_id,
        cel_cmp_id
)   ALLOW REVERSE SCANS;

drop index iwfl_wfe_0;
create index iwfl_wfe_0 on twfl_wfe_workflow_event (
        wfe_event_status,
        wfe_id
)   ALLOW REVERSE SCANS;

drop index iwfl_wee_0;
create index iwfl_wee_0 on twfl_wee_workflow_event_entry (
        wee_event_id,
        wee_entry_id,
        wee_event_entry_status
)   ALLOW REVERSE SCANS;



commit;

update command options using c on;

terminate;